/* number.c generated by valac 0.56.3, the Vala compiler
 * generated from number.vala, do not modify */

/*
 * Copyright (C) 1987-2008 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/*  This maths library is based on the MP multi-precision floating-point
 *  arithmetic package originally written in FORTRAN by Richard Brent,
 *  Computer Centre, Australian National University in the 1970's.
 *
 *  It has been converted from FORTRAN into C using the freely available
 *  f2c translator, available via netlib on research.att.com.
 *
 *  The subsequently converted C code has then been tidied up, mainly to
 *  remove any dependencies on the libI77 and libF77 support libraries.
 *
 *  FOR A GENERAL DESCRIPTION OF THE PHILOSOPHY AND DESIGN OF MP,
 *  SEE - R. P. BRENT, A FORTRAN MULTIPLE-PRECISION ARITHMETIC
 *  SOME ADDITIONAL DETAILS ARE GIVEN IN THE SAME ISSUE, 71-81.
 *  FOR DETAILS OF THE IMPLEMENTATION, CALLING SEQUENCES ETC. SEE
 *  THE MP USERS GUIDE.
 */

#include <glib.h>
#include "calculator.h"
#include "mpc.h"
#include "mpfr.h"
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include "mpfrg.h"
#include <glib/gi18n-lib.h>

typedef gint (*BitwiseFunc) (gint v1, gint v2, gpointer user_data);
enum  {
	NUMBER_0_PROPERTY,
	NUMBER_NUM_PROPERTIES
};
static GParamSpec* number_properties[NUMBER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NumberPrivate {
	__mpc_struct num;
};

static gint Number_private_offset;
static gpointer number_parent_class = NULL;
static mpfr_prec_t number__precision;
static mpfr_prec_t number__precision = (mpfr_prec_t) 1000;
static gchar* number__error;
static gchar* number__error = NULL;

static void number_mpc_from_radians (__mpc_struct* res,
                              __mpc_struct* op,
                              AngleUnit unit);
static Number* number_copy (Number* self);
static void number_mpc_to_radians (__mpc_struct* res,
                            __mpc_struct* op,
                            AngleUnit unit);
static Number* number_to_radians (Number* self,
                           AngleUnit unit);
static Number* number_bitwise (Number* self,
                        Number* y,
                        BitwiseFunc bitwise_operator,
                        gpointer bitwise_operator_target,
                        gint wordlen);
static gint __lambda4_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda4__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda5_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda5__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda6_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda6__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda7_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda7__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gchar* number_to_hex_string (Number* self);
static gint __lambda8_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda8__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean _mpc_equal (const __mpc_struct * s1,
                     const __mpc_struct * s2);
static gint number_hex_to_int (Number* self,
                        gchar digit);
static void number_finalize (GObject * obj);
static GType number_get_type_once (void);
static void _vala_number_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_number_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
VALA_EXTERN gint parse_literal_prefix (const gchar* str,
                           gint* prefix_len);
VALA_EXTERN Number* set_from_sexagesimal (const gchar* str);
VALA_EXTERN gint char_val (gunichar c,
               gint number_base);

static GType
angle_unit_get_type_once (void)
{
	static const GEnumValue values[] = {{ANGLE_UNIT_RADIANS, "ANGLE_UNIT_RADIANS", "radians"}, {ANGLE_UNIT_DEGREES, "ANGLE_UNIT_DEGREES", "degrees"}, {ANGLE_UNIT_GRADIANS, "ANGLE_UNIT_GRADIANS", "gradians"}, {0, NULL, NULL}};
	GType angle_unit_type_id;
	angle_unit_type_id = g_enum_register_static ("AngleUnit", values);
	return angle_unit_type_id;
}

GType
angle_unit_get_type (void)
{
	static volatile gsize angle_unit_type_id__once = 0;
	if (g_once_init_enter (&angle_unit_type_id__once)) {
		GType angle_unit_type_id;
		angle_unit_type_id = angle_unit_get_type_once ();
		g_once_init_leave (&angle_unit_type_id__once, angle_unit_type_id);
	}
	return angle_unit_type_id__once;
}

static inline gpointer
number_get_instance_private (Number* self)
{
	return G_STRUCT_MEMBER_P (self, Number_private_offset);
}

Number*
number_construct_integer (GType object_type,
                          gint64 real,
                          gint64 imag)
{
	Number * self = NULL;
#line 51 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 53 "../lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) real, (glong) imag, MPC_RNDNN);
#line 51 "../lib/number.vala"
	return self;
#line 170 "number.c"
}

Number*
number_new_integer (gint64 real,
                    gint64 imag)
{
#line 51 "../lib/number.vala"
	return number_construct_integer (TYPE_NUMBER, real, imag);
#line 179 "number.c"
}

Number*
number_construct_unsigned_integer (GType object_type,
                                   guint64 real,
                                   guint64 imag)
{
	Number * self = NULL;
#line 56 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 58 "../lib/number.vala"
	mpc_set_ui_ui (&self->priv->num, (gulong) real, (gulong) imag, MPC_RNDNN);
#line 56 "../lib/number.vala"
	return self;
#line 194 "number.c"
}

Number*
number_new_unsigned_integer (guint64 real,
                             guint64 imag)
{
#line 56 "../lib/number.vala"
	return number_construct_unsigned_integer (TYPE_NUMBER, real, imag);
#line 203 "number.c"
}

Number*
number_construct_fraction (GType object_type,
                           gint64 numerator,
                           gint64 denominator)
{
	Number * self = NULL;
#line 63 "../lib/number.vala"
	if (denominator < ((gint64) 0)) {
#line 65 "../lib/number.vala"
		numerator = -numerator;
#line 66 "../lib/number.vala"
		denominator = -denominator;
#line 218 "number.c"
	}
#line 69 "../lib/number.vala"
	self = (Number*) number_construct_integer (object_type, numerator, (gint64) 0);
#line 70 "../lib/number.vala"
	if (denominator != ((gint64) 1)) {
#line 72 "../lib/number.vala"
		mpc_div_ui (&self->priv->num, &self->priv->num, (gulong) ((glong) denominator), MPC_RNDNN);
#line 226 "number.c"
	}
#line 61 "../lib/number.vala"
	return self;
#line 230 "number.c"
}

Number*
number_new_fraction (gint64 numerator,
                     gint64 denominator)
{
#line 61 "../lib/number.vala"
	return number_construct_fraction (TYPE_NUMBER, numerator, denominator);
#line 239 "number.c"
}

static gint
mpc_set_mpreal (__mpc_struct *self,
                __mpfr_struct* re,
                __mpfr_struct* im,
                mpc_rnd_t rnd)
{
	__mpfr_struct _tmp1_;
	__mpfr_struct _tmp2_;
	gint result;
#line 61 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	g_return_val_if_fail (re != NULL, 0);
#line 63 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	if (im == NULL) {
#line 255 "number.c"
		__mpfr_struct _tmp0_;
#line 64 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
		_tmp0_ = *re;
#line 64 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
		result = mpc_set_fr (&(*self), &_tmp0_, rnd);
#line 64 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
		return result;
#line 263 "number.c"
	}
#line 66 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	_tmp1_ = *re;
#line 66 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	_tmp2_ = *im;
#line 66 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	result = mpc_set_fr_fr (&(*self), &_tmp1_, &_tmp2_, rnd);
#line 66 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	return result;
#line 273 "number.c"
}

Number*
number_construct_mpreal (GType object_type,
                         __mpfr_struct* real,
                         __mpfr_struct* imag)
{
	Number * self = NULL;
	__mpfr_struct _tmp0_;
#line 77 "../lib/number.vala"
	g_return_val_if_fail (real != NULL, NULL);
#line 77 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 79 "../lib/number.vala"
	_tmp0_ = *real;
#line 79 "../lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_, imag, MPC_RNDNN);
#line 77 "../lib/number.vala"
	return self;
#line 293 "number.c"
}

Number*
number_new_mpreal (__mpfr_struct* real,
                   __mpfr_struct* imag)
{
#line 77 "../lib/number.vala"
	return number_construct_mpreal (TYPE_NUMBER, real, imag);
#line 302 "number.c"
}

Number*
number_construct_double (GType object_type,
                         gdouble real,
                         gdouble imag)
{
	Number * self = NULL;
#line 82 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 84 "../lib/number.vala"
	mpc_set_d_d (&self->priv->num, real, imag, MPC_RNDNN);
#line 82 "../lib/number.vala"
	return self;
#line 317 "number.c"
}

Number*
number_new_double (gdouble real,
                   gdouble imag)
{
#line 82 "../lib/number.vala"
	return number_construct_double (TYPE_NUMBER, real, imag);
#line 326 "number.c"
}

Number*
number_construct_complex (GType object_type,
                          Number* r,
                          Number* i)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 87 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 87 "../lib/number.vala"
	g_return_val_if_fail (i != NULL, NULL);
#line 87 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 89 "../lib/number.vala"
	_tmp0_ = mpc_realref (&r->priv->num);
#line 89 "../lib/number.vala"
	_tmp1_ = mpc_realref (&i->priv->num);
#line 89 "../lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_->val, &_tmp1_->val, MPC_RNDNN);
#line 87 "../lib/number.vala"
	return self;
#line 351 "number.c"
}

Number*
number_new_complex (Number* r,
                    Number* i)
{
#line 87 "../lib/number.vala"
	return number_construct_complex (TYPE_NUMBER, r, i);
#line 360 "number.c"
}

Number*
number_construct_polar (GType object_type,
                        Number* r,
                        Number* theta,
                        AngleUnit unit)
{
	Number * self = NULL;
	Number* x = NULL;
	Number* _tmp0_;
	Number* y = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 92 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 92 "../lib/number.vala"
	g_return_val_if_fail (theta != NULL, NULL);
#line 94 "../lib/number.vala"
	_tmp0_ = number_cos (theta, unit);
#line 94 "../lib/number.vala"
	x = _tmp0_;
#line 95 "../lib/number.vala"
	_tmp1_ = number_sin (theta, unit);
#line 95 "../lib/number.vala"
	y = _tmp1_;
#line 96 "../lib/number.vala"
	_tmp2_ = number_multiply (x, r);
#line 96 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 96 "../lib/number.vala"
	_tmp4_ = number_multiply (y, r);
#line 96 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 96 "../lib/number.vala"
	self = (Number*) number_construct_complex (object_type, _tmp3_, _tmp5_);
#line 96 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 96 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 92 "../lib/number.vala"
	_g_object_unref0 (y);
#line 92 "../lib/number.vala"
	_g_object_unref0 (x);
#line 92 "../lib/number.vala"
	return self;
#line 410 "number.c"
}

Number*
number_new_polar (Number* r,
                  Number* theta,
                  AngleUnit unit)
{
#line 92 "../lib/number.vala"
	return number_construct_polar (TYPE_NUMBER, r, theta, unit);
#line 420 "number.c"
}

Number*
number_construct_eulers (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
#line 99 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 101 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 101 "../lib/number.vala"
	mpfr_set_ui (&_tmp0_->val, (gulong) 1, MPFR_RNDN);
#line 103 "../lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 103 "../lib/number.vala"
	_tmp2_ = mpc_realref (&self->priv->num);
#line 103 "../lib/number.vala"
	mpfr_exp (&_tmp1_->val, &_tmp2_->val, MPFR_RNDN);
#line 104 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&self->priv->num);
#line 104 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 99 "../lib/number.vala"
	return self;
#line 449 "number.c"
}

Number*
number_new_eulers (void)
{
#line 99 "../lib/number.vala"
	return number_construct_eulers (TYPE_NUMBER);
#line 457 "number.c"
}

Number*
number_construct_i (GType object_type)
{
	Number * self = NULL;
#line 107 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 109 "../lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) 0, (glong) 1, MPC_RNDNN);
#line 107 "../lib/number.vala"
	return self;
#line 470 "number.c"
}

Number*
number_new_i (void)
{
#line 107 "../lib/number.vala"
	return number_construct_i (TYPE_NUMBER);
#line 478 "number.c"
}

Number*
number_construct_pi (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 112 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 114 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 114 "../lib/number.vala"
	mpfr_const_pi (&_tmp0_->val, MPFR_RNDN);
#line 115 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 115 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 112 "../lib/number.vala"
	return self;
#line 499 "number.c"
}

Number*
number_new_pi (void)
{
#line 112 "../lib/number.vala"
	return number_construct_pi (TYPE_NUMBER);
#line 507 "number.c"
}

static gint
mpfr_const_tau (__mpfr_struct *self,
                mpfr_rnd_t rnd)
{
	gint i = 0;
	gint result;
#line 78 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpfr.vapi"
	i = mpfr_const_pi (&(*self), rnd);
#line 79 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpfr.vapi"
	mpfr_mul_si (&(*self), &(*self), (glong) 2, rnd);
#line 80 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpfr.vapi"
	result = i;
#line 80 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpfr.vapi"
	return result;
#line 524 "number.c"
}

Number*
number_construct_tau (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 118 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 120 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 120 "../lib/number.vala"
	mpfr_const_tau (&_tmp0_->val, MPFR_RNDN);
#line 121 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 121 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 118 "../lib/number.vala"
	return self;
#line 545 "number.c"
}

Number*
number_new_tau (void)
{
#line 118 "../lib/number.vala"
	return number_construct_tau (TYPE_NUMBER);
#line 553 "number.c"
}

Number*
number_construct_random (GType object_type)
{
	Number * self = NULL;
#line 127 "../lib/number.vala"
	self = (Number*) number_construct_double (object_type, g_random_double (), (gdouble) 0);
#line 125 "../lib/number.vala"
	return self;
#line 564 "number.c"
}

Number*
number_new_random (void)
{
#line 125 "../lib/number.vala"
	return number_construct_random (TYPE_NUMBER);
#line 572 "number.c"
}

gint64
number_to_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gint64 result;
#line 130 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 132 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 132 "../lib/number.vala"
	result = (gint64) mpfr_get_si (&_tmp0_->val, MPFR_RNDN);
#line 132 "../lib/number.vala"
	return result;
#line 588 "number.c"
}

guint64
number_to_unsigned_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	guint64 result;
#line 135 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 137 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 137 "../lib/number.vala"
	result = (guint64) mpfr_get_ui (&_tmp0_->val, MPFR_RNDN);
#line 137 "../lib/number.vala"
	return result;
#line 604 "number.c"
}

gfloat
number_to_float (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gfloat result;
#line 140 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 142 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 142 "../lib/number.vala"
	result = mpfr_get_flt (&_tmp0_->val, MPFR_RNDN);
#line 142 "../lib/number.vala"
	return result;
#line 620 "number.c"
}

gdouble
number_to_double (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gdouble result;
#line 145 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 147 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 147 "../lib/number.vala"
	result = mpfr_get_d (&_tmp0_->val, MPFR_RNDN);
#line 147 "../lib/number.vala"
	return result;
#line 636 "number.c"
}

static gboolean
mpc_is_zero (__mpc_struct *self)
{
	gint res = 0;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 74 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	res = mpc_cmp_si_si (&(*self), (glong) 0, (glong) 0);
#line 74 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	if (MPC_INEX_RE (res) == 0) {
#line 74 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
		_tmp0_ = MPC_INEX_IM (res) == 0;
#line 651 "number.c"
	} else {
#line 74 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
		_tmp0_ = FALSE;
#line 655 "number.c"
	}
#line 74 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	result = _tmp0_;
#line 74 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	return result;
#line 661 "number.c"
}

gboolean
number_is_zero (Number* self)
{
	gboolean result;
#line 151 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "../lib/number.vala"
	result = mpc_is_zero (&self->priv->num);
#line 153 "../lib/number.vala"
	return result;
#line 674 "number.c"
}

gboolean
number_is_negative (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 157 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 159 "../lib/number.vala"
	result = mpfr_sgn (&_tmp0_->val) < 0;
#line 159 "../lib/number.vala"
	return result;
#line 690 "number.c"
}

gboolean
number_is_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 163 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 166 "../lib/number.vala"
		result = FALSE;
#line 166 "../lib/number.vala"
		return result;
#line 706 "number.c"
	}
#line 168 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 168 "../lib/number.vala"
	result = mpfr_integer_p (&_tmp0_->val) != 0;
#line 168 "../lib/number.vala"
	return result;
#line 714 "number.c"
}

gboolean
number_is_positive_integer (Number* self)
{
	gboolean result;
#line 172 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 174 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 175 "../lib/number.vala"
		result = FALSE;
#line 175 "../lib/number.vala"
		return result;
#line 729 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRGRealRef* _tmp1_;
#line 177 "../lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 177 "../lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) >= 0) {
#line 177 "../lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 739 "number.c"
		} else {
#line 177 "../lib/number.vala"
			_tmp0_ = FALSE;
#line 743 "number.c"
		}
#line 177 "../lib/number.vala"
		result = _tmp0_;
#line 177 "../lib/number.vala"
		return result;
#line 749 "number.c"
	}
}

gboolean
number_is_natural (Number* self)
{
	gboolean result;
#line 181 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 183 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 184 "../lib/number.vala"
		result = FALSE;
#line 184 "../lib/number.vala"
		return result;
#line 765 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRGRealRef* _tmp1_;
#line 186 "../lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 186 "../lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) > 0) {
#line 186 "../lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 775 "number.c"
		} else {
#line 186 "../lib/number.vala"
			_tmp0_ = FALSE;
#line 779 "number.c"
		}
#line 186 "../lib/number.vala"
		result = _tmp0_;
#line 186 "../lib/number.vala"
		return result;
#line 785 "number.c"
	}
}

gboolean
number_is_complex (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 190 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 192 "../lib/number.vala"
	_tmp0_ = mpc_imagref (&self->priv->num);
#line 192 "../lib/number.vala"
	result = !mpfr_zero_p (&_tmp0_->val);
#line 192 "../lib/number.vala"
	return result;
#line 802 "number.c"
}

void
number_check_flags (void)
{
#line 198 "../lib/number.vala"
	if (mpfr_underflow_p () != 0) {
#line 201 "../lib/number.vala"
		number_set_error (_ ("Underflow error"));
#line 812 "number.c"
	} else {
#line 203 "../lib/number.vala"
		if (mpfr_overflow_p () != 0) {
#line 206 "../lib/number.vala"
			number_set_error (_ ("Overflow error"));
#line 818 "number.c"
		}
	}
}

static gboolean
mpc_is_equal (__mpc_struct *self,
              __mpc_struct* c)
{
	gint res = 0;
	__mpc_struct _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 75 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	g_return_val_if_fail (c != NULL, FALSE);
#line 75 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	_tmp0_ = *c;
#line 75 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	res = mpc_cmp (&(*self), &_tmp0_);
#line 75 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	if (MPC_INEX_RE (res) == 0) {
#line 75 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
		_tmp1_ = MPC_INEX_IM (res) == 0;
#line 841 "number.c"
	} else {
#line 75 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
		_tmp1_ = FALSE;
#line 845 "number.c"
	}
#line 75 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	result = _tmp1_;
#line 75 "/builddir/build/BUILD/gnome-calculator-43.0.1/vapi/mpc.vapi"
	return result;
#line 851 "number.c"
}

gboolean
number_equals (Number* self,
               Number* y)
{
	gboolean result;
#line 211 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, FALSE);
#line 213 "../lib/number.vala"
	result = mpc_is_equal (&self->priv->num, &y->priv->num);
#line 213 "../lib/number.vala"
	return result;
#line 867 "number.c"
}

gint
number_compare (Number* self,
                Number* y)
{
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
	gint result;
#line 221 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 221 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, 0);
#line 223 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 223 "../lib/number.vala"
	_tmp1_ = mpc_realref (&y->priv->num);
#line 223 "../lib/number.vala"
	result = mpfr_cmp (&_tmp0_->val, &_tmp1_->val);
#line 223 "../lib/number.vala"
	return result;
#line 889 "number.c"
}

Number*
number_sgn (Number* self)
{
	Number* z = NULL;
	MPFRGRealRef* _tmp0_;
	Number* _tmp1_;
	Number* result;
#line 227 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 229 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) mpfr_sgn (&_tmp0_->val), (gint64) 0);
#line 229 "../lib/number.vala"
	z = _tmp1_;
#line 230 "../lib/number.vala"
	result = z;
#line 230 "../lib/number.vala"
	return result;
#line 911 "number.c"
}

Number*
number_invert_sign (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 234 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 236 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 236 "../lib/number.vala"
	z = _tmp0_;
#line 237 "../lib/number.vala"
	mpc_neg (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 238 "../lib/number.vala"
	result = z;
#line 238 "../lib/number.vala"
	return result;
#line 932 "number.c"
}

Number*
number_abs (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	Number* result;
#line 242 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 244 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 244 "../lib/number.vala"
	z = _tmp0_;
#line 245 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 245 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 246 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 246 "../lib/number.vala"
	mpc_abs (&_tmp2_->val, &self->priv->num, MPFR_RNDN);
#line 247 "../lib/number.vala"
	result = z;
#line 247 "../lib/number.vala"
	return result;
#line 961 "number.c"
}

Number*
number_arg (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* _tmp4_;
	MPFRGRealRef* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	gboolean _tmp8_ = FALSE;
	Number* result;
#line 251 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 982 "number.c"
		Number* _tmp0_;
#line 256 "../lib/number.vala"
		number_set_error (_ ("Argument not defined for zero"));
#line 257 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 257 "../lib/number.vala"
		result = _tmp0_;
#line 257 "../lib/number.vala"
		return result;
#line 992 "number.c"
	}
#line 259 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 259 "../lib/number.vala"
	z = _tmp1_;
#line 260 "../lib/number.vala"
	_tmp2_ = z;
#line 260 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&_tmp2_->priv->num);
#line 260 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 261 "../lib/number.vala"
	_tmp4_ = z;
#line 261 "../lib/number.vala"
	_tmp5_ = mpc_realref (&_tmp4_->priv->num);
#line 261 "../lib/number.vala"
	mpc_arg (&_tmp5_->val, &self->priv->num, MPFR_RNDN);
#line 262 "../lib/number.vala"
	_tmp6_ = z;
#line 262 "../lib/number.vala"
	_tmp7_ = z;
#line 262 "../lib/number.vala"
	number_mpc_from_radians (&_tmp6_->priv->num, &_tmp7_->priv->num, unit);
#line 267 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 267 "../lib/number.vala"
		_tmp8_ = number_is_negative (self);
#line 1020 "number.c"
	} else {
#line 267 "../lib/number.vala"
		_tmp8_ = FALSE;
#line 1024 "number.c"
	}
#line 267 "../lib/number.vala"
	if (_tmp8_) {
#line 1028 "number.c"
		Number* _tmp9_;
		MPFRGRealRef* _tmp10_;
		Number* _tmp11_;
		MPFRGRealRef* _tmp12_;
#line 268 "../lib/number.vala"
		_tmp9_ = z;
#line 268 "../lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 268 "../lib/number.vala"
		_tmp11_ = z;
#line 268 "../lib/number.vala"
		_tmp12_ = mpc_realref (&_tmp11_->priv->num);
#line 268 "../lib/number.vala"
		mpfr_abs (&_tmp10_->val, &_tmp12_->val, MPFR_RNDN);
#line 1043 "number.c"
	}
#line 270 "../lib/number.vala"
	result = z;
#line 270 "../lib/number.vala"
	return result;
#line 1049 "number.c"
}

Number*
number_conjugate (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 274 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 276 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 276 "../lib/number.vala"
	z = _tmp0_;
#line 277 "../lib/number.vala"
	mpc_conj (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 278 "../lib/number.vala"
	result = z;
#line 278 "../lib/number.vala"
	return result;
#line 1070 "number.c"
}

Number*
number_real_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 282 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 284 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 284 "../lib/number.vala"
	z = _tmp0_;
#line 285 "../lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 285 "../lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 286 "../lib/number.vala"
	result = z;
#line 286 "../lib/number.vala"
	return result;
#line 1094 "number.c"
}

Number*
number_imaginary_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 290 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 293 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 293 "../lib/number.vala"
	z = _tmp0_;
#line 294 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 294 "../lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 295 "../lib/number.vala"
	result = z;
#line 295 "../lib/number.vala"
	return result;
#line 1118 "number.c"
}

Number*
number_integer_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 298 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 300 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 300 "../lib/number.vala"
	z = _tmp0_;
#line 301 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 301 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 302 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 302 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 302 "../lib/number.vala"
	mpfr_trunc (&_tmp2_->val, &_tmp3_->val);
#line 303 "../lib/number.vala"
	result = z;
#line 303 "../lib/number.vala"
	return result;
#line 1150 "number.c"
}

Number*
number_fractional_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 307 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 309 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 309 "../lib/number.vala"
	z = _tmp0_;
#line 310 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 310 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 311 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 311 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 311 "../lib/number.vala"
	mpfr_frac (&_tmp2_->val, &_tmp3_->val, MPFR_RNDN);
#line 312 "../lib/number.vala"
	result = z;
#line 312 "../lib/number.vala"
	return result;
#line 1182 "number.c"
}

Number*
number_fractional_part (Number* self)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 316 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 318 "../lib/number.vala"
	_tmp0_ = number_floor (self);
#line 318 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 318 "../lib/number.vala"
	_tmp2_ = number_subtract (self, _tmp1_);
#line 318 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 318 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 318 "../lib/number.vala"
	result = _tmp3_;
#line 318 "../lib/number.vala"
	return result;
#line 1209 "number.c"
}

Number*
number_floor (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 322 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 324 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 324 "../lib/number.vala"
	z = _tmp0_;
#line 325 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 325 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 326 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 326 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 326 "../lib/number.vala"
	mpfr_floor (&_tmp2_->val, &_tmp3_->val);
#line 327 "../lib/number.vala"
	result = z;
#line 327 "../lib/number.vala"
	return result;
#line 1241 "number.c"
}

Number*
number_ceiling (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 331 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 333 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 333 "../lib/number.vala"
	z = _tmp0_;
#line 334 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 334 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 335 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 335 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 335 "../lib/number.vala"
	mpfr_ceil (&_tmp2_->val, &_tmp3_->val);
#line 336 "../lib/number.vala"
	result = z;
#line 336 "../lib/number.vala"
	return result;
#line 1273 "number.c"
}

Number*
number_round (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 340 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 342 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 342 "../lib/number.vala"
	z = _tmp0_;
#line 343 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 343 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 344 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 344 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 344 "../lib/number.vala"
	mpfr_round (&_tmp2_->val, &_tmp3_->val);
#line 345 "../lib/number.vala"
	result = z;
#line 345 "../lib/number.vala"
	return result;
#line 1305 "number.c"
}

Number*
number_reciprocal (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 349 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 351 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 351 "../lib/number.vala"
	z = _tmp0_;
#line 352 "../lib/number.vala"
	mpc_set_si_si (&z->priv->num, (glong) 1, (glong) 0, MPC_RNDNN);
#line 353 "../lib/number.vala"
	_tmp1_ = mpc_realref (&z->priv->num);
#line 353 "../lib/number.vala"
	mpc_fr_div (&z->priv->num, &_tmp1_->val, &self->priv->num, MPC_RNDNN);
#line 354 "../lib/number.vala"
	result = z;
#line 354 "../lib/number.vala"
	return result;
#line 1331 "number.c"
}

Number*
number_epowy (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 358 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 360 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 360 "../lib/number.vala"
	z = _tmp0_;
#line 361 "../lib/number.vala"
	mpc_exp (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 362 "../lib/number.vala"
	result = z;
#line 362 "../lib/number.vala"
	return result;
#line 1352 "number.c"
}

Number*
number_xpowy (Number* self,
              Number* y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	Number* z = NULL;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* result;
#line 366 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 366 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 369 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 369 "../lib/number.vala"
		_tmp0_ = number_is_negative (y);
#line 1375 "number.c"
	} else {
#line 369 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 1379 "number.c"
	}
#line 369 "../lib/number.vala"
	if (_tmp0_) {
#line 1383 "number.c"
		Number* _tmp1_;
#line 372 "../lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 373 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 373 "../lib/number.vala"
		result = _tmp1_;
#line 373 "../lib/number.vala"
		return result;
#line 1393 "number.c"
	}
#line 377 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 377 "../lib/number.vala"
		_tmp2_ = number_is_zero (y);
#line 1399 "number.c"
	} else {
#line 377 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 1403 "number.c"
	}
#line 377 "../lib/number.vala"
	if (_tmp2_) {
#line 1407 "number.c"
		Number* _tmp3_;
#line 380 "../lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 381 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 381 "../lib/number.vala"
		result = _tmp3_;
#line 381 "../lib/number.vala"
		return result;
#line 1417 "number.c"
	}
#line 383 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 383 "../lib/number.vala"
		_tmp5_ = !number_is_complex (y);
#line 1423 "number.c"
	} else {
#line 383 "../lib/number.vala"
		_tmp5_ = FALSE;
#line 1427 "number.c"
	}
#line 383 "../lib/number.vala"
	if (_tmp5_) {
#line 383 "../lib/number.vala"
		_tmp4_ = !number_is_integer (y);
#line 1433 "number.c"
	} else {
#line 383 "../lib/number.vala"
		_tmp4_ = FALSE;
#line 1437 "number.c"
	}
#line 383 "../lib/number.vala"
	if (_tmp4_) {
#line 1441 "number.c"
		Number* reciprocal = NULL;
		Number* _tmp6_;
		Number* _tmp7_;
#line 385 "../lib/number.vala"
		_tmp6_ = number_reciprocal (y);
#line 385 "../lib/number.vala"
		reciprocal = _tmp6_;
#line 386 "../lib/number.vala"
		_tmp7_ = reciprocal;
#line 386 "../lib/number.vala"
		if (number_is_integer (_tmp7_)) {
#line 1453 "number.c"
			Number* _tmp8_;
			Number* _tmp9_;
#line 387 "../lib/number.vala"
			_tmp8_ = reciprocal;
#line 387 "../lib/number.vala"
			_tmp9_ = number_root (self, number_to_integer (_tmp8_));
#line 387 "../lib/number.vala"
			result = _tmp9_;
#line 387 "../lib/number.vala"
			_g_object_unref0 (reciprocal);
#line 387 "../lib/number.vala"
			return result;
#line 1466 "number.c"
		}
#line 383 "../lib/number.vala"
		_g_object_unref0 (reciprocal);
#line 1470 "number.c"
	}
#line 390 "../lib/number.vala"
	_tmp10_ = number_new ();
#line 390 "../lib/number.vala"
	z = _tmp10_;
#line 391 "../lib/number.vala"
	_tmp11_ = z;
#line 391 "../lib/number.vala"
	mpc_pow (&_tmp11_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 392 "../lib/number.vala"
	result = z;
#line 392 "../lib/number.vala"
	return result;
#line 1484 "number.c"
}

Number*
number_xpowy_integer (Number* self,
                      gint64 n)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Number* z = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 396 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 399 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 399 "../lib/number.vala"
		_tmp0_ = n < ((gint64) 0);
#line 1503 "number.c"
	} else {
#line 399 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 1507 "number.c"
	}
#line 399 "../lib/number.vala"
	if (_tmp0_) {
#line 1511 "number.c"
		Number* _tmp1_;
#line 402 "../lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 403 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 403 "../lib/number.vala"
		result = _tmp1_;
#line 403 "../lib/number.vala"
		return result;
#line 1521 "number.c"
	}
#line 407 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 407 "../lib/number.vala"
		_tmp2_ = n == ((gint64) 0);
#line 1527 "number.c"
	} else {
#line 407 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 1531 "number.c"
	}
#line 407 "../lib/number.vala"
	if (_tmp2_) {
#line 1535 "number.c"
		Number* _tmp3_;
#line 410 "../lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 411 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 411 "../lib/number.vala"
		result = _tmp3_;
#line 411 "../lib/number.vala"
		return result;
#line 1545 "number.c"
	}
#line 413 "../lib/number.vala"
	_tmp4_ = number_new ();
#line 413 "../lib/number.vala"
	z = _tmp4_;
#line 414 "../lib/number.vala"
	_tmp5_ = z;
#line 414 "../lib/number.vala"
	mpc_pow_si (&_tmp5_->priv->num, &self->priv->num, (glong) n, MPC_RNDNN);
#line 415 "../lib/number.vala"
	result = z;
#line 415 "../lib/number.vala"
	return result;
#line 1559 "number.c"
}

Number*
number_root (Number* self,
             gint64 n)
{
	guint64 p = 0ULL;
	Number* z = NULL;
	Number* _tmp0_;
	gboolean _tmp4_ = FALSE;
	Number* result;
#line 419 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 422 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 422 "../lib/number.vala"
	z = _tmp0_;
#line 423 "../lib/number.vala"
	if (n < ((gint64) 0)) {
#line 1579 "number.c"
		Number* _tmp1_;
#line 425 "../lib/number.vala"
		_tmp1_ = z;
#line 425 "../lib/number.vala"
		mpc_ui_div (&_tmp1_->priv->num, (gulong) 1, &self->priv->num, MPC_RNDNN);
#line 426 "../lib/number.vala"
		if (n == G_MININT64) {
#line 427 "../lib/number.vala"
			p = ((guint64) G_MAXINT64) + 1;
#line 1589 "number.c"
		} else {
#line 429 "../lib/number.vala"
			p = (guint64) (-n);
#line 1593 "number.c"
		}
	} else {
#line 430 "../lib/number.vala"
		if (n > ((gint64) 0)) {
#line 1598 "number.c"
			Number* _tmp2_;
#line 431 "../lib/number.vala"
			_tmp2_ = z;
#line 431 "../lib/number.vala"
			mpc_set (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 432 "../lib/number.vala"
			p = (guint64) n;
#line 1606 "number.c"
		} else {
			Number* _tmp3_;
#line 434 "../lib/number.vala"
			number_set_error (_ ("The zeroth root of a number is undefined"));
#line 435 "../lib/number.vala"
			_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 435 "../lib/number.vala"
			result = _tmp3_;
#line 435 "../lib/number.vala"
			_g_object_unref0 (z);
#line 435 "../lib/number.vala"
			return result;
#line 1619 "number.c"
		}
	}
#line 438 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 1624 "number.c"
		gboolean _tmp5_ = FALSE;
#line 438 "../lib/number.vala"
		if (!number_is_negative (self)) {
#line 438 "../lib/number.vala"
			_tmp5_ = TRUE;
#line 1630 "number.c"
		} else {
#line 438 "../lib/number.vala"
			_tmp5_ = (p & 1) == ((guint64) 1);
#line 1634 "number.c"
		}
#line 438 "../lib/number.vala"
		_tmp4_ = _tmp5_;
#line 1638 "number.c"
	} else {
#line 438 "../lib/number.vala"
		_tmp4_ = FALSE;
#line 1642 "number.c"
	}
#line 438 "../lib/number.vala"
	if (_tmp4_) {
#line 1646 "number.c"
		Number* _tmp6_;
		MPFRGRealRef* _tmp7_;
		Number* _tmp8_;
		MPFRGRealRef* _tmp9_;
		Number* _tmp10_;
		MPFRGRealRef* _tmp11_;
#line 440 "../lib/number.vala"
		_tmp6_ = z;
#line 440 "../lib/number.vala"
		_tmp7_ = mpc_realref (&_tmp6_->priv->num);
#line 440 "../lib/number.vala"
		_tmp8_ = z;
#line 440 "../lib/number.vala"
		_tmp9_ = mpc_realref (&_tmp8_->priv->num);
#line 440 "../lib/number.vala"
		mpfr_root (&_tmp7_->val, &_tmp9_->val, (gulong) p, MPFR_RNDN);
#line 441 "../lib/number.vala"
		_tmp10_ = z;
#line 441 "../lib/number.vala"
		_tmp11_ = mpc_imagref (&_tmp10_->priv->num);
#line 441 "../lib/number.vala"
		mpfr_set_zero (&_tmp11_->val, MPFR_RNDN);
#line 1669 "number.c"
	} else {
		__mpfr_struct tmp = {0};
		mpfr_prec_t _tmp12_;
		mpfr_prec_t _tmp13_;
		Number* _tmp14_;
		Number* _tmp15_;
#line 443 "../lib/number.vala"
		_tmp12_ = number_get_precision ();
#line 443 "../lib/number.vala"
		_tmp13_ = _tmp12_;
#line 443 "../lib/number.vala"
		mpfr_init2 (&tmp, _tmp13_);
#line 444 "../lib/number.vala"
		mpfr_set_ui (&tmp, (gulong) p, MPFR_RNDN);
#line 445 "../lib/number.vala"
		mpfr_ui_div (&tmp, (gulong) 1, &tmp, MPFR_RNDN);
#line 446 "../lib/number.vala"
		_tmp14_ = z;
#line 446 "../lib/number.vala"
		_tmp15_ = z;
#line 446 "../lib/number.vala"
		mpc_pow_fr (&_tmp14_->priv->num, &_tmp15_->priv->num, &tmp, MPC_RNDNN);
#line 438 "../lib/number.vala"
		mpfr_clear (&tmp);
#line 1694 "number.c"
	}
#line 448 "../lib/number.vala"
	result = z;
#line 448 "../lib/number.vala"
	return result;
#line 1700 "number.c"
}

Number*
number_sqrt (Number* self)
{
	Number* _tmp0_;
	Number* result;
#line 452 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 454 "../lib/number.vala"
	_tmp0_ = number_root (self, (gint64) 2);
#line 454 "../lib/number.vala"
	result = _tmp0_;
#line 454 "../lib/number.vala"
	return result;
#line 1716 "number.c"
}

Number*
number_ln (Number* self)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Number* result;
#line 458 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1731 "number.c"
		Number* _tmp0_;
#line 464 "../lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 465 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 465 "../lib/number.vala"
		result = _tmp0_;
#line 465 "../lib/number.vala"
		return result;
#line 1741 "number.c"
	}
#line 477 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 477 "../lib/number.vala"
	z = _tmp1_;
#line 478 "../lib/number.vala"
	_tmp2_ = z;
#line 478 "../lib/number.vala"
	mpc_log (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 482 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 482 "../lib/number.vala"
		_tmp3_ = number_is_negative (self);
#line 1755 "number.c"
	} else {
#line 482 "../lib/number.vala"
		_tmp3_ = FALSE;
#line 1759 "number.c"
	}
#line 482 "../lib/number.vala"
	if (_tmp3_) {
#line 1763 "number.c"
		Number* _tmp4_;
		MPFRGRealRef* _tmp5_;
		Number* _tmp6_;
		MPFRGRealRef* _tmp7_;
#line 483 "../lib/number.vala"
		_tmp4_ = z;
#line 483 "../lib/number.vala"
		_tmp5_ = mpc_imagref (&_tmp4_->priv->num);
#line 483 "../lib/number.vala"
		_tmp6_ = z;
#line 483 "../lib/number.vala"
		_tmp7_ = mpc_imagref (&_tmp6_->priv->num);
#line 483 "../lib/number.vala"
		mpfr_abs (&_tmp5_->val, &_tmp7_->val, MPFR_RNDN);
#line 1778 "number.c"
	}
#line 485 "../lib/number.vala"
	result = z;
#line 485 "../lib/number.vala"
	return result;
#line 1784 "number.c"
}

Number*
number_logarithm (Number* self,
                  gint64 n)
{
	Number* t1 = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* result;
#line 489 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 492 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1805 "number.c"
		Number* _tmp0_;
#line 495 "../lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 496 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 496 "../lib/number.vala"
		result = _tmp0_;
#line 496 "../lib/number.vala"
		return result;
#line 1815 "number.c"
	}
#line 500 "../lib/number.vala"
	_tmp1_ = number_new_integer (n, (gint64) 0);
#line 500 "../lib/number.vala"
	t1 = _tmp1_;
#line 501 "../lib/number.vala"
	_tmp2_ = number_ln (self);
#line 501 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 501 "../lib/number.vala"
	_tmp4_ = t1;
#line 501 "../lib/number.vala"
	_tmp5_ = number_ln (_tmp4_);
#line 501 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 501 "../lib/number.vala"
	_tmp7_ = number_divide (_tmp3_, _tmp6_);
#line 501 "../lib/number.vala"
	_tmp8_ = _tmp7_;
#line 501 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 501 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 501 "../lib/number.vala"
	result = _tmp8_;
#line 501 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 501 "../lib/number.vala"
	return result;
#line 1845 "number.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 532 "../lib/number.vala"
	return self ? g_object_ref (self) : NULL;
#line 1853 "number.c"
}

Number*
number_factorial (Number* self)
{
	gint64 value = 0LL;
	Number* z = NULL;
	Number* _tmp12_;
	Number* result;
#line 505 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 508 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1867 "number.c"
		Number* _tmp0_;
#line 509 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 509 "../lib/number.vala"
		result = _tmp0_;
#line 509 "../lib/number.vala"
		return result;
#line 1875 "number.c"
	}
#line 510 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 1879 "number.c"
		gboolean _tmp1_ = FALSE;
		Number* tmp = NULL;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
		Number* _tmp6_;
		__mpfr_struct tmp2 = {0};
		mpfr_prec_t _tmp7_;
		mpfr_prec_t _tmp8_;
		Number* _tmp9_;
		MPFRGRealRef* _tmp10_;
		Number* _tmp11_;
#line 514 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 514 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 1896 "number.c"
		} else {
#line 514 "../lib/number.vala"
			_tmp1_ = number_is_complex (self);
#line 1900 "number.c"
		}
#line 514 "../lib/number.vala"
		if (_tmp1_) {
#line 1904 "number.c"
			Number* _tmp2_;
#line 517 "../lib/number.vala"
			number_set_error (_ ("Factorial is only defined for non-negative real numbers"));
#line 518 "../lib/number.vala"
			_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 518 "../lib/number.vala"
			result = _tmp2_;
#line 518 "../lib/number.vala"
			return result;
#line 1914 "number.c"
		}
#line 521 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 521 "../lib/number.vala"
		_tmp4_ = _tmp3_;
#line 521 "../lib/number.vala"
		_tmp5_ = number_add (self, _tmp4_);
#line 521 "../lib/number.vala"
		_tmp6_ = _tmp5_;
#line 521 "../lib/number.vala"
		_g_object_unref0 (_tmp4_);
#line 521 "../lib/number.vala"
		tmp = _tmp6_;
#line 522 "../lib/number.vala"
		_tmp7_ = number_get_precision ();
#line 522 "../lib/number.vala"
		_tmp8_ = _tmp7_;
#line 522 "../lib/number.vala"
		mpfr_init2 (&tmp2, _tmp8_);
#line 525 "../lib/number.vala"
		_tmp9_ = tmp;
#line 525 "../lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 525 "../lib/number.vala"
		mpfr_gamma (&tmp2, &_tmp10_->val, MPFR_RNDN);
#line 527 "../lib/number.vala"
		_tmp11_ = number_new_mpreal (&tmp2, NULL);
#line 527 "../lib/number.vala"
		result = _tmp11_;
#line 527 "../lib/number.vala"
		mpfr_clear (&tmp2);
#line 527 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 527 "../lib/number.vala"
		return result;
#line 1950 "number.c"
	}
#line 531 "../lib/number.vala"
	value = number_to_integer (self);
#line 532 "../lib/number.vala"
	_tmp12_ = _g_object_ref0 (self);
#line 532 "../lib/number.vala"
	z = _tmp12_;
#line 1958 "number.c"
	{
		gint i = 0;
#line 533 "../lib/number.vala"
		i = 2;
#line 1963 "number.c"
		{
			gboolean _tmp13_ = FALSE;
#line 533 "../lib/number.vala"
			_tmp13_ = TRUE;
#line 533 "../lib/number.vala"
			while (TRUE) {
#line 1970 "number.c"
				Number* _tmp15_;
				Number* _tmp16_;
#line 533 "../lib/number.vala"
				if (!_tmp13_) {
#line 1975 "number.c"
					gint _tmp14_;
#line 533 "../lib/number.vala"
					_tmp14_ = i;
#line 533 "../lib/number.vala"
					i = _tmp14_ + 1;
#line 1981 "number.c"
				}
#line 533 "../lib/number.vala"
				_tmp13_ = FALSE;
#line 533 "../lib/number.vala"
				if (!(((gint64) i) < value)) {
#line 533 "../lib/number.vala"
					break;
#line 1989 "number.c"
				}
#line 534 "../lib/number.vala"
				_tmp15_ = z;
#line 534 "../lib/number.vala"
				_tmp16_ = number_multiply_integer (_tmp15_, (gint64) i);
#line 534 "../lib/number.vala"
				_g_object_unref0 (z);
#line 534 "../lib/number.vala"
				z = _tmp16_;
#line 1999 "number.c"
			}
		}
	}
#line 536 "../lib/number.vala"
	result = z;
#line 536 "../lib/number.vala"
	return result;
#line 2007 "number.c"
}

Number*
number_add (Number* self,
            Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 540 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 540 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 542 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 542 "../lib/number.vala"
	z = _tmp0_;
#line 543 "../lib/number.vala"
	mpc_add (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 544 "../lib/number.vala"
	result = z;
#line 544 "../lib/number.vala"
	return result;
#line 2031 "number.c"
}

Number*
number_subtract (Number* self,
                 Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 548 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 548 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 550 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 550 "../lib/number.vala"
	z = _tmp0_;
#line 551 "../lib/number.vala"
	mpc_sub (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 552 "../lib/number.vala"
	result = z;
#line 552 "../lib/number.vala"
	return result;
#line 2055 "number.c"
}

Number*
number_multiply (Number* self,
                 Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 556 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 556 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 558 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 558 "../lib/number.vala"
	z = _tmp0_;
#line 559 "../lib/number.vala"
	mpc_mul (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 560 "../lib/number.vala"
	result = z;
#line 560 "../lib/number.vala"
	return result;
#line 2079 "number.c"
}

Number*
number_multiply_integer (Number* self,
                         gint64 y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 564 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 566 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 566 "../lib/number.vala"
	z = _tmp0_;
#line 567 "../lib/number.vala"
	mpc_mul_si (&z->priv->num, &self->priv->num, (glong) y, MPC_RNDNN);
#line 568 "../lib/number.vala"
	result = z;
#line 568 "../lib/number.vala"
	return result;
#line 2101 "number.c"
}

Number*
number_divide (Number* self,
               Number* y)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* result;
#line 572 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 572 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 574 "../lib/number.vala"
	if (number_is_zero (y)) {
#line 2118 "number.c"
		Number* _tmp0_;
#line 577 "../lib/number.vala"
		number_set_error (_ ("Division by zero is undefined"));
#line 578 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 578 "../lib/number.vala"
		result = _tmp0_;
#line 578 "../lib/number.vala"
		return result;
#line 2128 "number.c"
	}
#line 581 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 581 "../lib/number.vala"
	z = _tmp1_;
#line 582 "../lib/number.vala"
	_tmp2_ = z;
#line 582 "../lib/number.vala"
	mpc_div (&_tmp2_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 583 "../lib/number.vala"
	result = z;
#line 583 "../lib/number.vala"
	return result;
#line 2142 "number.c"
}

Number*
number_divide_integer (Number* self,
                       gint64 y)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 587 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 589 "../lib/number.vala"
	_tmp0_ = number_new_integer (y, (gint64) 0);
#line 589 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 589 "../lib/number.vala"
	_tmp2_ = number_divide (self, _tmp1_);
#line 589 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 589 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 589 "../lib/number.vala"
	result = _tmp3_;
#line 589 "../lib/number.vala"
	return result;
#line 2170 "number.c"
}

Number*
number_modulus_divide (Number* self,
                       Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* t1 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t2 = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* z = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	Number* _tmp13_;
	Number* result;
#line 593 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 593 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 595 "../lib/number.vala"
	if (!number_is_integer (self)) {
#line 595 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2202 "number.c"
	} else {
#line 595 "../lib/number.vala"
		_tmp0_ = !number_is_integer (y);
#line 2206 "number.c"
	}
#line 595 "../lib/number.vala"
	if (_tmp0_) {
#line 2210 "number.c"
		Number* _tmp1_;
#line 598 "../lib/number.vala"
		number_set_error (_ ("Modulus division is only defined for integers"));
#line 599 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 599 "../lib/number.vala"
		result = _tmp1_;
#line 599 "../lib/number.vala"
		return result;
#line 2220 "number.c"
	}
#line 602 "../lib/number.vala"
	_tmp2_ = number_divide (self, y);
#line 602 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 602 "../lib/number.vala"
	_tmp4_ = number_floor (_tmp3_);
#line 602 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 602 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 602 "../lib/number.vala"
	t1 = _tmp5_;
#line 603 "../lib/number.vala"
	_tmp6_ = t1;
#line 603 "../lib/number.vala"
	_tmp7_ = number_multiply (_tmp6_, y);
#line 603 "../lib/number.vala"
	t2 = _tmp7_;
#line 604 "../lib/number.vala"
	_tmp8_ = t2;
#line 604 "../lib/number.vala"
	_tmp9_ = number_subtract (self, _tmp8_);
#line 604 "../lib/number.vala"
	z = _tmp9_;
#line 606 "../lib/number.vala"
	_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 606 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 606 "../lib/number.vala"
	t1 = _tmp10_;
#line 607 "../lib/number.vala"
	_tmp13_ = t1;
#line 607 "../lib/number.vala"
	if (number_compare (y, _tmp13_) < 0) {
#line 2256 "number.c"
		Number* _tmp14_;
		Number* _tmp15_;
#line 607 "../lib/number.vala"
		_tmp14_ = z;
#line 607 "../lib/number.vala"
		_tmp15_ = t1;
#line 607 "../lib/number.vala"
		_tmp12_ = number_compare (_tmp14_, _tmp15_) > 0;
#line 2265 "number.c"
	} else {
#line 607 "../lib/number.vala"
		_tmp12_ = FALSE;
#line 2269 "number.c"
	}
#line 607 "../lib/number.vala"
	if (_tmp12_) {
#line 607 "../lib/number.vala"
		_tmp11_ = TRUE;
#line 2275 "number.c"
	} else {
		gboolean _tmp16_ = FALSE;
		Number* _tmp17_;
#line 607 "../lib/number.vala"
		_tmp17_ = t1;
#line 607 "../lib/number.vala"
		if (number_compare (y, _tmp17_) > 0) {
#line 2283 "number.c"
			Number* _tmp18_;
			Number* _tmp19_;
#line 607 "../lib/number.vala"
			_tmp18_ = z;
#line 607 "../lib/number.vala"
			_tmp19_ = t1;
#line 607 "../lib/number.vala"
			_tmp16_ = number_compare (_tmp18_, _tmp19_) < 0;
#line 2292 "number.c"
		} else {
#line 607 "../lib/number.vala"
			_tmp16_ = FALSE;
#line 2296 "number.c"
		}
#line 607 "../lib/number.vala"
		_tmp11_ = _tmp16_;
#line 2300 "number.c"
	}
#line 607 "../lib/number.vala"
	if (_tmp11_) {
#line 2304 "number.c"
		Number* _tmp20_;
		Number* _tmp21_;
#line 608 "../lib/number.vala"
		_tmp20_ = z;
#line 608 "../lib/number.vala"
		_tmp21_ = number_add (_tmp20_, y);
#line 608 "../lib/number.vala"
		_g_object_unref0 (z);
#line 608 "../lib/number.vala"
		z = _tmp21_;
#line 2315 "number.c"
	}
#line 610 "../lib/number.vala"
	result = z;
#line 610 "../lib/number.vala"
	_g_object_unref0 (t2);
#line 610 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 610 "../lib/number.vala"
	return result;
#line 2325 "number.c"
}

Number*
number_modular_exponentiation (Number* self,
                               Number* exp,
                               Number* mod)
{
	Number* base_value = NULL;
	Number* _tmp0_;
	Number* exp_value = NULL;
	Number* _tmp3_;
	Number* ans = NULL;
	Number* _tmp4_;
	Number* two = NULL;
	Number* _tmp5_;
	Number* _tmp26_;
	Number* _tmp27_;
	Number* result;
#line 614 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 614 "../lib/number.vala"
	g_return_val_if_fail (exp != NULL, NULL);
#line 614 "../lib/number.vala"
	g_return_val_if_fail (mod != NULL, NULL);
#line 616 "../lib/number.vala"
	_tmp0_ = number_copy (self);
#line 616 "../lib/number.vala"
	base_value = _tmp0_;
#line 617 "../lib/number.vala"
	if (number_is_negative (exp)) {
#line 2356 "number.c"
		Number* _tmp1_;
		Number* _tmp2_;
#line 618 "../lib/number.vala"
		_tmp1_ = base_value;
#line 618 "../lib/number.vala"
		_tmp2_ = number_reciprocal (_tmp1_);
#line 618 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 618 "../lib/number.vala"
		base_value = _tmp2_;
#line 2367 "number.c"
	}
#line 619 "../lib/number.vala"
	_tmp3_ = number_abs (exp);
#line 619 "../lib/number.vala"
	exp_value = _tmp3_;
#line 620 "../lib/number.vala"
	_tmp4_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 620 "../lib/number.vala"
	ans = _tmp4_;
#line 621 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 621 "../lib/number.vala"
	two = _tmp5_;
#line 622 "../lib/number.vala"
	while (TRUE) {
#line 2383 "number.c"
		Number* _tmp6_;
		gboolean is_even = FALSE;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
		Number* _tmp10_;
		gboolean _tmp11_;
		Number* _tmp17_;
		Number* _tmp18_;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
		Number* _tmp25_;
#line 622 "../lib/number.vala"
		_tmp6_ = exp_value;
#line 622 "../lib/number.vala"
		if (!(!number_is_zero (_tmp6_))) {
#line 622 "../lib/number.vala"
			break;
#line 2406 "number.c"
		}
#line 624 "../lib/number.vala"
		_tmp7_ = exp_value;
#line 624 "../lib/number.vala"
		_tmp8_ = two;
#line 624 "../lib/number.vala"
		_tmp9_ = number_modulus_divide (_tmp7_, _tmp8_);
#line 624 "../lib/number.vala"
		_tmp10_ = _tmp9_;
#line 624 "../lib/number.vala"
		_tmp11_ = number_is_zero (_tmp10_);
#line 624 "../lib/number.vala"
		_g_object_unref0 (_tmp10_);
#line 624 "../lib/number.vala"
		is_even = _tmp11_;
#line 625 "../lib/number.vala"
		if (!is_even) {
#line 2424 "number.c"
			Number* _tmp12_;
			Number* _tmp13_;
			Number* _tmp14_;
			Number* _tmp15_;
			Number* _tmp16_;
#line 627 "../lib/number.vala"
			_tmp12_ = ans;
#line 627 "../lib/number.vala"
			_tmp13_ = base_value;
#line 627 "../lib/number.vala"
			_tmp14_ = number_multiply (_tmp12_, _tmp13_);
#line 627 "../lib/number.vala"
			_g_object_unref0 (ans);
#line 627 "../lib/number.vala"
			ans = _tmp14_;
#line 628 "../lib/number.vala"
			_tmp15_ = ans;
#line 628 "../lib/number.vala"
			_tmp16_ = number_modulus_divide (_tmp15_, mod);
#line 628 "../lib/number.vala"
			_g_object_unref0 (ans);
#line 628 "../lib/number.vala"
			ans = _tmp16_;
#line 2448 "number.c"
		}
#line 630 "../lib/number.vala"
		_tmp17_ = base_value;
#line 630 "../lib/number.vala"
		_tmp18_ = base_value;
#line 630 "../lib/number.vala"
		_tmp19_ = number_multiply (_tmp17_, _tmp18_);
#line 630 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 630 "../lib/number.vala"
		base_value = _tmp19_;
#line 631 "../lib/number.vala"
		_tmp20_ = base_value;
#line 631 "../lib/number.vala"
		_tmp21_ = number_modulus_divide (_tmp20_, mod);
#line 631 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 631 "../lib/number.vala"
		base_value = _tmp21_;
#line 632 "../lib/number.vala"
		_tmp22_ = exp_value;
#line 632 "../lib/number.vala"
		_tmp23_ = number_divide_integer (_tmp22_, (gint64) 2);
#line 632 "../lib/number.vala"
		_tmp24_ = _tmp23_;
#line 632 "../lib/number.vala"
		_tmp25_ = number_floor (_tmp24_);
#line 632 "../lib/number.vala"
		_g_object_unref0 (exp_value);
#line 632 "../lib/number.vala"
		exp_value = _tmp25_;
#line 632 "../lib/number.vala"
		_g_object_unref0 (_tmp24_);
#line 2482 "number.c"
	}
#line 634 "../lib/number.vala"
	_tmp26_ = ans;
#line 634 "../lib/number.vala"
	_tmp27_ = number_modulus_divide (_tmp26_, mod);
#line 634 "../lib/number.vala"
	result = _tmp27_;
#line 634 "../lib/number.vala"
	_g_object_unref0 (two);
#line 634 "../lib/number.vala"
	_g_object_unref0 (ans);
#line 634 "../lib/number.vala"
	_g_object_unref0 (exp_value);
#line 634 "../lib/number.vala"
	_g_object_unref0 (base_value);
#line 634 "../lib/number.vala"
	return result;
#line 2500 "number.c"
}

Number*
number_sin (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 638 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 640 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 640 "../lib/number.vala"
	z = _tmp0_;
#line 641 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2520 "number.c"
		Number* _tmp1_;
#line 642 "../lib/number.vala"
		_tmp1_ = z;
#line 642 "../lib/number.vala"
		mpc_set (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2526 "number.c"
	} else {
		Number* _tmp2_;
#line 644 "../lib/number.vala"
		_tmp2_ = z;
#line 644 "../lib/number.vala"
		number_mpc_to_radians (&_tmp2_->priv->num, &self->priv->num, unit);
#line 2533 "number.c"
	}
#line 645 "../lib/number.vala"
	_tmp3_ = z;
#line 645 "../lib/number.vala"
	_tmp4_ = z;
#line 645 "../lib/number.vala"
	mpc_sin (&_tmp3_->priv->num, &_tmp4_->priv->num, MPC_RNDNN);
#line 646 "../lib/number.vala"
	result = z;
#line 646 "../lib/number.vala"
	return result;
#line 2545 "number.c"
}

Number*
number_cos (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 650 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 652 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 652 "../lib/number.vala"
	z = _tmp0_;
#line 653 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2565 "number.c"
		Number* _tmp1_;
#line 654 "../lib/number.vala"
		_tmp1_ = z;
#line 654 "../lib/number.vala"
		mpc_set (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2571 "number.c"
	} else {
		Number* _tmp2_;
#line 656 "../lib/number.vala"
		_tmp2_ = z;
#line 656 "../lib/number.vala"
		number_mpc_to_radians (&_tmp2_->priv->num, &self->priv->num, unit);
#line 2578 "number.c"
	}
#line 657 "../lib/number.vala"
	_tmp3_ = z;
#line 657 "../lib/number.vala"
	_tmp4_ = z;
#line 657 "../lib/number.vala"
	mpc_cos (&_tmp3_->priv->num, &_tmp4_->priv->num, MPC_RNDNN);
#line 658 "../lib/number.vala"
	result = z;
#line 658 "../lib/number.vala"
	return result;
#line 2590 "number.c"
}

Number*
number_tan (Number* self,
            AngleUnit unit)
{
	Number* x_radians = NULL;
	Number* _tmp0_;
	Number* check = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* z = NULL;
	Number* _tmp14_;
	Number* _tmp17_;
	Number* _tmp18_;
	Number* result;
#line 662 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 665 "../lib/number.vala"
	_tmp0_ = number_to_radians (self, unit);
#line 665 "../lib/number.vala"
	x_radians = _tmp0_;
#line 666 "../lib/number.vala"
	_tmp1_ = x_radians;
#line 666 "../lib/number.vala"
	_tmp2_ = number_new_pi ();
#line 666 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 666 "../lib/number.vala"
	_tmp4_ = number_divide_integer (_tmp3_, (gint64) 2);
#line 666 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 666 "../lib/number.vala"
	_tmp6_ = number_subtract (_tmp1_, _tmp5_);
#line 666 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 666 "../lib/number.vala"
	_tmp8_ = number_new_pi ();
#line 666 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 666 "../lib/number.vala"
	_tmp10_ = number_divide (_tmp7_, _tmp9_);
#line 666 "../lib/number.vala"
	_tmp11_ = _tmp10_;
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp9_);
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp7_);
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 666 "../lib/number.vala"
	check = _tmp11_;
#line 668 "../lib/number.vala"
	_tmp12_ = check;
#line 668 "../lib/number.vala"
	if (number_is_integer (_tmp12_)) {
#line 2659 "number.c"
		Number* _tmp13_;
#line 671 "../lib/number.vala"
		number_set_error (_ ("Tangent is undefined for angles that are multiples of π (180°) from π∕" \
"2 (90°)"));
#line 672 "../lib/number.vala"
		_tmp13_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 672 "../lib/number.vala"
		result = _tmp13_;
#line 672 "../lib/number.vala"
		_g_object_unref0 (check);
#line 672 "../lib/number.vala"
		_g_object_unref0 (x_radians);
#line 672 "../lib/number.vala"
		return result;
#line 2673 "number.c"
	}
#line 675 "../lib/number.vala"
	_tmp14_ = number_new ();
#line 675 "../lib/number.vala"
	z = _tmp14_;
#line 676 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2681 "number.c"
		Number* _tmp15_;
#line 677 "../lib/number.vala"
		_tmp15_ = z;
#line 677 "../lib/number.vala"
		mpc_set (&_tmp15_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2687 "number.c"
	} else {
		Number* _tmp16_;
#line 679 "../lib/number.vala"
		_tmp16_ = z;
#line 679 "../lib/number.vala"
		number_mpc_to_radians (&_tmp16_->priv->num, &self->priv->num, unit);
#line 2694 "number.c"
	}
#line 680 "../lib/number.vala"
	_tmp17_ = z;
#line 680 "../lib/number.vala"
	_tmp18_ = z;
#line 680 "../lib/number.vala"
	mpc_tan (&_tmp17_->priv->num, &_tmp18_->priv->num, MPC_RNDNN);
#line 681 "../lib/number.vala"
	result = z;
#line 681 "../lib/number.vala"
	_g_object_unref0 (check);
#line 681 "../lib/number.vala"
	_g_object_unref0 (x_radians);
#line 681 "../lib/number.vala"
	return result;
#line 2710 "number.c"
}

Number*
number_asin (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 685 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 687 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 687 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 687 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) > 0;
#line 687 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 687 "../lib/number.vala"
	if (_tmp3_) {
#line 687 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2740 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 687 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 687 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 687 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) < 0;
#line 687 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 2752 "number.c"
	}
#line 687 "../lib/number.vala"
	if (_tmp0_) {
#line 2756 "number.c"
		Number* _tmp6_;
#line 690 "../lib/number.vala"
		number_set_error (_ ("Inverse sine is undefined for values outside [-1, 1]"));
#line 691 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 691 "../lib/number.vala"
		result = _tmp6_;
#line 691 "../lib/number.vala"
		return result;
#line 2766 "number.c"
	}
#line 694 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 694 "../lib/number.vala"
	z = _tmp7_;
#line 695 "../lib/number.vala"
	_tmp8_ = z;
#line 695 "../lib/number.vala"
	mpc_asin (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 696 "../lib/number.vala"
	_tmp9_ = z;
#line 696 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 2780 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 697 "../lib/number.vala"
		_tmp10_ = z;
#line 697 "../lib/number.vala"
		_tmp11_ = z;
#line 697 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 2789 "number.c"
	}
#line 698 "../lib/number.vala"
	result = z;
#line 698 "../lib/number.vala"
	return result;
#line 2795 "number.c"
}

Number*
number_acos (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 702 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 704 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 704 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 704 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) > 0;
#line 704 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 704 "../lib/number.vala"
	if (_tmp3_) {
#line 704 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2825 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 704 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 704 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 704 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) < 0;
#line 704 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 2837 "number.c"
	}
#line 704 "../lib/number.vala"
	if (_tmp0_) {
#line 2841 "number.c"
		Number* _tmp6_;
#line 707 "../lib/number.vala"
		number_set_error (_ ("Inverse cosine is undefined for values outside [-1, 1]"));
#line 708 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 708 "../lib/number.vala"
		result = _tmp6_;
#line 708 "../lib/number.vala"
		return result;
#line 2851 "number.c"
	}
#line 711 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 711 "../lib/number.vala"
	z = _tmp7_;
#line 712 "../lib/number.vala"
	_tmp8_ = z;
#line 712 "../lib/number.vala"
	mpc_acos (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 713 "../lib/number.vala"
	_tmp9_ = z;
#line 713 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 2865 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 714 "../lib/number.vala"
		_tmp10_ = z;
#line 714 "../lib/number.vala"
		_tmp11_ = z;
#line 714 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 2874 "number.c"
	}
#line 715 "../lib/number.vala"
	result = z;
#line 715 "../lib/number.vala"
	return result;
#line 2880 "number.c"
}

Number*
number_atan (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 719 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 722 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 0, (gint64) 1);
#line 722 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 722 "../lib/number.vala"
	_tmp3_ = number_equals (self, _tmp2_);
#line 722 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 722 "../lib/number.vala"
	if (_tmp3_) {
#line 722 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2910 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 722 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) 0, (gint64) -1);
#line 722 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 722 "../lib/number.vala"
		_tmp0_ = number_equals (self, _tmp5_);
#line 722 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 2922 "number.c"
	}
#line 722 "../lib/number.vala"
	if (_tmp0_) {
#line 2926 "number.c"
		Number* _tmp6_;
#line 725 "../lib/number.vala"
		number_set_error (_ ("Arctangent function is undefined for values i and -i"));
#line 726 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 726 "../lib/number.vala"
		result = _tmp6_;
#line 726 "../lib/number.vala"
		return result;
#line 2936 "number.c"
	}
#line 728 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 728 "../lib/number.vala"
	z = _tmp7_;
#line 729 "../lib/number.vala"
	_tmp8_ = z;
#line 729 "../lib/number.vala"
	mpc_atan (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 730 "../lib/number.vala"
	_tmp9_ = z;
#line 730 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 2950 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 731 "../lib/number.vala"
		_tmp10_ = z;
#line 731 "../lib/number.vala"
		_tmp11_ = z;
#line 731 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 2959 "number.c"
	}
#line 732 "../lib/number.vala"
	result = z;
#line 732 "../lib/number.vala"
	return result;
#line 2965 "number.c"
}

Number*
number_sinh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 736 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 738 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 738 "../lib/number.vala"
	z = _tmp0_;
#line 739 "../lib/number.vala"
	mpc_sinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 740 "../lib/number.vala"
	result = z;
#line 740 "../lib/number.vala"
	return result;
#line 2986 "number.c"
}

Number*
number_cosh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 744 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 746 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 746 "../lib/number.vala"
	z = _tmp0_;
#line 747 "../lib/number.vala"
	mpc_cosh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 748 "../lib/number.vala"
	result = z;
#line 748 "../lib/number.vala"
	return result;
#line 3007 "number.c"
}

Number*
number_tanh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 752 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 754 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 754 "../lib/number.vala"
	z = _tmp0_;
#line 755 "../lib/number.vala"
	mpc_tanh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 756 "../lib/number.vala"
	result = z;
#line 756 "../lib/number.vala"
	return result;
#line 3028 "number.c"
}

Number*
number_asinh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 760 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 762 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 762 "../lib/number.vala"
	z = _tmp0_;
#line 763 "../lib/number.vala"
	mpc_asinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 764 "../lib/number.vala"
	result = z;
#line 764 "../lib/number.vala"
	return result;
#line 3049 "number.c"
}

Number*
number_acosh (Number* self)
{
	Number* t = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* z = NULL;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 768 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 771 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 771 "../lib/number.vala"
	t = _tmp0_;
#line 772 "../lib/number.vala"
	_tmp1_ = t;
#line 772 "../lib/number.vala"
	if (number_compare (self, _tmp1_) < 0) {
#line 3072 "number.c"
		Number* _tmp2_;
#line 775 "../lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic cosine is undefined for values less than one"));
#line 776 "../lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 776 "../lib/number.vala"
		result = _tmp2_;
#line 776 "../lib/number.vala"
		_g_object_unref0 (t);
#line 776 "../lib/number.vala"
		return result;
#line 3084 "number.c"
	}
#line 779 "../lib/number.vala"
	_tmp3_ = number_new ();
#line 779 "../lib/number.vala"
	z = _tmp3_;
#line 780 "../lib/number.vala"
	_tmp4_ = z;
#line 780 "../lib/number.vala"
	mpc_acosh (&_tmp4_->priv->num, &self->priv->num, MPC_RNDNN);
#line 781 "../lib/number.vala"
	result = z;
#line 781 "../lib/number.vala"
	_g_object_unref0 (t);
#line 781 "../lib/number.vala"
	return result;
#line 3100 "number.c"
}

Number*
number_atanh (Number* self)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* result;
#line 785 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 788 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 788 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 788 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) >= 0;
#line 788 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 788 "../lib/number.vala"
	if (_tmp3_) {
#line 788 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3128 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 788 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 788 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 788 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) <= 0;
#line 788 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 3140 "number.c"
	}
#line 788 "../lib/number.vala"
	if (_tmp0_) {
#line 3144 "number.c"
		Number* _tmp6_;
#line 791 "../lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic tangent is undefined for values outside [-1, 1]"));
#line 792 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 792 "../lib/number.vala"
		result = _tmp6_;
#line 792 "../lib/number.vala"
		return result;
#line 3154 "number.c"
	}
#line 795 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 795 "../lib/number.vala"
	z = _tmp7_;
#line 796 "../lib/number.vala"
	_tmp8_ = z;
#line 796 "../lib/number.vala"
	mpc_atanh (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 797 "../lib/number.vala"
	result = z;
#line 797 "../lib/number.vala"
	return result;
#line 3168 "number.c"
}

static gint
__lambda4_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 810 "../lib/number.vala"
	result = v1 & v2;
#line 810 "../lib/number.vala"
	return result;
#line 3181 "number.c"
}

static gint
___lambda4__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda4_ ((Number*) self, v1, v2);
#line 810 "../lib/number.vala"
	return result;
#line 3193 "number.c"
}

Number*
number_and (Number* self,
            Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 801 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 801 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 803 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 803 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3211 "number.c"
	} else {
#line 804 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3215 "number.c"
	}
#line 803 "../lib/number.vala"
	if (_tmp0_) {
#line 807 "../lib/number.vala"
		number_set_error (_ ("Boolean AND is only defined for positive integers"));
#line 3221 "number.c"
	}
#line 810 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda4__bitwise_func, self, 0);
#line 810 "../lib/number.vala"
	result = _tmp1_;
#line 810 "../lib/number.vala"
	return result;
#line 3229 "number.c"
}

static gint
__lambda5_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 822 "../lib/number.vala"
	result = v1 | v2;
#line 822 "../lib/number.vala"
	return result;
#line 3242 "number.c"
}

static gint
___lambda5__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda5_ ((Number*) self, v1, v2);
#line 822 "../lib/number.vala"
	return result;
#line 3254 "number.c"
}

Number*
number_or (Number* self,
           Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 814 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 814 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 816 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 816 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3272 "number.c"
	} else {
#line 816 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3276 "number.c"
	}
#line 816 "../lib/number.vala"
	if (_tmp0_) {
#line 819 "../lib/number.vala"
		number_set_error (_ ("Boolean OR is only defined for positive integers"));
#line 3282 "number.c"
	}
#line 822 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda5__bitwise_func, self, 0);
#line 822 "../lib/number.vala"
	result = _tmp1_;
#line 822 "../lib/number.vala"
	return result;
#line 3290 "number.c"
}

static gint
__lambda6_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 834 "../lib/number.vala"
	result = v1 ^ v2;
#line 834 "../lib/number.vala"
	return result;
#line 3303 "number.c"
}

static gint
___lambda6__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda6_ ((Number*) self, v1, v2);
#line 834 "../lib/number.vala"
	return result;
#line 3315 "number.c"
}

Number*
number_xor (Number* self,
            Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 826 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 826 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 828 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 828 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3333 "number.c"
	} else {
#line 828 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3337 "number.c"
	}
#line 828 "../lib/number.vala"
	if (_tmp0_) {
#line 831 "../lib/number.vala"
		number_set_error (_ ("Boolean XOR is only defined for positive integers"));
#line 3343 "number.c"
	}
#line 834 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda6__bitwise_func, self, 0);
#line 834 "../lib/number.vala"
	result = _tmp1_;
#line 834 "../lib/number.vala"
	return result;
#line 3351 "number.c"
}

static gint
__lambda7_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 846 "../lib/number.vala"
	result = v1 ^ 0xF;
#line 846 "../lib/number.vala"
	return result;
#line 3364 "number.c"
}

static gint
___lambda7__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda7_ ((Number*) self, v1, v2);
#line 846 "../lib/number.vala"
	return result;
#line 3376 "number.c"
}

Number*
number_not (Number* self,
            gint wordlen)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 838 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 840 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 843 "../lib/number.vala"
		number_set_error (_ ("Boolean NOT is only defined for positive integers"));
#line 3394 "number.c"
	}
#line 846 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 846 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 846 "../lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda7__bitwise_func, self, wordlen);
#line 846 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 846 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 846 "../lib/number.vala"
	result = _tmp3_;
#line 846 "../lib/number.vala"
	return result;
#line 3410 "number.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 3433 "number.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 3442 "number.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 3461 "number.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3465 "number.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 3471 "number.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 3481 "number.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 3489 "number.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 3493 "number.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 3499 "number.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 3509 "number.c"
}

Number*
number_mask (Number* self,
             Number* x,
             gint wordlen)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gint len = 0;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint offset = 0;
	gint _tmp4_ = 0;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 850 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 850 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 853 "../lib/number.vala"
	_tmp0_ = number_to_hex_string (x);
#line 853 "../lib/number.vala"
	text = _tmp0_;
#line 854 "../lib/number.vala"
	_tmp1_ = text;
#line 854 "../lib/number.vala"
	_tmp2_ = strlen (_tmp1_);
#line 854 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 854 "../lib/number.vala"
	len = _tmp3_;
#line 855 "../lib/number.vala"
	offset = wordlen / 4;
#line 856 "../lib/number.vala"
	if (len > offset) {
#line 856 "../lib/number.vala"
		_tmp4_ = ((gint) len) - offset;
#line 3553 "number.c"
	} else {
#line 856 "../lib/number.vala"
		_tmp4_ = 0;
#line 3557 "number.c"
	}
#line 856 "../lib/number.vala"
	offset = _tmp4_;
#line 857 "../lib/number.vala"
	_tmp5_ = text;
#line 857 "../lib/number.vala"
	_tmp6_ = string_substring (_tmp5_, (glong) offset, (glong) -1);
#line 857 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 857 "../lib/number.vala"
	_tmp8_ = mp_set_from_string (_tmp7_, 16);
#line 857 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 857 "../lib/number.vala"
	_g_free0 (_tmp7_);
#line 857 "../lib/number.vala"
	result = _tmp9_;
#line 857 "../lib/number.vala"
	_g_free0 (text);
#line 857 "../lib/number.vala"
	return result;
#line 3579 "number.c"
}

Number*
number_shift (Number* self,
              gint64 count)
{
	Number* result;
#line 861 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 863 "../lib/number.vala"
	if (!number_is_integer (self)) {
#line 3591 "number.c"
		Number* _tmp0_;
#line 866 "../lib/number.vala"
		number_set_error (_ ("Shift is only possible on integer values"));
#line 867 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 867 "../lib/number.vala"
		result = _tmp0_;
#line 867 "../lib/number.vala"
		return result;
#line 3601 "number.c"
	}
#line 870 "../lib/number.vala"
	if (count >= ((gint64) 0)) {
#line 3605 "number.c"
		gint multiplier = 0;
		Number* _tmp3_;
#line 872 "../lib/number.vala"
		multiplier = 1;
#line 3610 "number.c"
		{
			gint i = 0;
#line 873 "../lib/number.vala"
			i = 0;
#line 3615 "number.c"
			{
				gboolean _tmp1_ = FALSE;
#line 873 "../lib/number.vala"
				_tmp1_ = TRUE;
#line 873 "../lib/number.vala"
				while (TRUE) {
#line 873 "../lib/number.vala"
					if (!_tmp1_) {
#line 3624 "number.c"
						gint _tmp2_;
#line 873 "../lib/number.vala"
						_tmp2_ = i;
#line 873 "../lib/number.vala"
						i = _tmp2_ + 1;
#line 3630 "number.c"
					}
#line 873 "../lib/number.vala"
					_tmp1_ = FALSE;
#line 873 "../lib/number.vala"
					if (!(((gint64) i) < count)) {
#line 873 "../lib/number.vala"
						break;
#line 3638 "number.c"
					}
#line 874 "../lib/number.vala"
					multiplier *= 2;
#line 3642 "number.c"
				}
			}
		}
#line 875 "../lib/number.vala"
		_tmp3_ = number_multiply_integer (self, (gint64) multiplier);
#line 875 "../lib/number.vala"
		result = _tmp3_;
#line 875 "../lib/number.vala"
		return result;
#line 3652 "number.c"
	} else {
		gint multiplier = 0;
		Number* _tmp6_;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
#line 879 "../lib/number.vala"
		multiplier = 1;
#line 3661 "number.c"
		{
			gint i = 0;
#line 880 "../lib/number.vala"
			i = 0;
#line 3666 "number.c"
			{
				gboolean _tmp4_ = FALSE;
#line 880 "../lib/number.vala"
				_tmp4_ = TRUE;
#line 880 "../lib/number.vala"
				while (TRUE) {
#line 880 "../lib/number.vala"
					if (!_tmp4_) {
#line 3675 "number.c"
						gint _tmp5_;
#line 880 "../lib/number.vala"
						_tmp5_ = i;
#line 880 "../lib/number.vala"
						i = _tmp5_ + 1;
#line 3681 "number.c"
					}
#line 880 "../lib/number.vala"
					_tmp4_ = FALSE;
#line 880 "../lib/number.vala"
					if (!(((gint64) i) < (-count))) {
#line 880 "../lib/number.vala"
						break;
#line 3689 "number.c"
					}
#line 881 "../lib/number.vala"
					multiplier *= 2;
#line 3693 "number.c"
				}
			}
		}
#line 882 "../lib/number.vala"
		_tmp6_ = number_divide_integer (self, (gint64) multiplier);
#line 882 "../lib/number.vala"
		_tmp7_ = _tmp6_;
#line 882 "../lib/number.vala"
		_tmp8_ = number_floor (_tmp7_);
#line 882 "../lib/number.vala"
		_tmp9_ = _tmp8_;
#line 882 "../lib/number.vala"
		_g_object_unref0 (_tmp7_);
#line 882 "../lib/number.vala"
		result = _tmp9_;
#line 882 "../lib/number.vala"
		return result;
#line 3711 "number.c"
	}
}

static gint
__lambda8_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 889 "../lib/number.vala"
	result = v1 ^ v2;
#line 889 "../lib/number.vala"
	return result;
#line 3725 "number.c"
}

static gint
___lambda8__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda8_ ((Number*) self, v1, v2);
#line 889 "../lib/number.vala"
	return result;
#line 3737 "number.c"
}

Number*
number_ones_complement (Number* self,
                        gint wordlen)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 887 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 889 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 889 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 889 "../lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda8__bitwise_func, self, wordlen);
#line 889 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 889 "../lib/number.vala"
	_tmp4_ = number_not (_tmp3_, wordlen);
#line 889 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 889 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 889 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 889 "../lib/number.vala"
	result = _tmp5_;
#line 889 "../lib/number.vala"
	return result;
#line 3773 "number.c"
}

Number*
number_twos_complement (Number* self,
                        gint wordlen)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 893 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 895 "../lib/number.vala"
	_tmp0_ = number_ones_complement (self, wordlen);
#line 895 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 895 "../lib/number.vala"
	_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 895 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 895 "../lib/number.vala"
	_tmp4_ = number_add (_tmp1_, _tmp3_);
#line 895 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 895 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 895 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 895 "../lib/number.vala"
	result = _tmp5_;
#line 895 "../lib/number.vala"
	return result;
#line 3809 "number.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 929 "../lib/number.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3817 "number.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 929 "../lib/number.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 3825 "number.c"
}

GList*
number_factorize (Number* self)
{
	GList* factors = NULL;
	Number* value = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	gboolean _tmp7_;
	guint64 num = 0ULL;
	Number* int_max = NULL;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* divisor = NULL;
	Number* _tmp18_;
	Number* _tmp27_;
	Number* root = NULL;
	Number* _tmp28_;
	Number* _tmp29_;
	Number* _tmp48_;
	Number* _tmp49_;
	Number* _tmp50_;
	gboolean _tmp51_;
	GList* result;
#line 899 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 901 "../lib/number.vala"
	factors = NULL;
#line 903 "../lib/number.vala"
	_tmp0_ = number_abs (self);
#line 903 "../lib/number.vala"
	value = _tmp0_;
#line 905 "../lib/number.vala"
	_tmp1_ = value;
#line 905 "../lib/number.vala"
	if (number_is_zero (_tmp1_)) {
#line 3867 "number.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 907 "../lib/number.vala"
		_tmp2_ = value;
#line 907 "../lib/number.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 907 "../lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 908 "../lib/number.vala"
		result = factors;
#line 908 "../lib/number.vala"
		_g_object_unref0 (value);
#line 908 "../lib/number.vala"
		return result;
#line 3882 "number.c"
	}
#line 911 "../lib/number.vala"
	_tmp4_ = value;
#line 911 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 911 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 911 "../lib/number.vala"
	_tmp7_ = number_equals (_tmp4_, _tmp6_);
#line 911 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 911 "../lib/number.vala"
	if (_tmp7_) {
#line 3896 "number.c"
		Number* _tmp8_;
#line 913 "../lib/number.vala"
		_tmp8_ = _g_object_ref0 (self);
#line 913 "../lib/number.vala"
		factors = g_list_append (factors, _tmp8_);
#line 914 "../lib/number.vala"
		result = factors;
#line 914 "../lib/number.vala"
		_g_object_unref0 (value);
#line 914 "../lib/number.vala"
		return result;
#line 3908 "number.c"
	}
#line 919 "../lib/number.vala"
	num = (guint64) 1;
#line 920 "../lib/number.vala"
	num = num << 63;
#line 921 "../lib/number.vala"
	num += num - 1;
#line 922 "../lib/number.vala"
	_tmp9_ = number_new_unsigned_integer (num, (guint64) 0);
#line 922 "../lib/number.vala"
	int_max = _tmp9_;
#line 924 "../lib/number.vala"
	_tmp10_ = value;
#line 924 "../lib/number.vala"
	_tmp11_ = int_max;
#line 924 "../lib/number.vala"
	if (number_compare (_tmp10_, _tmp11_) <= 0) {
#line 3926 "number.c"
		GList* factors_int64 = NULL;
		Number* _tmp12_;
		GList* _tmp13_;
#line 926 "../lib/number.vala"
		_tmp12_ = value;
#line 926 "../lib/number.vala"
		_tmp13_ = number_factorize_uint64 (self, number_to_unsigned_integer (_tmp12_));
#line 926 "../lib/number.vala"
		factors_int64 = _tmp13_;
#line 927 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 3938 "number.c"
			GList* _tmp14_;
			GList* _tmp15_;
			gconstpointer _tmp16_;
			Number* _tmp17_;
#line 928 "../lib/number.vala"
			_tmp14_ = factors_int64;
#line 928 "../lib/number.vala"
			_tmp15_ = factors_int64;
#line 928 "../lib/number.vala"
			_tmp16_ = _tmp15_->data;
#line 928 "../lib/number.vala"
			_tmp17_ = number_invert_sign ((Number*) _tmp16_);
#line 928 "../lib/number.vala"
			_g_object_unref0 (_tmp14_->data);
#line 928 "../lib/number.vala"
			_tmp14_->data = _tmp17_;
#line 3955 "number.c"
		}
#line 929 "../lib/number.vala"
		result = factors_int64;
#line 929 "../lib/number.vala"
		_g_object_unref0 (int_max);
#line 929 "../lib/number.vala"
		_g_object_unref0 (value);
#line 929 "../lib/number.vala"
		(factors == NULL) ? NULL : (factors = (_g_list_free__g_object_unref0_ (factors), NULL));
#line 929 "../lib/number.vala"
		return result;
#line 3967 "number.c"
	}
#line 932 "../lib/number.vala"
	_tmp18_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 932 "../lib/number.vala"
	divisor = _tmp18_;
#line 933 "../lib/number.vala"
	while (TRUE) {
#line 3975 "number.c"
		Number* tmp = NULL;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
#line 935 "../lib/number.vala"
		_tmp19_ = value;
#line 935 "../lib/number.vala"
		_tmp20_ = divisor;
#line 935 "../lib/number.vala"
		_tmp21_ = number_divide (_tmp19_, _tmp20_);
#line 935 "../lib/number.vala"
		tmp = _tmp21_;
#line 936 "../lib/number.vala"
		_tmp22_ = tmp;
#line 936 "../lib/number.vala"
		if (number_is_integer (_tmp22_)) {
#line 3993 "number.c"
			Number* _tmp23_;
			Number* _tmp24_;
			Number* _tmp25_;
			Number* _tmp26_;
#line 938 "../lib/number.vala"
			_tmp23_ = tmp;
#line 938 "../lib/number.vala"
			_tmp24_ = _g_object_ref0 (_tmp23_);
#line 938 "../lib/number.vala"
			_g_object_unref0 (value);
#line 938 "../lib/number.vala"
			value = _tmp24_;
#line 939 "../lib/number.vala"
			_tmp25_ = divisor;
#line 939 "../lib/number.vala"
			_tmp26_ = _g_object_ref0 (_tmp25_);
#line 939 "../lib/number.vala"
			factors = g_list_append (factors, _tmp26_);
#line 4012 "number.c"
		} else {
#line 942 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 942 "../lib/number.vala"
			break;
#line 4018 "number.c"
		}
#line 933 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 4022 "number.c"
	}
#line 945 "../lib/number.vala"
	_tmp27_ = number_new_integer ((gint64) 3, (gint64) 0);
#line 945 "../lib/number.vala"
	_g_object_unref0 (divisor);
#line 945 "../lib/number.vala"
	divisor = _tmp27_;
#line 946 "../lib/number.vala"
	_tmp28_ = value;
#line 946 "../lib/number.vala"
	_tmp29_ = number_sqrt (_tmp28_);
#line 946 "../lib/number.vala"
	root = _tmp29_;
#line 947 "../lib/number.vala"
	while (TRUE) {
#line 4038 "number.c"
		Number* _tmp30_;
		Number* _tmp31_;
		Number* tmp = NULL;
		Number* _tmp32_;
		Number* _tmp33_;
		Number* _tmp34_;
		Number* _tmp35_;
#line 947 "../lib/number.vala"
		_tmp30_ = divisor;
#line 947 "../lib/number.vala"
		_tmp31_ = root;
#line 947 "../lib/number.vala"
		if (!(number_compare (_tmp30_, _tmp31_) <= 0)) {
#line 947 "../lib/number.vala"
			break;
#line 4054 "number.c"
		}
#line 949 "../lib/number.vala"
		_tmp32_ = value;
#line 949 "../lib/number.vala"
		_tmp33_ = divisor;
#line 949 "../lib/number.vala"
		_tmp34_ = number_divide (_tmp32_, _tmp33_);
#line 949 "../lib/number.vala"
		tmp = _tmp34_;
#line 950 "../lib/number.vala"
		_tmp35_ = tmp;
#line 950 "../lib/number.vala"
		if (number_is_integer (_tmp35_)) {
#line 4068 "number.c"
			Number* _tmp36_;
			Number* _tmp37_;
			Number* _tmp38_;
			Number* _tmp39_;
			Number* _tmp40_;
			Number* _tmp41_;
#line 952 "../lib/number.vala"
			_tmp36_ = tmp;
#line 952 "../lib/number.vala"
			_tmp37_ = _g_object_ref0 (_tmp36_);
#line 952 "../lib/number.vala"
			_g_object_unref0 (value);
#line 952 "../lib/number.vala"
			value = _tmp37_;
#line 953 "../lib/number.vala"
			_tmp38_ = value;
#line 953 "../lib/number.vala"
			_tmp39_ = number_sqrt (_tmp38_);
#line 953 "../lib/number.vala"
			_g_object_unref0 (root);
#line 953 "../lib/number.vala"
			root = _tmp39_;
#line 954 "../lib/number.vala"
			_tmp40_ = divisor;
#line 954 "../lib/number.vala"
			_tmp41_ = _g_object_ref0 (_tmp40_);
#line 954 "../lib/number.vala"
			factors = g_list_append (factors, _tmp41_);
#line 4097 "number.c"
		} else {
			Number* _tmp42_;
			Number* _tmp43_;
			Number* _tmp44_;
			Number* _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
#line 958 "../lib/number.vala"
			_tmp42_ = divisor;
#line 958 "../lib/number.vala"
			_tmp43_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 958 "../lib/number.vala"
			_tmp44_ = _tmp43_;
#line 958 "../lib/number.vala"
			_tmp45_ = number_add (_tmp42_, _tmp44_);
#line 958 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 958 "../lib/number.vala"
			tmp = _tmp45_;
#line 958 "../lib/number.vala"
			_g_object_unref0 (_tmp44_);
#line 959 "../lib/number.vala"
			_tmp46_ = tmp;
#line 959 "../lib/number.vala"
			_tmp47_ = _g_object_ref0 (_tmp46_);
#line 959 "../lib/number.vala"
			_g_object_unref0 (divisor);
#line 959 "../lib/number.vala"
			divisor = _tmp47_;
#line 4127 "number.c"
		}
#line 947 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 4131 "number.c"
	}
#line 963 "../lib/number.vala"
	_tmp48_ = value;
#line 963 "../lib/number.vala"
	_tmp49_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 963 "../lib/number.vala"
	_tmp50_ = _tmp49_;
#line 963 "../lib/number.vala"
	_tmp51_ = number_compare (_tmp48_, _tmp50_) > 0;
#line 963 "../lib/number.vala"
	_g_object_unref0 (_tmp50_);
#line 963 "../lib/number.vala"
	if (_tmp51_) {
#line 4145 "number.c"
		Number* _tmp52_;
		Number* _tmp53_;
#line 964 "../lib/number.vala"
		_tmp52_ = value;
#line 964 "../lib/number.vala"
		_tmp53_ = _g_object_ref0 (_tmp52_);
#line 964 "../lib/number.vala"
		factors = g_list_append (factors, _tmp53_);
#line 4154 "number.c"
	}
#line 966 "../lib/number.vala"
	if (number_is_negative (self)) {
#line 4158 "number.c"
		GList* _tmp54_;
		GList* _tmp55_;
		gconstpointer _tmp56_;
		Number* _tmp57_;
#line 967 "../lib/number.vala"
		_tmp54_ = factors;
#line 967 "../lib/number.vala"
		_tmp55_ = factors;
#line 967 "../lib/number.vala"
		_tmp56_ = _tmp55_->data;
#line 967 "../lib/number.vala"
		_tmp57_ = number_invert_sign ((Number*) _tmp56_);
#line 967 "../lib/number.vala"
		_g_object_unref0 (_tmp54_->data);
#line 967 "../lib/number.vala"
		_tmp54_->data = _tmp57_;
#line 4175 "number.c"
	}
#line 969 "../lib/number.vala"
	result = factors;
#line 969 "../lib/number.vala"
	_g_object_unref0 (root);
#line 969 "../lib/number.vala"
	_g_object_unref0 (divisor);
#line 969 "../lib/number.vala"
	_g_object_unref0 (int_max);
#line 969 "../lib/number.vala"
	_g_object_unref0 (value);
#line 969 "../lib/number.vala"
	return result;
#line 4189 "number.c"
}

GList*
number_factorize_uint64 (Number* self,
                         guint64 n)
{
	GList* factors = NULL;
	GList* result;
#line 972 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 974 "../lib/number.vala"
	factors = NULL;
#line 975 "../lib/number.vala"
	while (TRUE) {
#line 4204 "number.c"
		Number* _tmp0_;
#line 975 "../lib/number.vala"
		if (!((n % 2) == ((guint64) 0))) {
#line 975 "../lib/number.vala"
			break;
#line 4210 "number.c"
		}
#line 977 "../lib/number.vala"
		n = n / 2;
#line 978 "../lib/number.vala"
		_tmp0_ = number_new_unsigned_integer ((guint64) 2, (guint64) 0);
#line 978 "../lib/number.vala"
		factors = g_list_append (factors, _tmp0_);
#line 4218 "number.c"
	}
	{
		guint64 divisor = 0ULL;
#line 981 "../lib/number.vala"
		divisor = (guint64) 3;
#line 4224 "number.c"
		{
			gboolean _tmp1_ = FALSE;
#line 981 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 981 "../lib/number.vala"
			while (TRUE) {
#line 981 "../lib/number.vala"
				if (!_tmp1_) {
#line 981 "../lib/number.vala"
					divisor += (guint64) 2;
#line 4235 "number.c"
				}
#line 981 "../lib/number.vala"
				_tmp1_ = FALSE;
#line 981 "../lib/number.vala"
				if (!(divisor <= (n / divisor))) {
#line 981 "../lib/number.vala"
					break;
#line 4243 "number.c"
				}
#line 983 "../lib/number.vala"
				while (TRUE) {
#line 4247 "number.c"
					Number* _tmp2_;
#line 983 "../lib/number.vala"
					if (!((n % divisor) == ((guint64) 0))) {
#line 983 "../lib/number.vala"
						break;
#line 4253 "number.c"
					}
#line 985 "../lib/number.vala"
					n = n / divisor;
#line 986 "../lib/number.vala"
					_tmp2_ = number_new_unsigned_integer (divisor, (guint64) 0);
#line 986 "../lib/number.vala"
					factors = g_list_append (factors, _tmp2_);
#line 4261 "number.c"
				}
			}
		}
	}
#line 990 "../lib/number.vala"
	if (n > ((guint64) 1)) {
#line 4268 "number.c"
		Number* _tmp3_;
#line 991 "../lib/number.vala"
		_tmp3_ = number_new_unsigned_integer (n, (guint64) 0);
#line 991 "../lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 4274 "number.c"
	}
#line 992 "../lib/number.vala"
	result = factors;
#line 992 "../lib/number.vala"
	return result;
#line 4280 "number.c"
}

static Number*
number_copy (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 995 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 997 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 997 "../lib/number.vala"
	z = _tmp0_;
#line 998 "../lib/number.vala"
	mpc_set (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 999 "../lib/number.vala"
	result = z;
#line 999 "../lib/number.vala"
	return result;
#line 4301 "number.c"
}

static gboolean
_mpc_equal (const __mpc_struct * s1,
            const __mpc_struct * s2)
{
#line 1010 "../lib/number.vala"
	if (s1 == s2) {
#line 1010 "../lib/number.vala"
		return TRUE;
#line 4312 "number.c"
	}
#line 1010 "../lib/number.vala"
	if (s1 == NULL) {
#line 1010 "../lib/number.vala"
		return FALSE;
#line 4318 "number.c"
	}
#line 1010 "../lib/number.vala"
	if (s2 == NULL) {
#line 1010 "../lib/number.vala"
		return FALSE;
#line 4324 "number.c"
	}
#line 1010 "../lib/number.vala"
	return FALSE;
#line 4328 "number.c"
}

static void
number_mpc_from_radians (__mpc_struct* res,
                         __mpc_struct* op,
                         AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	__mpc_struct _tmp3_;
#line 1002 "../lib/number.vala"
	g_return_if_fail (res != NULL);
#line 1002 "../lib/number.vala"
	g_return_if_fail (op != NULL);
#line 1006 "../lib/number.vala"
	switch (unit) {
#line 4347 "number.c"
		default:
#line 1006 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 4351 "number.c"
		{
#line 1010 "../lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 4355 "number.c"
				__mpc_struct _tmp0_;
#line 1011 "../lib/number.vala"
				_tmp0_ = *op;
#line 1011 "../lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 4361 "number.c"
			}
#line 1012 "../lib/number.vala"
			return;
#line 4365 "number.c"
		}
#line 1006 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 4369 "number.c"
		{
#line 1015 "../lib/number.vala"
			i = 180;
#line 1016 "../lib/number.vala"
			break;
#line 4375 "number.c"
		}
#line 1006 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 4379 "number.c"
		{
#line 1019 "../lib/number.vala"
			i = 200;
#line 1020 "../lib/number.vala"
			break;
#line 4385 "number.c"
		}
	}
#line 1023 "../lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1023 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1023 "../lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1024 "../lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1025 "../lib/number.vala"
	mpfr_si_div (&scale, (glong) i, &scale, MPFR_RNDN);
#line 1026 "../lib/number.vala"
	_tmp3_ = *op;
#line 1026 "../lib/number.vala"
	mpc_mul_fr (res, &_tmp3_, &scale, MPC_RNDNN);
#line 1002 "../lib/number.vala"
	mpfr_clear (&scale);
#line 4404 "number.c"
}

static void
number_mpc_to_radians (__mpc_struct* res,
                       __mpc_struct* op,
                       AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	__mpc_struct _tmp3_;
#line 1029 "../lib/number.vala"
	g_return_if_fail (res != NULL);
#line 1029 "../lib/number.vala"
	g_return_if_fail (op != NULL);
#line 1033 "../lib/number.vala"
	switch (unit) {
#line 4423 "number.c"
		default:
#line 1033 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 4427 "number.c"
		{
#line 1037 "../lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 4431 "number.c"
				__mpc_struct _tmp0_;
#line 1038 "../lib/number.vala"
				_tmp0_ = *op;
#line 1038 "../lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 4437 "number.c"
			}
#line 1039 "../lib/number.vala"
			return;
#line 4441 "number.c"
		}
#line 1033 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 4445 "number.c"
		{
#line 1042 "../lib/number.vala"
			i = 180;
#line 1043 "../lib/number.vala"
			break;
#line 4451 "number.c"
		}
#line 1033 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 4455 "number.c"
		{
#line 1046 "../lib/number.vala"
			i = 200;
#line 1047 "../lib/number.vala"
			break;
#line 4461 "number.c"
		}
	}
#line 1049 "../lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1049 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1049 "../lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1050 "../lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1051 "../lib/number.vala"
	mpfr_div_si (&scale, &scale, (glong) i, MPFR_RNDN);
#line 1052 "../lib/number.vala"
	_tmp3_ = *op;
#line 1052 "../lib/number.vala"
	mpc_mul_fr (res, &_tmp3_, &scale, MPC_RNDNN);
#line 1029 "../lib/number.vala"
	mpfr_clear (&scale);
#line 4480 "number.c"
}

static Number*
number_to_radians (Number* self,
                   AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 1056 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1058 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 1058 "../lib/number.vala"
	z = _tmp0_;
#line 1059 "../lib/number.vala"
	number_mpc_to_radians (&z->priv->num, &self->priv->num, unit);
#line 1060 "../lib/number.vala"
	result = z;
#line 1060 "../lib/number.vala"
	return result;
#line 4502 "number.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 4519 "number.c"
}

static Number*
number_bitwise (Number* self,
                Number* y,
                BitwiseFunc bitwise_operator,
                gpointer bitwise_operator_target,
                gint wordlen)
{
	gchar* text1 = NULL;
	gchar* _tmp0_;
	gchar* text2 = NULL;
	gchar* _tmp1_;
	gint offset1 = 0;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint offset2 = 0;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint offset_out = 0;
	gboolean _tmp9_ = FALSE;
	gchar* text_out = NULL;
	gchar* _tmp12_;
	gint text_out_length1;
	gint _text_out_size_;
	gchar* _tmp22_;
	gint _tmp22__length1;
	Number* _tmp23_;
	Number* result;
#line 1063 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1063 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 1065 "../lib/number.vala"
	_tmp0_ = number_to_hex_string (self);
#line 1065 "../lib/number.vala"
	text1 = _tmp0_;
#line 1066 "../lib/number.vala"
	_tmp1_ = number_to_hex_string (y);
#line 1066 "../lib/number.vala"
	text2 = _tmp1_;
#line 1067 "../lib/number.vala"
	_tmp2_ = text1;
#line 1067 "../lib/number.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1067 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1067 "../lib/number.vala"
	offset1 = _tmp4_ - 1;
#line 1068 "../lib/number.vala"
	_tmp5_ = text2;
#line 1068 "../lib/number.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1068 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1068 "../lib/number.vala"
	offset2 = _tmp7_ - 1;
#line 1069 "../lib/number.vala"
	offset_out = (wordlen / 4) - 1;
#line 1070 "../lib/number.vala"
	if (offset_out <= 0) {
#line 4583 "number.c"
		gint _tmp8_ = 0;
#line 1071 "../lib/number.vala"
		if (offset1 > offset2) {
#line 1071 "../lib/number.vala"
			_tmp8_ = offset1;
#line 4589 "number.c"
		} else {
#line 1071 "../lib/number.vala"
			_tmp8_ = offset2;
#line 4593 "number.c"
		}
#line 1071 "../lib/number.vala"
		offset_out = _tmp8_;
#line 4597 "number.c"
	}
#line 1072 "../lib/number.vala"
	if (offset_out > 0) {
#line 4601 "number.c"
		gboolean _tmp10_ = FALSE;
#line 1072 "../lib/number.vala"
		if (offset_out < offset1) {
#line 1072 "../lib/number.vala"
			_tmp10_ = TRUE;
#line 4607 "number.c"
		} else {
#line 1072 "../lib/number.vala"
			_tmp10_ = offset_out < offset2;
#line 4611 "number.c"
		}
#line 1072 "../lib/number.vala"
		_tmp9_ = _tmp10_;
#line 4615 "number.c"
	} else {
#line 1072 "../lib/number.vala"
		_tmp9_ = FALSE;
#line 4619 "number.c"
	}
#line 1072 "../lib/number.vala"
	if (_tmp9_) {
#line 4623 "number.c"
		Number* _tmp11_;
#line 1074 "../lib/number.vala"
		number_set_error ("Overflow. Try a bigger word size");
#line 1075 "../lib/number.vala"
		_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1075 "../lib/number.vala"
		result = _tmp11_;
#line 1075 "../lib/number.vala"
		_g_free0 (text2);
#line 1075 "../lib/number.vala"
		_g_free0 (text1);
#line 1075 "../lib/number.vala"
		return result;
#line 4637 "number.c"
	}
#line 1078 "../lib/number.vala"
	_tmp12_ = g_new0 (gchar, offset_out + 2);
#line 1078 "../lib/number.vala"
	text_out = _tmp12_;
#line 1078 "../lib/number.vala"
	text_out_length1 = offset_out + 2;
#line 1078 "../lib/number.vala"
	_text_out_size_ = text_out_length1;
#line 4647 "number.c"
	{
		gchar* _tmp13_;
		gint _tmp13__length1;
		gboolean _tmp14_ = FALSE;
#line 1081 "../lib/number.vala"
		_tmp13_ = text_out;
#line 1081 "../lib/number.vala"
		_tmp13__length1 = text_out_length1;
#line 1081 "../lib/number.vala"
		_tmp13_[offset_out + 1] = '\0';
#line 1081 "../lib/number.vala"
		_tmp14_ = TRUE;
#line 1081 "../lib/number.vala"
		while (TRUE) {
#line 4662 "number.c"
			gint v1 = 0;
			gint v2 = 0;
#line 1084 "../lib/number.vala"
			static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 4667 "number.c"
			gchar* _tmp20_;
			gint _tmp20__length1;
			gchar _tmp21_;
#line 1081 "../lib/number.vala"
			if (!_tmp14_) {
#line 4673 "number.c"
				gint _tmp15_;
#line 1081 "../lib/number.vala"
				_tmp15_ = offset_out;
#line 1081 "../lib/number.vala"
				offset_out = _tmp15_ - 1;
#line 4679 "number.c"
			}
#line 1081 "../lib/number.vala"
			_tmp14_ = FALSE;
#line 1081 "../lib/number.vala"
			if (!(offset_out >= 0)) {
#line 1081 "../lib/number.vala"
				break;
#line 4687 "number.c"
			}
#line 1083 "../lib/number.vala"
			v1 = 0;
#line 1083 "../lib/number.vala"
			v2 = 0;
#line 1086 "../lib/number.vala"
			if (offset1 >= 0) {
#line 4695 "number.c"
				const gchar* _tmp16_;
				gint _tmp17_;
#line 1088 "../lib/number.vala"
				_tmp16_ = text1;
#line 1088 "../lib/number.vala"
				v1 = number_hex_to_int (self, string_get (_tmp16_, (glong) offset1));
#line 1089 "../lib/number.vala"
				_tmp17_ = offset1;
#line 1089 "../lib/number.vala"
				offset1 = _tmp17_ - 1;
#line 4706 "number.c"
			}
#line 1091 "../lib/number.vala"
			if (offset2 >= 0) {
#line 4710 "number.c"
				const gchar* _tmp18_;
				gint _tmp19_;
#line 1093 "../lib/number.vala"
				_tmp18_ = text2;
#line 1093 "../lib/number.vala"
				v2 = number_hex_to_int (self, string_get (_tmp18_, (glong) offset2));
#line 1094 "../lib/number.vala"
				_tmp19_ = offset2;
#line 1094 "../lib/number.vala"
				offset2 = _tmp19_ - 1;
#line 4721 "number.c"
			}
#line 1096 "../lib/number.vala"
			_tmp20_ = text_out;
#line 1096 "../lib/number.vala"
			_tmp20__length1 = text_out_length1;
#line 1096 "../lib/number.vala"
			_tmp21_ = digits[bitwise_operator (v1, v2, bitwise_operator_target)];
#line 1096 "../lib/number.vala"
			_tmp20_[offset_out] = _tmp21_;
#line 4731 "number.c"
		}
	}
#line 1099 "../lib/number.vala"
	_tmp22_ = text_out;
#line 1099 "../lib/number.vala"
	_tmp22__length1 = text_out_length1;
#line 1099 "../lib/number.vala"
	_tmp23_ = mp_set_from_string ((const gchar*) _tmp22_, 16);
#line 1099 "../lib/number.vala"
	result = _tmp23_;
#line 1099 "../lib/number.vala"
	text_out = (g_free (text_out), NULL);
#line 1099 "../lib/number.vala"
	_g_free0 (text2);
#line 1099 "../lib/number.vala"
	_g_free0 (text1);
#line 1099 "../lib/number.vala"
	return result;
#line 4750 "number.c"
}

static gint
number_hex_to_int (Number* self,
                   gchar digit)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint result;
#line 1102 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1104 "../lib/number.vala"
	if (digit >= '0') {
#line 1104 "../lib/number.vala"
		_tmp0_ = digit <= '9';
#line 4767 "number.c"
	} else {
#line 1104 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 4771 "number.c"
	}
#line 1104 "../lib/number.vala"
	if (_tmp0_) {
#line 1105 "../lib/number.vala"
		result = (gint) (digit - '0');
#line 1105 "../lib/number.vala"
		return result;
#line 4779 "number.c"
	}
#line 1106 "../lib/number.vala"
	if (digit >= 'A') {
#line 1106 "../lib/number.vala"
		_tmp1_ = digit <= 'F';
#line 4785 "number.c"
	} else {
#line 1106 "../lib/number.vala"
		_tmp1_ = FALSE;
#line 4789 "number.c"
	}
#line 1106 "../lib/number.vala"
	if (_tmp1_) {
#line 1107 "../lib/number.vala"
		result = (digit - 'A') + 10;
#line 1107 "../lib/number.vala"
		return result;
#line 4797 "number.c"
	}
#line 1108 "../lib/number.vala"
	if (digit >= 'a') {
#line 1108 "../lib/number.vala"
		_tmp2_ = digit <= 'f';
#line 4803 "number.c"
	} else {
#line 1108 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 4807 "number.c"
	}
#line 1108 "../lib/number.vala"
	if (_tmp2_) {
#line 1109 "../lib/number.vala"
		result = (digit - 'a') + 10;
#line 1109 "../lib/number.vala"
		return result;
#line 4815 "number.c"
	}
#line 1110 "../lib/number.vala"
	result = 0;
#line 1110 "../lib/number.vala"
	return result;
#line 4821 "number.c"
}

static gchar*
number_to_hex_string (Number* self)
{
	Serializer* serializer = NULL;
	Serializer* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 1113 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1115 "../lib/number.vala"
	_tmp0_ = serializer_new (DISPLAY_FORMAT_FIXED, 16, 0);
#line 1115 "../lib/number.vala"
	serializer = _tmp0_;
#line 1116 "../lib/number.vala"
	_tmp1_ = serializer_to_string (serializer, self);
#line 1116 "../lib/number.vala"
	result = _tmp1_;
#line 1116 "../lib/number.vala"
	_g_object_unref0 (serializer);
#line 1116 "../lib/number.vala"
	return result;
#line 4845 "number.c"
}

Number*
number_construct (GType object_type)
{
	Number * self = NULL;
#line 41 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 41 "../lib/number.vala"
	return self;
#line 4856 "number.c"
}

Number*
number_new (void)
{
#line 41 "../lib/number.vala"
	return number_construct (TYPE_NUMBER);
#line 4864 "number.c"
}

mpfr_prec_t
number_get_precision (void)
{
	mpfr_prec_t result;
#line 46 "../lib/number.vala"
	result = number__precision;
#line 46 "../lib/number.vala"
	return result;
#line 4875 "number.c"
}

void
number_set_precision (mpfr_prec_t value)
{
#line 46 "../lib/number.vala"
	number__precision = value;
#line 4883 "number.c"
}

const gchar*
number_get_error (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../lib/number.vala"
	_tmp0_ = number__error;
#line 49 "../lib/number.vala"
	result = _tmp0_;
#line 49 "../lib/number.vala"
	return result;
#line 4897 "number.c"
}

void
number_set_error (const gchar* value)
{
	gchar* _tmp0_;
#line 49 "../lib/number.vala"
	_tmp0_ = g_strdup (value);
#line 49 "../lib/number.vala"
	_g_free0 (number__error);
#line 49 "../lib/number.vala"
	number__error = _tmp0_;
#line 4910 "number.c"
}

static void
number_class_init (NumberClass * klass,
                   gpointer klass_data)
{
#line 41 "../lib/number.vala"
	number_parent_class = g_type_class_peek_parent (klass);
#line 41 "../lib/number.vala"
	g_type_class_adjust_private_offset (klass, &Number_private_offset);
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_number_get_property;
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_number_set_property;
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->finalize = number_finalize;
#line 4927 "number.c"
}

static void
number_instance_init (Number * self,
                      gpointer klass)
{
	mpfr_prec_t _tmp0_;
	mpfr_prec_t _tmp1_;
#line 41 "../lib/number.vala"
	self->priv = number_get_instance_private (self);
#line 44 "../lib/number.vala"
	_tmp0_ = number_get_precision ();
#line 44 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 44 "../lib/number.vala"
	mpc_init2 (&self->priv->num, _tmp1_);
#line 4944 "number.c"
}

static void
number_finalize (GObject * obj)
{
	Number * self;
#line 41 "../lib/number.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER, Number);
#line 44 "../lib/number.vala"
	mpc_clear (&self->priv->num);
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (number_parent_class)->finalize (obj);
#line 4957 "number.c"
}

static GType
number_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NumberClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Number), 0, (GInstanceInitFunc) number_instance_init, NULL };
	GType number_type_id;
	number_type_id = g_type_register_static (G_TYPE_OBJECT, "Number", &g_define_type_info, 0);
	Number_private_offset = g_type_add_instance_private (number_type_id, sizeof (NumberPrivate));
	return number_type_id;
}

GType
number_get_type (void)
{
	static volatile gsize number_type_id__once = 0;
	if (g_once_init_enter (&number_type_id__once)) {
		GType number_type_id;
		number_type_id = number_get_type_once ();
		g_once_init_leave (&number_type_id__once, number_type_id);
	}
	return number_type_id__once;
}

static void
_vala_number_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 41 "../lib/number.vala"
	switch (property_id) {
#line 4992 "number.c"
		default:
#line 41 "../lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../lib/number.vala"
		break;
#line 4998 "number.c"
	}
}

static void
_vala_number_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 41 "../lib/number.vala"
	switch (property_id) {
#line 5012 "number.c"
		default:
#line 41 "../lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../lib/number.vala"
		break;
#line 5018 "number.c"
	}
}

gint
parse_literal_prefix (const gchar* str,
                      gint* prefix_len)
{
	gint new_base = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gchar prefix = '\0';
	gint result;
#line 1120 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 1122 "../lib/number.vala"
	new_base = 0;
#line 1124 "../lib/number.vala"
	_tmp1_ = strlen (str);
#line 1124 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1124 "../lib/number.vala"
	if (_tmp2_ < 3) {
#line 1124 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 5044 "number.c"
	} else {
#line 1124 "../lib/number.vala"
		_tmp0_ = string_get (str, (glong) 0) != '0';
#line 5048 "number.c"
	}
#line 1124 "../lib/number.vala"
	if (_tmp0_) {
#line 1125 "../lib/number.vala"
		result = new_base;
#line 1125 "../lib/number.vala"
		return result;
#line 5056 "number.c"
	}
#line 1127 "../lib/number.vala"
	prefix = g_ascii_tolower (string_get (str, (glong) 1));
#line 1129 "../lib/number.vala"
	if (prefix == 'b') {
#line 1130 "../lib/number.vala"
		new_base = 2;
#line 5064 "number.c"
	} else {
#line 1131 "../lib/number.vala"
		if (prefix == 'o') {
#line 1132 "../lib/number.vala"
			new_base = 8;
#line 5070 "number.c"
		} else {
#line 1133 "../lib/number.vala"
			if (prefix == 'x') {
#line 1134 "../lib/number.vala"
				new_base = 16;
#line 5076 "number.c"
			}
		}
	}
#line 1136 "../lib/number.vala"
	if (new_base != 0) {
#line 1137 "../lib/number.vala"
		*prefix_len = 2;
#line 5084 "number.c"
	}
#line 1139 "../lib/number.vala"
	result = new_base;
#line 1139 "../lib/number.vala"
	return result;
#line 5090 "number.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 5112 "number.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 5120 "number.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 5126 "number.c"
	}
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1259 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1260 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1261 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 5143 "number.c"
		gchar* _tmp0_;
#line 1262 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1262 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1263 "glib-2.0.vapi"
		result = TRUE;
#line 1263 "glib-2.0.vapi"
		if (c) {
#line 1263 "glib-2.0.vapi"
			*c = _vala_c;
#line 5155 "number.c"
		}
#line 1263 "glib-2.0.vapi"
		return result;
#line 5159 "number.c"
	} else {
#line 1265 "glib-2.0.vapi"
		result = FALSE;
#line 1265 "glib-2.0.vapi"
		if (c) {
#line 1265 "glib-2.0.vapi"
			*c = _vala_c;
#line 5167 "number.c"
		}
#line 1265 "glib-2.0.vapi"
		return result;
#line 5171 "number.c"
	}
}

static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1298 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1299 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 5186 "number.c"
		gchar* _tmp0_;
#line 1300 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1300 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1301 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1302 "glib-2.0.vapi"
		result = TRUE;
#line 1302 "glib-2.0.vapi"
		if (c) {
#line 1302 "glib-2.0.vapi"
			*c = _vala_c;
#line 5200 "number.c"
		}
#line 1302 "glib-2.0.vapi"
		return result;
#line 5204 "number.c"
	} else {
#line 1304 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1305 "glib-2.0.vapi"
		result = FALSE;
#line 1305 "glib-2.0.vapi"
		if (c) {
#line 1305 "glib-2.0.vapi"
			*c = _vala_c;
#line 5214 "number.c"
		}
#line 1305 "glib-2.0.vapi"
		return result;
#line 5218 "number.c"
	}
}

Number*
mp_set_from_string (const gchar* str,
                    gint default_base)
{
#line 1153 "../lib/number.vala"
	static const gunichar base_digits[10] = {8320U, 8321U, 8322U, 8323U, 8324U, 8325U, 8326U, 8327U, 8328U, 8329U};
#line 5228 "number.c"
	gint index = 0;
	gint base_prefix = 0;
	gunichar c = 0U;
	gint end = 0;
	gint number_base = 0;
	gint literal_base = 0;
	gint base_multiplier = 0;
	gint _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean negate = FALSE;
	gunichar _tmp12_ = 0U;
	Number* z = NULL;
	Number* _tmp15_;
#line 1218 "../lib/number.vala"
	static const gunichar fractions[15] = {189U, 8531U, 8532U, 188U, 190U, 8533U, 8534U, 8535U, 8536U, 8537U, 8538U, 8539U, 8540U, 8541U, 8542U};
#line 1219 "../lib/number.vala"
	static const gint numerators[15] = {1, 1, 2, 1, 3, 1, 2, 3, 4, 1, 5, 1, 3, 5, 7};
#line 1220 "../lib/number.vala"
	static const gint denominators[15] = {2, 3, 3, 4, 4, 5, 5, 5, 5, 6, 6, 8, 8, 8, 8};
#line 5249 "number.c"
	gboolean has_fraction = FALSE;
	gunichar _tmp25_ = 0U;
	gboolean _tmp26_;
	Number* result;
#line 1147 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1149 "../lib/number.vala"
	if (string_index_of_char (str, 176U, 0) >= 0) {
#line 5258 "number.c"
		Number* _tmp0_;
#line 1150 "../lib/number.vala"
		_tmp0_ = set_from_sexagesimal (str);
#line 1150 "../lib/number.vala"
		result = _tmp0_;
#line 1150 "../lib/number.vala"
		return result;
#line 5266 "number.c"
	}
#line 1154 "../lib/number.vala"
	index = 0;
#line 1155 "../lib/number.vala"
	base_prefix = 0;
#line 1157 "../lib/number.vala"
	while (TRUE) {
#line 5274 "number.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 1157 "../lib/number.vala"
		_tmp2_ = string_get_next_char (str, &index, &_tmp1_);
#line 1157 "../lib/number.vala"
		c = _tmp1_;
#line 1157 "../lib/number.vala"
		if (!_tmp2_) {
#line 1157 "../lib/number.vala"
			break;
#line 5285 "number.c"
		}
	}
#line 1158 "../lib/number.vala"
	end = index;
#line 1159 "../lib/number.vala"
	number_base = 0;
#line 1160 "../lib/number.vala"
	literal_base = 0;
#line 1161 "../lib/number.vala"
	base_multiplier = 1;
#line 1162 "../lib/number.vala"
	while (TRUE) {
#line 5298 "number.c"
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gint value = 0;
#line 1162 "../lib/number.vala"
		_tmp4_ = string_get_prev_char (str, &index, &_tmp3_);
#line 1162 "../lib/number.vala"
		c = _tmp3_;
#line 1162 "../lib/number.vala"
		if (!_tmp4_) {
#line 1162 "../lib/number.vala"
			break;
#line 5310 "number.c"
		}
#line 1164 "../lib/number.vala"
		value = -1;
#line 5314 "number.c"
		{
			gint i = 0;
#line 1165 "../lib/number.vala"
			i = 0;
#line 5319 "number.c"
			{
				gboolean _tmp5_ = FALSE;
#line 1165 "../lib/number.vala"
				_tmp5_ = TRUE;
#line 1165 "../lib/number.vala"
				while (TRUE) {
#line 5326 "number.c"
					gunichar _tmp7_;
#line 1165 "../lib/number.vala"
					if (!_tmp5_) {
#line 5330 "number.c"
						gint _tmp6_;
#line 1165 "../lib/number.vala"
						_tmp6_ = i;
#line 1165 "../lib/number.vala"
						i = _tmp6_ + 1;
#line 5336 "number.c"
					}
#line 1165 "../lib/number.vala"
					_tmp5_ = FALSE;
#line 1165 "../lib/number.vala"
					if (!(i < G_N_ELEMENTS (base_digits))) {
#line 1165 "../lib/number.vala"
						break;
#line 5344 "number.c"
					}
#line 1167 "../lib/number.vala"
					_tmp7_ = base_digits[i];
#line 1167 "../lib/number.vala"
					if (c == _tmp7_) {
#line 1169 "../lib/number.vala"
						value = i;
#line 1170 "../lib/number.vala"
						break;
#line 5354 "number.c"
					}
				}
			}
		}
#line 1173 "../lib/number.vala"
		if (value < 0) {
#line 1174 "../lib/number.vala"
			break;
#line 5363 "number.c"
		}
#line 1176 "../lib/number.vala"
		end = index;
#line 1177 "../lib/number.vala"
		number_base += value * base_multiplier;
#line 1178 "../lib/number.vala"
		base_multiplier *= 10;
#line 5371 "number.c"
	}
#line 1181 "../lib/number.vala"
	_tmp8_ = parse_literal_prefix (str, &base_prefix);
#line 1181 "../lib/number.vala"
	literal_base = _tmp8_;
#line 1183 "../lib/number.vala"
	if (number_base != 0) {
#line 1183 "../lib/number.vala"
		_tmp10_ = literal_base != 0;
#line 5381 "number.c"
	} else {
#line 1183 "../lib/number.vala"
		_tmp10_ = FALSE;
#line 5385 "number.c"
	}
#line 1183 "../lib/number.vala"
	if (_tmp10_) {
#line 1183 "../lib/number.vala"
		_tmp9_ = literal_base != number_base;
#line 5391 "number.c"
	} else {
#line 1183 "../lib/number.vala"
		_tmp9_ = FALSE;
#line 5395 "number.c"
	}
#line 1183 "../lib/number.vala"
	if (_tmp9_) {
#line 1184 "../lib/number.vala"
		result = NULL;
#line 1184 "../lib/number.vala"
		return result;
#line 5403 "number.c"
	}
#line 1186 "../lib/number.vala"
	if (number_base == 0) {
#line 5407 "number.c"
		gint _tmp11_ = 0;
#line 1187 "../lib/number.vala"
		if (literal_base != 0) {
#line 1187 "../lib/number.vala"
			_tmp11_ = literal_base;
#line 5413 "number.c"
		} else {
#line 1187 "../lib/number.vala"
			_tmp11_ = default_base;
#line 5417 "number.c"
		}
#line 1187 "../lib/number.vala"
		number_base = _tmp11_;
#line 5421 "number.c"
	}
#line 1190 "../lib/number.vala"
	negate = FALSE;
#line 1191 "../lib/number.vala"
	index = base_prefix;
#line 1192 "../lib/number.vala"
	string_get_next_char (str, &index, &_tmp12_);
#line 1192 "../lib/number.vala"
	c = _tmp12_;
#line 1193 "../lib/number.vala"
	if (c == ((gunichar) '+')) {
#line 1194 "../lib/number.vala"
		negate = FALSE;
#line 5435 "number.c"
	} else {
		gboolean _tmp13_ = FALSE;
#line 1195 "../lib/number.vala"
		if (c == ((gunichar) '-')) {
#line 1195 "../lib/number.vala"
			_tmp13_ = TRUE;
#line 5442 "number.c"
		} else {
#line 1195 "../lib/number.vala"
			_tmp13_ = c == 8722U;
#line 5446 "number.c"
		}
#line 1195 "../lib/number.vala"
		if (_tmp13_) {
#line 1196 "../lib/number.vala"
			negate = TRUE;
#line 5452 "number.c"
		} else {
			gunichar _tmp14_ = 0U;
#line 1198 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp14_);
#line 1198 "../lib/number.vala"
			c = _tmp14_;
#line 5459 "number.c"
		}
	}
#line 1201 "../lib/number.vala"
	_tmp15_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1201 "../lib/number.vala"
	z = _tmp15_;
#line 1203 "../lib/number.vala"
	while (TRUE) {
#line 5468 "number.c"
		gunichar _tmp16_ = 0U;
		gboolean _tmp17_;
		gint i = 0;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
#line 1203 "../lib/number.vala"
		_tmp17_ = string_get_next_char (str, &index, &_tmp16_);
#line 1203 "../lib/number.vala"
		c = _tmp16_;
#line 1203 "../lib/number.vala"
		if (!_tmp17_) {
#line 1203 "../lib/number.vala"
			break;
#line 5486 "number.c"
		}
#line 1205 "../lib/number.vala"
		i = char_val (c, number_base);
#line 1206 "../lib/number.vala"
		if (i > number_base) {
#line 1207 "../lib/number.vala"
			result = NULL;
#line 1207 "../lib/number.vala"
			_g_object_unref0 (z);
#line 1207 "../lib/number.vala"
			return result;
#line 5498 "number.c"
		}
#line 1208 "../lib/number.vala"
		if (i < 0) {
#line 5502 "number.c"
			gunichar _tmp18_ = 0U;
#line 1210 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp18_);
#line 1210 "../lib/number.vala"
			c = _tmp18_;
#line 1211 "../lib/number.vala"
			break;
#line 5510 "number.c"
		}
#line 1214 "../lib/number.vala"
		_tmp19_ = z;
#line 1214 "../lib/number.vala"
		_tmp20_ = number_multiply_integer (_tmp19_, (gint64) number_base);
#line 1214 "../lib/number.vala"
		_tmp21_ = _tmp20_;
#line 1214 "../lib/number.vala"
		_tmp22_ = number_new_integer ((gint64) i, (gint64) 0);
#line 1214 "../lib/number.vala"
		_tmp23_ = _tmp22_;
#line 1214 "../lib/number.vala"
		_tmp24_ = number_add (_tmp21_, _tmp23_);
#line 1214 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1214 "../lib/number.vala"
		z = _tmp24_;
#line 1214 "../lib/number.vala"
		_g_object_unref0 (_tmp23_);
#line 1214 "../lib/number.vala"
		_g_object_unref0 (_tmp21_);
#line 5532 "number.c"
	}
#line 1221 "../lib/number.vala"
	has_fraction = FALSE;
#line 1222 "../lib/number.vala"
	_tmp26_ = string_get_next_char (str, &index, &_tmp25_);
#line 1222 "../lib/number.vala"
	c = _tmp25_;
#line 1222 "../lib/number.vala"
	if (_tmp26_) {
#line 5542 "number.c"
		{
			gint i = 0;
#line 1224 "../lib/number.vala"
			i = 0;
#line 5547 "number.c"
			{
				gboolean _tmp27_ = FALSE;
#line 1224 "../lib/number.vala"
				_tmp27_ = TRUE;
#line 1224 "../lib/number.vala"
				while (TRUE) {
#line 5554 "number.c"
					gunichar _tmp29_;
#line 1224 "../lib/number.vala"
					if (!_tmp27_) {
#line 5558 "number.c"
						gint _tmp28_;
#line 1224 "../lib/number.vala"
						_tmp28_ = i;
#line 1224 "../lib/number.vala"
						i = _tmp28_ + 1;
#line 5564 "number.c"
					}
#line 1224 "../lib/number.vala"
					_tmp27_ = FALSE;
#line 1224 "../lib/number.vala"
					if (!(i < G_N_ELEMENTS (fractions))) {
#line 1224 "../lib/number.vala"
						break;
#line 5572 "number.c"
					}
#line 1226 "../lib/number.vala"
					_tmp29_ = fractions[i];
#line 1226 "../lib/number.vala"
					if (c == _tmp29_) {
#line 5578 "number.c"
						Number* fraction = NULL;
						gint _tmp30_;
						gint _tmp31_;
						Number* _tmp32_;
						Number* _tmp33_;
						Number* _tmp34_;
						Number* _tmp35_;
						gunichar _tmp36_ = 0U;
						gboolean _tmp37_;
#line 1228 "../lib/number.vala"
						_tmp30_ = numerators[i];
#line 1228 "../lib/number.vala"
						_tmp31_ = denominators[i];
#line 1228 "../lib/number.vala"
						_tmp32_ = number_new_fraction ((gint64) _tmp30_, (gint64) _tmp31_);
#line 1228 "../lib/number.vala"
						fraction = _tmp32_;
#line 1229 "../lib/number.vala"
						_tmp33_ = z;
#line 1229 "../lib/number.vala"
						_tmp34_ = fraction;
#line 1229 "../lib/number.vala"
						_tmp35_ = number_add (_tmp33_, _tmp34_);
#line 1229 "../lib/number.vala"
						_g_object_unref0 (z);
#line 1229 "../lib/number.vala"
						z = _tmp35_;
#line 1232 "../lib/number.vala"
						_tmp37_ = string_get_next_char (str, &index, &_tmp36_);
#line 1232 "../lib/number.vala"
						c = _tmp36_;
#line 1232 "../lib/number.vala"
						if (!_tmp37_) {
#line 1233 "../lib/number.vala"
							result = z;
#line 1233 "../lib/number.vala"
							_g_object_unref0 (fraction);
#line 1233 "../lib/number.vala"
							return result;
#line 5618 "number.c"
						} else {
#line 1235 "../lib/number.vala"
							result = NULL;
#line 1235 "../lib/number.vala"
							_g_object_unref0 (fraction);
#line 1235 "../lib/number.vala"
							_g_object_unref0 (z);
#line 1235 "../lib/number.vala"
							return result;
#line 5628 "number.c"
						}
#line 1226 "../lib/number.vala"
						_g_object_unref0 (fraction);
#line 5632 "number.c"
					}
				}
			}
		}
#line 1240 "../lib/number.vala"
		if (c == ((gunichar) '.')) {
#line 1241 "../lib/number.vala"
			has_fraction = TRUE;
#line 5641 "number.c"
		} else {
			gunichar _tmp38_ = 0U;
#line 1243 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp38_);
#line 1243 "../lib/number.vala"
			c = _tmp38_;
#line 5648 "number.c"
		}
	}
#line 1247 "../lib/number.vala"
	if (has_fraction) {
#line 5653 "number.c"
		Number* numerator = NULL;
		Number* _tmp39_;
		Number* denominator = NULL;
		Number* _tmp40_;
		Number* _tmp52_;
		Number* _tmp53_;
		Number* _tmp54_;
		Number* _tmp55_;
		Number* _tmp56_;
		Number* _tmp57_;
#line 1249 "../lib/number.vala"
		_tmp39_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1249 "../lib/number.vala"
		numerator = _tmp39_;
#line 1250 "../lib/number.vala"
		_tmp40_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1250 "../lib/number.vala"
		denominator = _tmp40_;
#line 1252 "../lib/number.vala"
		while (TRUE) {
#line 5674 "number.c"
			gunichar _tmp41_ = 0U;
			gboolean _tmp42_;
			gint i = 0;
			Number* _tmp44_;
			Number* _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
			Number* _tmp49_;
			Number* _tmp50_;
			Number* _tmp51_;
#line 1252 "../lib/number.vala"
			_tmp42_ = string_get_next_char (str, &index, &_tmp41_);
#line 1252 "../lib/number.vala"
			c = _tmp41_;
#line 1252 "../lib/number.vala"
			if (!_tmp42_) {
#line 1252 "../lib/number.vala"
				break;
#line 5694 "number.c"
			}
#line 1254 "../lib/number.vala"
			i = char_val (c, number_base);
#line 1255 "../lib/number.vala"
			if (i < 0) {
#line 5700 "number.c"
				gunichar _tmp43_ = 0U;
#line 1257 "../lib/number.vala"
				string_get_prev_char (str, &index, &_tmp43_);
#line 1257 "../lib/number.vala"
				c = _tmp43_;
#line 1258 "../lib/number.vala"
				break;
#line 5708 "number.c"
			}
#line 1261 "../lib/number.vala"
			_tmp44_ = denominator;
#line 1261 "../lib/number.vala"
			_tmp45_ = number_multiply_integer (_tmp44_, (gint64) number_base);
#line 1261 "../lib/number.vala"
			_g_object_unref0 (denominator);
#line 1261 "../lib/number.vala"
			denominator = _tmp45_;
#line 1262 "../lib/number.vala"
			_tmp46_ = numerator;
#line 1262 "../lib/number.vala"
			_tmp47_ = number_multiply_integer (_tmp46_, (gint64) number_base);
#line 1262 "../lib/number.vala"
			_g_object_unref0 (numerator);
#line 1262 "../lib/number.vala"
			numerator = _tmp47_;
#line 1263 "../lib/number.vala"
			_tmp48_ = numerator;
#line 1263 "../lib/number.vala"
			_tmp49_ = number_new_integer ((gint64) i, (gint64) 0);
#line 1263 "../lib/number.vala"
			_tmp50_ = _tmp49_;
#line 1263 "../lib/number.vala"
			_tmp51_ = number_add (_tmp48_, _tmp50_);
#line 1263 "../lib/number.vala"
			_g_object_unref0 (numerator);
#line 1263 "../lib/number.vala"
			numerator = _tmp51_;
#line 1263 "../lib/number.vala"
			_g_object_unref0 (_tmp50_);
#line 5740 "number.c"
		}
#line 1266 "../lib/number.vala"
		_tmp52_ = numerator;
#line 1266 "../lib/number.vala"
		_tmp53_ = denominator;
#line 1266 "../lib/number.vala"
		_tmp54_ = number_divide (_tmp52_, _tmp53_);
#line 1266 "../lib/number.vala"
		_g_object_unref0 (numerator);
#line 1266 "../lib/number.vala"
		numerator = _tmp54_;
#line 1267 "../lib/number.vala"
		_tmp55_ = z;
#line 1267 "../lib/number.vala"
		_tmp56_ = numerator;
#line 1267 "../lib/number.vala"
		_tmp57_ = number_add (_tmp55_, _tmp56_);
#line 1267 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1267 "../lib/number.vala"
		z = _tmp57_;
#line 1247 "../lib/number.vala"
		_g_object_unref0 (denominator);
#line 1247 "../lib/number.vala"
		_g_object_unref0 (numerator);
#line 5766 "number.c"
	}
#line 1270 "../lib/number.vala"
	if (index != end) {
#line 1271 "../lib/number.vala"
		result = NULL;
#line 1271 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1271 "../lib/number.vala"
		return result;
#line 5776 "number.c"
	}
#line 1273 "../lib/number.vala"
	if (negate) {
#line 5780 "number.c"
		Number* _tmp58_;
		Number* _tmp59_;
#line 1274 "../lib/number.vala"
		_tmp58_ = z;
#line 1274 "../lib/number.vala"
		_tmp59_ = number_invert_sign (_tmp58_);
#line 1274 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1274 "../lib/number.vala"
		z = _tmp59_;
#line 5791 "number.c"
	}
#line 1276 "../lib/number.vala"
	result = z;
#line 1276 "../lib/number.vala"
	return result;
#line 5797 "number.c"
}

gint
char_val (gunichar c,
          gint number_base)
{
	gint value = 0;
	gint result;
#line 1281 "../lib/number.vala"
	if (!g_unichar_isxdigit (c)) {
#line 1282 "../lib/number.vala"
		result = -1;
#line 1282 "../lib/number.vala"
		return result;
#line 5812 "number.c"
	}
#line 1284 "../lib/number.vala"
	value = g_unichar_xdigit_value (c);
#line 1286 "../lib/number.vala"
	if (value >= number_base) {
#line 1287 "../lib/number.vala"
		result = -1;
#line 1287 "../lib/number.vala"
		return result;
#line 5822 "number.c"
	}
#line 1289 "../lib/number.vala"
	result = value;
#line 1289 "../lib/number.vala"
	return result;
#line 5828 "number.c"
}

Number*
set_from_sexagesimal (const gchar* str)
{
	gint degree_index = 0;
	Number* degrees = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	gint minute_start = 0;
	gunichar c = 0U;
	gunichar _tmp5_ = 0U;
	gint minute_index = 0;
	Number* minutes = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	gint second_start = 0;
	gunichar _tmp16_ = 0U;
	gint second_index = 0;
	Number* seconds = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_;
	Number* _tmp19_;
	Number* _tmp20_;
	Number* _tmp21_;
	Number* _tmp22_;
	Number* _tmp23_;
	Number* _tmp24_;
	Number* _tmp25_;
	Number* _tmp26_;
	gunichar _tmp27_ = 0U;
	Number* result;
#line 1292 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1294 "../lib/number.vala"
	degree_index = string_index_of_char (str, 176U, 0);
#line 1295 "../lib/number.vala"
	if (degree_index < 0) {
#line 1296 "../lib/number.vala"
		result = NULL;
#line 1296 "../lib/number.vala"
		return result;
#line 5882 "number.c"
	}
#line 1297 "../lib/number.vala"
	_tmp0_ = string_substring (str, (glong) 0, (glong) degree_index);
#line 1297 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1297 "../lib/number.vala"
	_tmp2_ = mp_set_from_string (_tmp1_, 10);
#line 1297 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1297 "../lib/number.vala"
	_g_free0 (_tmp1_);
#line 1297 "../lib/number.vala"
	degrees = _tmp3_;
#line 1298 "../lib/number.vala"
	_tmp4_ = degrees;
#line 1298 "../lib/number.vala"
	if (_tmp4_ == NULL) {
#line 1299 "../lib/number.vala"
		result = NULL;
#line 1299 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1299 "../lib/number.vala"
		return result;
#line 5906 "number.c"
	}
#line 1300 "../lib/number.vala"
	minute_start = degree_index;
#line 1302 "../lib/number.vala"
	string_get_next_char (str, &minute_start, &_tmp5_);
#line 1302 "../lib/number.vala"
	c = _tmp5_;
#line 1304 "../lib/number.vala"
	if (string_get (str, (glong) minute_start) == '\0') {
#line 1305 "../lib/number.vala"
		result = degrees;
#line 1305 "../lib/number.vala"
		return result;
#line 5920 "number.c"
	}
#line 1306 "../lib/number.vala"
	minute_index = string_index_of_char (str, (gunichar) '\'', minute_start);
#line 1307 "../lib/number.vala"
	if (minute_index < 0) {
#line 1308 "../lib/number.vala"
		result = NULL;
#line 1308 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1308 "../lib/number.vala"
		return result;
#line 5932 "number.c"
	}
#line 1309 "../lib/number.vala"
	_tmp6_ = string_substring (str, (glong) minute_start, (glong) (minute_index - minute_start));
#line 1309 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1309 "../lib/number.vala"
	_tmp8_ = mp_set_from_string (_tmp7_, 10);
#line 1309 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 1309 "../lib/number.vala"
	_g_free0 (_tmp7_);
#line 1309 "../lib/number.vala"
	minutes = _tmp9_;
#line 1310 "../lib/number.vala"
	_tmp10_ = minutes;
#line 1310 "../lib/number.vala"
	if (_tmp10_ == NULL) {
#line 1311 "../lib/number.vala"
		result = NULL;
#line 1311 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1311 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1311 "../lib/number.vala"
		return result;
#line 5958 "number.c"
	}
#line 1312 "../lib/number.vala"
	_tmp11_ = degrees;
#line 1312 "../lib/number.vala"
	_tmp12_ = minutes;
#line 1312 "../lib/number.vala"
	_tmp13_ = number_divide_integer (_tmp12_, (gint64) 60);
#line 1312 "../lib/number.vala"
	_tmp14_ = _tmp13_;
#line 1312 "../lib/number.vala"
	_tmp15_ = number_add (_tmp11_, _tmp14_);
#line 1312 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 1312 "../lib/number.vala"
	degrees = _tmp15_;
#line 1312 "../lib/number.vala"
	_g_object_unref0 (_tmp14_);
#line 1313 "../lib/number.vala"
	second_start = minute_index;
#line 1314 "../lib/number.vala"
	string_get_next_char (str, &second_start, &_tmp16_);
#line 1314 "../lib/number.vala"
	c = _tmp16_;
#line 1316 "../lib/number.vala"
	if (string_get (str, (glong) second_start) == '\0') {
#line 1317 "../lib/number.vala"
		result = degrees;
#line 1317 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1317 "../lib/number.vala"
		return result;
#line 5990 "number.c"
	}
#line 1318 "../lib/number.vala"
	second_index = string_index_of_char (str, (gunichar) '"', second_start);
#line 1319 "../lib/number.vala"
	if (second_index < 0) {
#line 1320 "../lib/number.vala"
		result = NULL;
#line 1320 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1320 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1320 "../lib/number.vala"
		return result;
#line 6004 "number.c"
	}
#line 1321 "../lib/number.vala"
	_tmp17_ = string_substring (str, (glong) second_start, (glong) (second_index - second_start));
#line 1321 "../lib/number.vala"
	_tmp18_ = _tmp17_;
#line 1321 "../lib/number.vala"
	_tmp19_ = mp_set_from_string (_tmp18_, 10);
#line 1321 "../lib/number.vala"
	_tmp20_ = _tmp19_;
#line 1321 "../lib/number.vala"
	_g_free0 (_tmp18_);
#line 1321 "../lib/number.vala"
	seconds = _tmp20_;
#line 1322 "../lib/number.vala"
	_tmp21_ = seconds;
#line 1322 "../lib/number.vala"
	if (_tmp21_ == NULL) {
#line 1323 "../lib/number.vala"
		result = NULL;
#line 1323 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1323 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1323 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1323 "../lib/number.vala"
		return result;
#line 6032 "number.c"
	}
#line 1324 "../lib/number.vala"
	_tmp22_ = degrees;
#line 1324 "../lib/number.vala"
	_tmp23_ = seconds;
#line 1324 "../lib/number.vala"
	_tmp24_ = number_divide_integer (_tmp23_, (gint64) 3600);
#line 1324 "../lib/number.vala"
	_tmp25_ = _tmp24_;
#line 1324 "../lib/number.vala"
	_tmp26_ = number_add (_tmp22_, _tmp25_);
#line 1324 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 1324 "../lib/number.vala"
	degrees = _tmp26_;
#line 1324 "../lib/number.vala"
	_g_object_unref0 (_tmp25_);
#line 1325 "../lib/number.vala"
	string_get_next_char (str, &second_index, &_tmp27_);
#line 1325 "../lib/number.vala"
	c = _tmp27_;
#line 1328 "../lib/number.vala"
	if (string_get (str, (glong) second_index) == '\0') {
#line 1329 "../lib/number.vala"
		result = degrees;
#line 1329 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1329 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1329 "../lib/number.vala"
		return result;
#line 6064 "number.c"
	} else {
#line 1331 "../lib/number.vala"
		result = NULL;
#line 1331 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1331 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1331 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1331 "../lib/number.vala"
		return result;
#line 6076 "number.c"
	}
}

gboolean
mp_is_overflow (Number* x,
                gint wordlen)
{
	Number* t2 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	gboolean result;
#line 1335 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, FALSE);
#line 1337 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1337 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1337 "../lib/number.vala"
	_tmp2_ = number_xpowy_integer (_tmp1_, (gint64) wordlen);
#line 1337 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1337 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 1337 "../lib/number.vala"
	t2 = _tmp3_;
#line 1338 "../lib/number.vala"
	result = number_compare (t2, x) > 0;
#line 1338 "../lib/number.vala"
	_g_object_unref0 (t2);
#line 1338 "../lib/number.vala"
	return result;
#line 6110 "number.c"
}

