/* search-provider.c generated by valac 0.56.3, the Vala compiler
 * generated from search-provider.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2014 Michael Catanzaro
 * Copyright (C) 2018 Marco Trevisan
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <langinfo.h>
#include <float.h>
#include <math.h>
#include <errno.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <locale.h>

#define SEARCH_PROVIDER_MAX_CACHED_EQUATIONS 10
#define SEARCH_PROVIDER_COPY_TO_CLIPBOARD_ID "copy-to-clipboard-"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SEARCH_PROVIDER (search_provider_get_type ())
#define SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_PROVIDER, SearchProvider))
#define SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_PROVIDER, SearchProviderClass))
#define IS_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_PROVIDER))
#define IS_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_PROVIDER))
#define SEARCH_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_PROVIDER, SearchProviderClass))

typedef struct _SearchProvider SearchProvider;
typedef struct _SearchProviderClass SearchProviderClass;
typedef struct _SearchProviderPrivate SearchProviderPrivate;

#define TYPE_SEARCH_PROVIDER_APP (search_provider_app_get_type ())
#define SEARCH_PROVIDER_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_PROVIDER_APP, SearchProviderApp))
#define SEARCH_PROVIDER_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_PROVIDER_APP, SearchProviderAppClass))
#define IS_SEARCH_PROVIDER_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_PROVIDER_APP))
#define IS_SEARCH_PROVIDER_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_PROVIDER_APP))
#define SEARCH_PROVIDER_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_PROVIDER_APP, SearchProviderAppClass))

typedef struct _SearchProviderApp SearchProviderApp;
typedef struct _SearchProviderAppClass SearchProviderAppClass;
enum  {
	SEARCH_PROVIDER_0_PROPERTY,
	SEARCH_PROVIDER_NUM_PROPERTIES
};
static GParamSpec* search_provider_properties[SEARCH_PROVIDER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SearchProviderSolveSubprocessData SearchProviderSolveSubprocessData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _SearchProviderSolveEquationData SearchProviderSolveEquationData;
typedef struct _SearchProviderGetResultIdentifierData SearchProviderGetResultIdentifierData;
typedef struct _SearchProviderGetInitialResultSetData SearchProviderGetInitialResultSetData;
typedef struct _SearchProviderGetSubsearchResultSetData SearchProviderGetSubsearchResultSetData;
typedef struct _SearchProviderGetResultMetasData SearchProviderGetResultMetasData;
typedef struct _SearchProviderActivateResultData SearchProviderActivateResultData;
typedef struct _SearchProviderGetInitialResultSetReadyData SearchProviderGetInitialResultSetReadyData;
typedef struct _SearchProviderGetSubsearchResultSetReadyData SearchProviderGetSubsearchResultSetReadyData;
typedef struct _SearchProviderGetResultMetasReadyData SearchProviderGetResultMetasReadyData;
typedef struct _SearchProviderActivateResultReadyData SearchProviderActivateResultReadyData;
typedef struct _SearchProviderAppPrivate SearchProviderAppPrivate;
enum  {
	SEARCH_PROVIDER_APP_0_PROPERTY,
	SEARCH_PROVIDER_APP_NUM_PROPERTIES
};
static GParamSpec* search_provider_app_properties[SEARCH_PROVIDER_APP_NUM_PROPERTIES];
typedef struct _Block2Data Block2Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SearchProvider {
	GObject parent_instance;
	SearchProviderPrivate * priv;
};

struct _SearchProviderClass {
	GObjectClass parent_class;
};

struct _SearchProviderPrivate {
	SearchProviderApp* application;
	GCancellable* cancellable;
	GQueue* queued_equations;
	GHashTable* cached_equations;
};

struct _Block1Data {
	int _ref_count_;
	SearchProvider* self;
	GSubprocess* subprocess;
	gpointer _async_data_;
};

struct _SearchProviderSolveSubprocessData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SearchProvider* self;
	gchar* equation;
	GSubprocess* result;
	Block1Data* _data1_;
	gchar** argv;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint argv_length1;
	gint _argv_size_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GSubprocessFlags flags;
	GSubprocess* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GSubprocess* _tmp9_;
	GSubprocess* _tmp10_;
	GError* e;
	GError* _tmp11_;
	GError* _tmp12_;
	GCancellable* _tmp13_;
	GCancellable* _tmp14_;
	GCancellable* _tmp15_;
	SearchProviderApp* _tmp16_;
	GSubprocess* _tmp17_;
	GError* _inner_error0_;
};

struct _SearchProviderSolveEquationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SearchProvider* self;
	gchar* equation;
	gboolean result;
	gchar* _result_;
	gchar* tsep_string;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* decimal;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* normalized_equation;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	GHashTable* _tmp17_;
	gconstpointer _tmp18_;
	GSubprocess* subprocess;
	GSubprocess* _tmp19_;
	GSubprocess* _tmp20_;
	GCancellable* _tmp21_;
	gchar* _tmp22_;
	GSubprocess* _tmp23_;
	GCancellable* _tmp24_;
	GError* e;
	GError* _tmp25_;
	const gchar* _tmp26_;
	GError* _tmp27_;
	const gchar* _tmp28_;
	GError* _tmp29_;
	GQueue* _tmp30_;
	gchar* _tmp31_;
	GHashTable* _tmp32_;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	GQueue* _tmp36_;
	GHashTable* _tmp37_;
	GQueue* _tmp38_;
	gpointer _tmp39_;
	gchar* _tmp40_;
	GError* _inner_error0_;
};

struct _SearchProviderGetResultIdentifierData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SearchProvider* self;
	gchar** terms;
	gint terms_length1;
	gchar** result;
	gint result_length1;
	gchar* equation;
	gchar* _tmp0_;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GError* _inner_error0_;
};

struct _SearchProviderGetInitialResultSetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SearchProvider* self;
	gchar** terms;
	gint terms_length1;
	gchar** result;
	gint result_length1;
	gchar** _tmp0_;
	gint _tmp1_;
	gchar** _tmp2_;
	gint _tmp0__length1;
	gint __tmp0__size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GError* _inner_error0_;
};

struct _SearchProviderGetSubsearchResultSetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SearchProvider* self;
	gchar** previous_results;
	gint previous_results_length1;
	gchar** terms;
	gint terms_length1;
	gchar** result;
	gint result_length1;
	gchar** _tmp0_;
	gint _tmp1_;
	gchar** _tmp2_;
	gint _tmp0__length1;
	gint __tmp0__size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GError* _inner_error0_;
};

struct _SearchProviderGetResultMetasData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SearchProvider* self;
	gchar** results;
	gint results_length1;
	char* sender;
	GHashTable** result;
	gint result_length1;
	gchar* equation;
	gchar* _result_;
	guint32 equation_index;
	gboolean _tmp0_;
	const gchar* _tmp1_;
	GHashTable** _tmp2_;
	GHashTable** _tmp3_;
	gint _tmp3__length1;
	gboolean _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	const gchar* _tmp9_;
	GHashTable** _tmp10_;
	GHashTable** _tmp11_;
	gint _tmp11__length1;
	GHashTable* _tmp12_;
	const gchar* _tmp13_;
	gconstpointer _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	GHashTable** metadata;
	GHashTable** _tmp17_;
	gint metadata_length1;
	gint _metadata_size_;
	GHashTable** _tmp18_;
	gint _tmp18__length1;
	GHashFunc _tmp19_;
	GEqualFunc _tmp20_;
	GHashTable* _tmp21_;
	GHashTable** _tmp22_;
	gint _tmp22__length1;
	GHashTable* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	GVariant* _tmp26_;
	GHashTable** _tmp27_;
	gint _tmp27__length1;
	GHashTable* _tmp28_;
	gchar* _tmp29_;
	const gchar* _tmp30_;
	GVariant* _tmp31_;
	GHashTable** _tmp32_;
	gint _tmp32__length1;
	GHashTable* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GVariant* _tmp39_;
	guint32 copy_index;
	GHashTable** _tmp40_;
	gint _tmp40__length1;
	GHashFunc _tmp41_;
	GEqualFunc _tmp42_;
	GHashTable* _tmp43_;
	GHashTable** _tmp44_;
	gint _tmp44__length1;
	GHashTable* _tmp45_;
	gchar* _tmp46_;
	const gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	GVariant* _tmp50_;
	GHashTable** _tmp51_;
	gint _tmp51__length1;
	GHashTable* _tmp52_;
	gchar* _tmp53_;
	GVariant* _tmp54_;
	GHashTable** _tmp55_;
	gint _tmp55__length1;
	GHashTable* _tmp56_;
	gchar* _tmp57_;
	GVariant* _tmp58_;
	GHashTable** _tmp59_;
	gint _tmp59__length1;
	GHashTable* _tmp60_;
	gchar* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	GVariant* _tmp64_;
	GHashTable** _tmp65_;
	gint _tmp65__length1;
	GError* _inner_error0_;
};

struct _SearchProviderActivateResultData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SearchProvider* self;
	gchar* result_id;
	gchar** terms;
	gint terms_length1;
	guint32 timestamp;
	gchar* equation;
	gchar* _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	gchar* equation_result;
	GHashTable* _tmp3_;
	const gchar* _tmp4_;
	gconstpointer _tmp5_;
	gchar* _tmp6_;
	GdkClipboard* clipboard;
	GdkDisplay* _tmp7_;
	GdkClipboard* _tmp8_;
	GdkClipboard* _tmp9_;
	GdkClipboard* _tmp10_;
	const gchar* _tmp11_;
	GError* _inner_error0_;
};

struct _SearchProviderGetInitialResultSetReadyData {
	GDBusMethodInvocation* _invocation_;
	gchar** terms;
	gint terms_length1;
};

struct _SearchProviderGetSubsearchResultSetReadyData {
	GDBusMethodInvocation* _invocation_;
	gchar** previous_results;
	gint previous_results_length1;
	gchar** terms;
	gint terms_length1;
};

struct _SearchProviderGetResultMetasReadyData {
	GDBusMethodInvocation* _invocation_;
	gchar** results;
	gint results_length1;
};

struct _SearchProviderActivateResultReadyData {
	GDBusMethodInvocation* _invocation_;
	gchar* result_id;
	gchar** terms;
	gint terms_length1;
	guint32 timestamp;
};

struct _SearchProviderApp {
	GApplication parent_instance;
	SearchProviderAppPrivate * priv;
};

struct _SearchProviderAppClass {
	GApplicationClass parent_class;
};

struct _Block2Data {
	int _ref_count_;
	SearchProviderApp* self;
	SearchProvider* search_provider;
};

static gint SearchProvider_private_offset;
static gpointer search_provider_parent_class = NULL;
static gpointer search_provider_app_parent_class = NULL;

VALA_EXTERN GType search_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchProvider, g_object_unref)
VALA_EXTERN guint search_provider_register_object (void* object,
                                       GDBusConnection* connection,
                                       const gchar* path,
                                       GError** error);
VALA_EXTERN GType search_provider_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchProviderApp, g_object_unref)
VALA_EXTERN void search_provider_cancel (SearchProvider* self);
static void _g_free0_ (gpointer var);
static inline void _g_queue_free__g_free0_ (GQueue* self);
VALA_EXTERN SearchProvider* search_provider_new (SearchProviderApp* app);
VALA_EXTERN SearchProvider* search_provider_construct (GType object_type,
                                           SearchProviderApp* app);
static gchar* search_provider_terms_to_equation (gchar** terms,
                                          gint terms_length1);
static void search_provider_solve_subprocess_data_free (gpointer _data);
static void search_provider_solve_subprocess (SearchProvider* self,
                                       const gchar* equation,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static GSubprocess* search_provider_solve_subprocess_finish (SearchProvider* self,
                                                      GAsyncResult* _res_,
                                                      GError** error);
static gboolean search_provider_solve_subprocess_co (SearchProviderSolveSubprocessData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void __lambda5_ (Block1Data* _data1_);
static void ___lambda5__g_cancellable_cancelled (GCancellable* _sender,
                                          gpointer self);
VALA_EXTERN void search_provider_app_renew_inactivity_timeout (SearchProviderApp* self);
static void search_provider_solve_equation_data_free (gpointer _data);
static void search_provider_solve_equation (SearchProvider* self,
                                     const gchar* equation,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static gboolean search_provider_solve_equation_finish (SearchProvider* self,
                                                GAsyncResult* _res_,
                                                GError** error);
static gboolean search_provider_solve_equation_co (SearchProviderSolveEquationData* _data_);
static void search_provider_solve_equation_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void search_provider_get_result_identifier_data_free (gpointer _data);
static void search_provider_get_result_identifier (SearchProvider* self,
                                            gchar** terms,
                                            gint terms_length1,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static gchar** search_provider_get_result_identifier_finish (SearchProvider* self,
                                                      GAsyncResult* _res_,
                                                      gint* result_length1,
                                                      GError** error);
static gboolean search_provider_get_result_identifier_co (SearchProviderGetResultIdentifierData* _data_);
static void search_provider_get_result_identifier_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void search_provider_get_initial_result_set_data_free (gpointer _data);
VALA_EXTERN void search_provider_get_initial_result_set (SearchProvider* self,
                                             gchar** terms,
                                             gint terms_length1,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN gchar** search_provider_get_initial_result_set_finish (SearchProvider* self,
                                                       GAsyncResult* _res_,
                                                       gint* result_length1,
                                                       GError** error);
static gboolean search_provider_get_initial_result_set_co (SearchProviderGetInitialResultSetData* _data_);
static void search_provider_get_initial_result_set_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void search_provider_get_subsearch_result_set_data_free (gpointer _data);
VALA_EXTERN void search_provider_get_subsearch_result_set (SearchProvider* self,
                                               gchar** previous_results,
                                               gint previous_results_length1,
                                               gchar** terms,
                                               gint terms_length1,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
VALA_EXTERN gchar** search_provider_get_subsearch_result_set_finish (SearchProvider* self,
                                                         GAsyncResult* _res_,
                                                         gint* result_length1,
                                                         GError** error);
static gboolean search_provider_get_subsearch_result_set_co (SearchProviderGetSubsearchResultSetData* _data_);
static void search_provider_get_subsearch_result_set_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static void search_provider_get_result_metas_data_free (gpointer _data);
VALA_EXTERN void search_provider_get_result_metas (SearchProvider* self,
                                       gchar** results,
                                       gint results_length1,
                                       const char* sender,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
VALA_EXTERN GHashTable** search_provider_get_result_metas_finish (SearchProvider* self,
                                                      GAsyncResult* _res_,
                                                      gint* result_length1,
                                                      GError** error);
static gboolean search_provider_get_result_metas_co (SearchProviderGetResultMetasData* _data_);
static void search_provider_get_result_metas_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void _g_variant_unref0_ (gpointer var);
static GVariant* _variant_new1 (const gchar* value);
static GVariant* _variant_new2 (const gchar* value);
static GVariant* _variant_new3 (gchar* value);
static GVariant* _variant_new4 (gchar* value);
static GVariant* _variant_new5 (const gchar* value);
static GVariant* _variant_new6 (const gchar* value);
static GVariant* _variant_new7 (const gchar* value);
static void search_provider_spawn_and_display_equation (gchar** terms,
                                                 gint terms_length1,
                                                 GError** error);
static void search_provider_activate_result_data_free (gpointer _data);
VALA_EXTERN void search_provider_activate_result (SearchProvider* self,
                                      const gchar* result_id,
                                      gchar** terms,
                                      gint terms_length1,
                                      guint32 timestamp,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN void search_provider_activate_result_finish (SearchProvider* self,
                                             GAsyncResult* _res_,
                                             GError** error);
static gboolean search_provider_activate_result_co (SearchProviderActivateResultData* _data_);
static void search_provider_activate_result_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
VALA_EXTERN void search_provider_launch_search (SearchProvider* self,
                                    gchar** terms,
                                    gint terms_length1,
                                    guint32 timestamp,
                                    GError** error);
static void search_provider_finalize (GObject * obj);
static GType search_provider_get_type_once (void);
static void _dbus_search_provider_get_initial_result_set (SearchProvider* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_search_provider_get_initial_result_set_ready (GObject * source_object,
                                                         GAsyncResult * _res_,
                                                         gpointer _user_data_);
static void _dbus_search_provider_get_subsearch_result_set (SearchProvider* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_search_provider_get_subsearch_result_set_ready (GObject * source_object,
                                                           GAsyncResult * _res_,
                                                           gpointer _user_data_);
static void _dbus_search_provider_get_result_metas (SearchProvider* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation);
static void _dbus_search_provider_get_result_metas_ready (GObject * source_object,
                                                   GAsyncResult * _res_,
                                                   gpointer _user_data_);
static void _dbus_search_provider_activate_result (SearchProvider* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void _dbus_search_provider_activate_result_ready (GObject * source_object,
                                                  GAsyncResult * _res_,
                                                  gpointer _user_data_);
static void _dbus_search_provider_launch_search (SearchProvider* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation);
static void search_provider_dbus_interface_method_call (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* method_name,
                                                 GVariant* parameters,
                                                 GDBusMethodInvocation* invocation,
                                                 gpointer user_data);
static GVariant* search_provider_dbus_interface_get_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GError** error,
                                                       gpointer user_data);
static gboolean search_provider_dbus_interface_set_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GVariant* value,
                                                      GError** error,
                                                      gpointer user_data);
static void _search_provider_unregister_object (gpointer user_data);
VALA_EXTERN SearchProviderApp* search_provider_app_new (void);
VALA_EXTERN SearchProviderApp* search_provider_app_construct (GType object_type);
static gboolean search_provider_app_real_dbus_register (GApplication* base,
                                                 GDBusConnection* connection,
                                                 const gchar* object_path,
                                                 GError** error);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda4_ (Block2Data* _data2_);
static void ___lambda4__g_application_shutdown (GApplication* _sender,
                                         gpointer self);
static GType search_provider_app_get_type_once (void);
static gint _vala_main (gchar** args,
                 gint args_length1);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _search_provider_dbus_arg_info_get_initial_result_set_terms = {-1, "terms", "as", NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_get_initial_result_set_result = {-1, "result", "as", NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_get_initial_result_set_in[] = {&_search_provider_dbus_arg_info_get_initial_result_set_terms, NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_get_initial_result_set_out[] = {&_search_provider_dbus_arg_info_get_initial_result_set_result, NULL};
static const GDBusMethodInfo _search_provider_dbus_method_info_get_initial_result_set = {-1, "GetInitialResultSet", (GDBusArgInfo **) (&_search_provider_dbus_arg_info_get_initial_result_set_in), (GDBusArgInfo **) (&_search_provider_dbus_arg_info_get_initial_result_set_out), NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_get_subsearch_result_set_previous_results = {-1, "previous_results", "as", NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_get_subsearch_result_set_terms = {-1, "terms", "as", NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_get_subsearch_result_set_result = {-1, "result", "as", NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_get_subsearch_result_set_in[] = {&_search_provider_dbus_arg_info_get_subsearch_result_set_previous_results, &_search_provider_dbus_arg_info_get_subsearch_result_set_terms, NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_get_subsearch_result_set_out[] = {&_search_provider_dbus_arg_info_get_subsearch_result_set_result, NULL};
static const GDBusMethodInfo _search_provider_dbus_method_info_get_subsearch_result_set = {-1, "GetSubsearchResultSet", (GDBusArgInfo **) (&_search_provider_dbus_arg_info_get_subsearch_result_set_in), (GDBusArgInfo **) (&_search_provider_dbus_arg_info_get_subsearch_result_set_out), NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_get_result_metas_results = {-1, "results", "as", NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_get_result_metas_result = {-1, "result", "aa{sv}", NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_get_result_metas_in[] = {&_search_provider_dbus_arg_info_get_result_metas_results, NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_get_result_metas_out[] = {&_search_provider_dbus_arg_info_get_result_metas_result, NULL};
static const GDBusMethodInfo _search_provider_dbus_method_info_get_result_metas = {-1, "GetResultMetas", (GDBusArgInfo **) (&_search_provider_dbus_arg_info_get_result_metas_in), (GDBusArgInfo **) (&_search_provider_dbus_arg_info_get_result_metas_out), NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_activate_result_result_id = {-1, "result_id", "s", NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_activate_result_terms = {-1, "terms", "as", NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_activate_result_timestamp = {-1, "timestamp", "u", NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_activate_result_in[] = {&_search_provider_dbus_arg_info_activate_result_result_id, &_search_provider_dbus_arg_info_activate_result_terms, &_search_provider_dbus_arg_info_activate_result_timestamp, NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_activate_result_out[] = {NULL};
static const GDBusMethodInfo _search_provider_dbus_method_info_activate_result = {-1, "ActivateResult", (GDBusArgInfo **) (&_search_provider_dbus_arg_info_activate_result_in), (GDBusArgInfo **) (&_search_provider_dbus_arg_info_activate_result_out), NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_launch_search_terms = {-1, "terms", "as", NULL};
static const GDBusArgInfo _search_provider_dbus_arg_info_launch_search_timestamp = {-1, "timestamp", "u", NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_launch_search_in[] = {&_search_provider_dbus_arg_info_launch_search_terms, &_search_provider_dbus_arg_info_launch_search_timestamp, NULL};
static const GDBusArgInfo * const _search_provider_dbus_arg_info_launch_search_out[] = {NULL};
static const GDBusMethodInfo _search_provider_dbus_method_info_launch_search = {-1, "LaunchSearch", (GDBusArgInfo **) (&_search_provider_dbus_arg_info_launch_search_in), (GDBusArgInfo **) (&_search_provider_dbus_arg_info_launch_search_out), NULL};
static const GDBusMethodInfo * const _search_provider_dbus_method_info[] = {&_search_provider_dbus_method_info_get_initial_result_set, &_search_provider_dbus_method_info_get_subsearch_result_set, &_search_provider_dbus_method_info_get_result_metas, &_search_provider_dbus_method_info_activate_result, &_search_provider_dbus_method_info_launch_search, NULL};
static const GDBusSignalInfo * const _search_provider_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _search_provider_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _search_provider_dbus_interface_info = {-1, "org.gnome.Shell.SearchProvider2", (GDBusMethodInfo **) (&_search_provider_dbus_method_info), (GDBusSignalInfo **) (&_search_provider_dbus_signal_info), (GDBusPropertyInfo **) (&_search_provider_dbus_property_info), NULL};
static const GDBusInterfaceVTable _search_provider_dbus_interface_vtable = {search_provider_dbus_interface_method_call, search_provider_dbus_interface_get_property, search_provider_dbus_interface_set_property};

static inline gpointer
search_provider_get_instance_private (SearchProvider* self)
{
	return G_STRUCT_MEMBER_P (self, SearchProvider_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 20 "../search-provider/search-provider.vala"
	var = (g_free (var), NULL);
#line 718 "search-provider.c"
}

static inline void
_g_queue_free__g_free0_ (GQueue* self)
{
#line 20 "../search-provider/search-provider.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_free0_);
#line 726 "search-provider.c"
}

SearchProvider*
search_provider_construct (GType object_type,
                           SearchProviderApp* app)
{
	SearchProvider * self = NULL;
	GQueue* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
#line 25 "../search-provider/search-provider.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 25 "../search-provider/search-provider.vala"
	self = (SearchProvider*) g_object_new (object_type, NULL);
#line 27 "../search-provider/search-provider.vala"
	self->priv->application = app;
#line 29 "../search-provider/search-provider.vala"
	_tmp0_ = g_queue_new ();
#line 29 "../search-provider/search-provider.vala"
	(self->priv->queued_equations == NULL) ? NULL : (self->priv->queued_equations = (_g_queue_free__g_free0_ (self->priv->queued_equations), NULL));
#line 29 "../search-provider/search-provider.vala"
	self->priv->queued_equations = _tmp0_;
#line 30 "../search-provider/search-provider.vala"
	_tmp1_ = g_str_hash;
#line 30 "../search-provider/search-provider.vala"
	_tmp2_ = g_str_equal;
#line 30 "../search-provider/search-provider.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_free0_);
#line 30 "../search-provider/search-provider.vala"
	_g_hash_table_unref0 (self->priv->cached_equations);
#line 30 "../search-provider/search-provider.vala"
	self->priv->cached_equations = _tmp3_;
#line 25 "../search-provider/search-provider.vala"
	return self;
#line 762 "search-provider.c"
}

SearchProvider*
search_provider_new (SearchProviderApp* app)
{
#line 25 "../search-provider/search-provider.vala"
	return search_provider_construct (TYPE_SEARCH_PROVIDER, app);
#line 770 "search-provider.c"
}

void
search_provider_cancel (SearchProvider* self)
{
	GCancellable* _tmp0_;
#line 39 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 41 "../search-provider/search-provider.vala"
	_tmp0_ = self->priv->cancellable;
#line 41 "../search-provider/search-provider.vala"
	if (_tmp0_ != NULL) {
#line 783 "search-provider.c"
		GCancellable* _tmp1_;
#line 42 "../search-provider/search-provider.vala"
		_tmp1_ = self->priv->cancellable;
#line 42 "../search-provider/search-provider.vala"
		g_cancellable_cancel (_tmp1_);
#line 789 "search-provider.c"
	}
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 804 "search-provider.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 808 "search-provider.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 814 "search-provider.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 819 "search-provider.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 825 "search-provider.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 829 "search-provider.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 833 "search-provider.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 837 "search-provider.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 841 "search-provider.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 845 "search-provider.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 860 "search-provider.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 869 "search-provider.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 876 "search-provider.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 882 "search-provider.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 890 "search-provider.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 894 "search-provider.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 900 "search-provider.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 905 "search-provider.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 911 "search-provider.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 915 "search-provider.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 919 "search-provider.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 925 "search-provider.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 931 "search-provider.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 943 "search-provider.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 947 "search-provider.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 951 "search-provider.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 956 "search-provider.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 964 "search-provider.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 982 "search-provider.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 988 "search-provider.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 992 "search-provider.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1000 "search-provider.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1009 "search-provider.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1018 "search-provider.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1024 "search-provider.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1032 "search-provider.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1044 "search-provider.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1050 "search-provider.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1054 "search-provider.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1062 "search-provider.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1073 "search-provider.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1082 "search-provider.c"
	}
}

static gchar*
search_provider_terms_to_equation (gchar** terms,
                                   gint terms_length1)
{
	gchar* _tmp0_;
	gchar* result;
#line 47 "../search-provider/search-provider.vala"
	_tmp0_ = _vala_g_strjoinv (" ", terms, (gint) terms_length1);
#line 47 "../search-provider/search-provider.vala"
	result = _tmp0_;
#line 47 "../search-provider/search-provider.vala"
	return result;
#line 1098 "search-provider.c"
}

static void
search_provider_solve_subprocess_data_free (gpointer _data)
{
	SearchProviderSolveSubprocessData* _data_;
	_data_ = _data;
#line 14 "../search-provider/search-provider.vala"
	_g_free0 (_data_->equation);
#line 14 "../search-provider/search-provider.vala"
	_g_object_unref0 (_data_->result);
#line 14 "../search-provider/search-provider.vala"
	_g_object_unref0 (_data_->self);
#line 14 "../search-provider/search-provider.vala"
	g_slice_free (SearchProviderSolveSubprocessData, _data_);
#line 1114 "search-provider.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 14 "../search-provider/search-provider.vala"
	return self ? g_object_ref (self) : NULL;
#line 1122 "search-provider.c"
}

static void
search_provider_solve_subprocess (SearchProvider* self,
                                  const gchar* equation,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	SearchProviderSolveSubprocessData* _data_;
	SearchProvider* _tmp0_;
	gchar* _tmp1_;
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (equation != NULL);
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_slice_new0 (SearchProviderSolveSubprocessData);
#line 14 "../search-provider/search-provider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 14 "../search-provider/search-provider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, search_provider_solve_subprocess_data_free);
#line 14 "../search-provider/search-provider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "../search-provider/search-provider.vala"
	_data_->self = _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	_tmp1_ = g_strdup (equation);
#line 14 "../search-provider/search-provider.vala"
	_g_free0 (_data_->equation);
#line 14 "../search-provider/search-provider.vala"
	_data_->equation = _tmp1_;
#line 14 "../search-provider/search-provider.vala"
	search_provider_solve_subprocess_co (_data_);
#line 1156 "search-provider.c"
}

static GSubprocess*
search_provider_solve_subprocess_finish (SearchProvider* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	GSubprocess* result;
	SearchProviderSolveSubprocessData* _data_;
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "../search-provider/search-provider.vala"
	if (NULL == _data_) {
#line 14 "../search-provider/search-provider.vala"
		return NULL;
#line 1172 "search-provider.c"
	}
#line 14 "../search-provider/search-provider.vala"
	result = _data_->result;
#line 14 "../search-provider/search-provider.vala"
	_data_->result = NULL;
#line 14 "../search-provider/search-provider.vala"
	return result;
#line 1180 "search-provider.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 50 "../search-provider/search-provider.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 50 "../search-provider/search-provider.vala"
	return _data1_;
#line 1190 "search-provider.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 50 "../search-provider/search-provider.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1200 "search-provider.c"
		SearchProvider* self;
#line 50 "../search-provider/search-provider.vala"
		self = _data1_->self;
#line 50 "../search-provider/search-provider.vala"
		_g_object_unref0 (_data1_->subprocess);
#line 50 "../search-provider/search-provider.vala"
		_g_object_unref0 (self);
#line 50 "../search-provider/search-provider.vala"
		g_slice_free (Block1Data, _data1_);
#line 1210 "search-provider.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 54 "../search-provider/search-provider.vala"
	if ((*length) == (*size)) {
#line 54 "../search-provider/search-provider.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 54 "../search-provider/search-provider.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1226 "search-provider.c"
	}
#line 54 "../search-provider/search-provider.vala"
	(*array)[(*length)++] = value;
#line 54 "../search-provider/search-provider.vala"
	(*array)[*length] = NULL;
#line 1232 "search-provider.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 55 "../search-provider/search-provider.vala"
	if ((*length) == (*size)) {
#line 55 "../search-provider/search-provider.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 55 "../search-provider/search-provider.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1247 "search-provider.c"
	}
#line 55 "../search-provider/search-provider.vala"
	(*array)[(*length)++] = value;
#line 55 "../search-provider/search-provider.vala"
	(*array)[*length] = NULL;
#line 1253 "search-provider.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 1266 "search-provider.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 68 "../search-provider/search-provider.vala"
	return self ? g_error_copy (self) : NULL;
#line 1274 "search-provider.c"
}

static void
__lambda5_ (Block1Data* _data1_)
{
	SearchProvider* self;
#line 74 "../search-provider/search-provider.vala"
	self = _data1_->self;
#line 75 "../search-provider/search-provider.vala"
	g_subprocess_force_exit (_data1_->subprocess);
#line 76 "../search-provider/search-provider.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 76 "../search-provider/search-provider.vala"
	self->priv->cancellable = NULL;
#line 1289 "search-provider.c"
}

static void
___lambda5__g_cancellable_cancelled (GCancellable* _sender,
                                     gpointer self)
{
#line 74 "../search-provider/search-provider.vala"
	__lambda5_ (self);
#line 1298 "search-provider.c"
}

static gboolean
search_provider_solve_subprocess_co (SearchProviderSolveSubprocessData* _data_)
{
#line 50 "../search-provider/search-provider.vala"
	switch (_data_->_state_) {
#line 50 "../search-provider/search-provider.vala"
		case 0:
#line 1308 "search-provider.c"
		goto _state_0;
		default:
#line 50 "../search-provider/search-provider.vala"
		g_assert_not_reached ();
#line 1313 "search-provider.c"
	}
	_state_0:
#line 50 "../search-provider/search-provider.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 50 "../search-provider/search-provider.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 50 "../search-provider/search-provider.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 50 "../search-provider/search-provider.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 53 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = g_strdup ("gnome-calculator");
#line 53 "../search-provider/search-provider.vala"
	_data_->_tmp1_ = g_strdup ("--solve");
#line 53 "../search-provider/search-provider.vala"
	_data_->_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 53 "../search-provider/search-provider.vala"
	_data_->_tmp2_[0] = _data_->_tmp0_;
#line 53 "../search-provider/search-provider.vala"
	_data_->_tmp2_[1] = _data_->_tmp1_;
#line 53 "../search-provider/search-provider.vala"
	_data_->argv = _data_->_tmp2_;
#line 53 "../search-provider/search-provider.vala"
	_data_->argv_length1 = 2;
#line 53 "../search-provider/search-provider.vala"
	_data_->_argv_size_ = _data_->argv_length1;
#line 54 "../search-provider/search-provider.vala"
	_data_->_tmp3_ = g_strdup (_data_->equation);
#line 54 "../search-provider/search-provider.vala"
	_vala_array_add1 (&_data_->argv, &_data_->argv_length1, &_data_->_argv_size_, _data_->_tmp3_);
#line 55 "../search-provider/search-provider.vala"
	_vala_array_add2 (&_data_->argv, &_data_->argv_length1, &_data_->_argv_size_, NULL);
#line 57 "../search-provider/search-provider.vala"
	_data_->_tmp4_ = string_to_string (_data_->equation);
#line 57 "../search-provider/search-provider.vala"
	_data_->_tmp5_ = g_strconcat ("Trying to solve ", _data_->_tmp4_, NULL);
#line 57 "../search-provider/search-provider.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 57 "../search-provider/search-provider.vala"
	g_debug ("search-provider.vala:57: %s", _data_->_tmp6_);
#line 57 "../search-provider/search-provider.vala"
	_g_free0 (_data_->_tmp6_);
#line 1356 "search-provider.c"
	{
#line 63 "../search-provider/search-provider.vala"
		_data_->flags = G_SUBPROCESS_FLAGS_STDOUT_PIPE | G_SUBPROCESS_FLAGS_STDERR_PIPE;
#line 64 "../search-provider/search-provider.vala"
		_data_->_tmp8_ = _data_->argv;
#line 64 "../search-provider/search-provider.vala"
		_data_->_tmp8__length1 = _data_->argv_length1;
#line 64 "../search-provider/search-provider.vala"
		_data_->_tmp9_ = g_subprocess_newv (_data_->_tmp8_, _data_->flags, &_data_->_inner_error0_);
#line 64 "../search-provider/search-provider.vala"
		_data_->_tmp7_ = _data_->_tmp9_;
#line 64 "../search-provider/search-provider.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1370 "search-provider.c"
			goto __catch0_g_error;
		}
#line 64 "../search-provider/search-provider.vala"
		_data_->_tmp10_ = _data_->_tmp7_;
#line 64 "../search-provider/search-provider.vala"
		_data_->_tmp7_ = NULL;
#line 64 "../search-provider/search-provider.vala"
		_g_object_unref0 (_data_->_data1_->subprocess);
#line 64 "../search-provider/search-provider.vala"
		_data_->_data1_->subprocess = _data_->_tmp10_;
#line 59 "../search-provider/search-provider.vala"
		_g_object_unref0 (_data_->_tmp7_);
#line 1383 "search-provider.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 59 "../search-provider/search-provider.vala"
		_data_->e = _data_->_inner_error0_;
#line 59 "../search-provider/search-provider.vala"
		_data_->_inner_error0_ = NULL;
#line 68 "../search-provider/search-provider.vala"
		_data_->_tmp11_ = _data_->e;
#line 68 "../search-provider/search-provider.vala"
		_data_->_tmp12_ = _g_error_copy0 (_data_->_tmp11_);
#line 68 "../search-provider/search-provider.vala"
		_data_->_inner_error0_ = _data_->_tmp12_;
#line 68 "../search-provider/search-provider.vala"
		_g_error_free0 (_data_->e);
#line 1400 "search-provider.c"
		goto __finally0;
	}
	__finally0:
#line 59 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 59 "../search-provider/search-provider.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 59 "../search-provider/search-provider.vala"
		_data_->argv = (_vala_array_free (_data_->argv, _data_->argv_length1, (GDestroyNotify) g_free), NULL);
#line 59 "../search-provider/search-provider.vala"
		block1_data_unref (_data_->_data1_);
#line 59 "../search-provider/search-provider.vala"
		_data_->_data1_ = NULL;
#line 59 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 59 "../search-provider/search-provider.vala"
		return FALSE;
#line 1418 "search-provider.c"
	}
#line 71 "../search-provider/search-provider.vala"
	_data_->_tmp13_ = _data_->self->priv->cancellable;
#line 71 "../search-provider/search-provider.vala"
	if (_data_->_tmp13_ == NULL) {
#line 72 "../search-provider/search-provider.vala"
		_data_->_tmp14_ = g_cancellable_new ();
#line 72 "../search-provider/search-provider.vala"
		_g_object_unref0 (_data_->self->priv->cancellable);
#line 72 "../search-provider/search-provider.vala"
		_data_->self->priv->cancellable = _data_->_tmp14_;
#line 1430 "search-provider.c"
	}
#line 74 "../search-provider/search-provider.vala"
	_data_->_tmp15_ = _data_->self->priv->cancellable;
#line 74 "../search-provider/search-provider.vala"
	g_signal_connect_data (_data_->_tmp15_, "cancelled", (GCallback) ___lambda5__g_cancellable_cancelled, block1_data_ref (_data_->_data1_), (GClosureNotify) block1_data_unref, 0);
#line 79 "../search-provider/search-provider.vala"
	_data_->_tmp16_ = _data_->self->priv->application;
#line 79 "../search-provider/search-provider.vala"
	search_provider_app_renew_inactivity_timeout (_data_->_tmp16_);
#line 81 "../search-provider/search-provider.vala"
	_data_->_tmp17_ = _g_object_ref0 (_data_->_data1_->subprocess);
#line 81 "../search-provider/search-provider.vala"
	_data_->result = _data_->_tmp17_;
#line 81 "../search-provider/search-provider.vala"
	_data_->argv = (_vala_array_free (_data_->argv, _data_->argv_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../search-provider/search-provider.vala"
	block1_data_unref (_data_->_data1_);
#line 81 "../search-provider/search-provider.vala"
	_data_->_data1_ = NULL;
#line 81 "../search-provider/search-provider.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 81 "../search-provider/search-provider.vala"
	if (_data_->_state_ != 0) {
#line 81 "../search-provider/search-provider.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 81 "../search-provider/search-provider.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1458 "search-provider.c"
		}
	}
#line 81 "../search-provider/search-provider.vala"
	g_object_unref (_data_->_async_result);
#line 81 "../search-provider/search-provider.vala"
	return FALSE;
#line 1465 "search-provider.c"
}

static void
search_provider_solve_equation_data_free (gpointer _data)
{
	SearchProviderSolveEquationData* _data_;
	_data_ = _data;
#line 14 "../search-provider/search-provider.vala"
	_g_free0 (_data_->equation);
#line 14 "../search-provider/search-provider.vala"
	_g_object_unref0 (_data_->self);
#line 14 "../search-provider/search-provider.vala"
	g_slice_free (SearchProviderSolveEquationData, _data_);
#line 1479 "search-provider.c"
}

static void
search_provider_solve_equation (SearchProvider* self,
                                const gchar* equation,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	SearchProviderSolveEquationData* _data_;
	SearchProvider* _tmp0_;
	gchar* _tmp1_;
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (equation != NULL);
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_slice_new0 (SearchProviderSolveEquationData);
#line 14 "../search-provider/search-provider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 14 "../search-provider/search-provider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, search_provider_solve_equation_data_free);
#line 14 "../search-provider/search-provider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "../search-provider/search-provider.vala"
	_data_->self = _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	_tmp1_ = g_strdup (equation);
#line 14 "../search-provider/search-provider.vala"
	_g_free0 (_data_->equation);
#line 14 "../search-provider/search-provider.vala"
	_data_->equation = _tmp1_;
#line 14 "../search-provider/search-provider.vala"
	search_provider_solve_equation_co (_data_);
#line 1513 "search-provider.c"
}

static gboolean
search_provider_solve_equation_finish (SearchProvider* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	gboolean result;
	SearchProviderSolveEquationData* _data_;
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "../search-provider/search-provider.vala"
	if (NULL == _data_) {
#line 1527 "search-provider.c"
		gboolean _tmp0_ = FALSE;
#line 14 "../search-provider/search-provider.vala"
		return _tmp0_;
#line 1531 "search-provider.c"
	}
#line 14 "../search-provider/search-provider.vala"
	result = _data_->result;
#line 14 "../search-provider/search-provider.vala"
	return result;
#line 1537 "search-provider.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1559 "search-provider.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1563 "search-provider.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1569 "search-provider.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1573 "search-provider.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1577 "search-provider.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1585 "search-provider.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1613 "search-provider.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1622 "search-provider.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1636 "search-provider.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1645 "search-provider.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1659 "search-provider.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1668 "search-provider.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1677 "search-provider.c"
}

static gboolean
double_try_parse (const gchar* str,
                  gdouble* _result_,
                  const gchar** unparsed)
{
	gdouble _vala__result_ = 0.0;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gdouble _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 1007 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 1009 "glib-2.0.vapi"
	errno = 0;
#line 1010 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtod (str, &_tmp0_);
#line 1010 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 1010 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 1011 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 1011 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 1011 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1011 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 1012 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 1013 "glib-2.0.vapi"
		result = errno != ERANGE;
#line 1013 "glib-2.0.vapi"
		if (_result_) {
#line 1013 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1720 "search-provider.c"
		}
#line 1013 "glib-2.0.vapi"
		if (unparsed) {
#line 1013 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1726 "search-provider.c"
		}
#line 1013 "glib-2.0.vapi"
		return result;
#line 1730 "search-provider.c"
	} else {
		gchar* _tmp5_;
#line 1015 "glib-2.0.vapi"
		_tmp5_ = endptr;
#line 1015 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 1016 "glib-2.0.vapi"
		result = FALSE;
#line 1016 "glib-2.0.vapi"
		if (_result_) {
#line 1016 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1743 "search-provider.c"
		}
#line 1016 "glib-2.0.vapi"
		if (unparsed) {
#line 1016 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1749 "search-provider.c"
		}
#line 1016 "glib-2.0.vapi"
		return result;
#line 1753 "search-provider.c"
	}
}

static void
search_provider_solve_equation_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	SearchProviderSolveEquationData* _data_;
#line 111 "../search-provider/search-provider.vala"
	_data_ = _user_data_;
#line 111 "../search-provider/search-provider.vala"
	_data_->_source_object_ = source_object;
#line 111 "../search-provider/search-provider.vala"
	_data_->_res_ = _res_;
#line 111 "../search-provider/search-provider.vala"
	search_provider_solve_equation_co (_data_);
#line 1771 "search-provider.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 1792 "search-provider.c"
}

static gboolean
search_provider_solve_equation_co (SearchProviderSolveEquationData* _data_)
{
#line 84 "../search-provider/search-provider.vala"
	switch (_data_->_state_) {
#line 84 "../search-provider/search-provider.vala"
		case 0:
#line 1802 "search-provider.c"
		goto _state_0;
#line 84 "../search-provider/search-provider.vala"
		case 1:
#line 1806 "search-provider.c"
		goto _state_1;
#line 84 "../search-provider/search-provider.vala"
		case 2:
#line 1810 "search-provider.c"
		goto _state_2;
		default:
#line 84 "../search-provider/search-provider.vala"
		g_assert_not_reached ();
#line 1815 "search-provider.c"
	}
	_state_0:
#line 88 "../search-provider/search-provider.vala"
	search_provider_cancel (_data_->self);
#line 90 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = nl_langinfo (THOUSEP);
#line 90 "../search-provider/search-provider.vala"
	_data_->_tmp1_ = g_strdup (_data_->_tmp0_);
#line 90 "../search-provider/search-provider.vala"
	_data_->tsep_string = _data_->_tmp1_;
#line 91 "../search-provider/search-provider.vala"
	_data_->_tmp3_ = _data_->tsep_string;
#line 91 "../search-provider/search-provider.vala"
	if (_data_->_tmp3_ == NULL) {
#line 91 "../search-provider/search-provider.vala"
		_data_->_tmp2_ = TRUE;
#line 1832 "search-provider.c"
	} else {
#line 91 "../search-provider/search-provider.vala"
		_data_->_tmp4_ = _data_->tsep_string;
#line 91 "../search-provider/search-provider.vala"
		_data_->_tmp2_ = g_strcmp0 (_data_->_tmp4_, "") == 0;
#line 1838 "search-provider.c"
	}
#line 91 "../search-provider/search-provider.vala"
	if (_data_->_tmp2_) {
#line 92 "../search-provider/search-provider.vala"
		_data_->_tmp5_ = g_strdup (" ");
#line 92 "../search-provider/search-provider.vala"
		_g_free0 (_data_->tsep_string);
#line 92 "../search-provider/search-provider.vala"
		_data_->tsep_string = _data_->_tmp5_;
#line 1848 "search-provider.c"
	}
#line 94 "../search-provider/search-provider.vala"
	_data_->_tmp6_ = nl_langinfo (RADIXCHAR);
#line 94 "../search-provider/search-provider.vala"
	_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
#line 94 "../search-provider/search-provider.vala"
	_data_->decimal = _data_->_tmp7_;
#line 95 "../search-provider/search-provider.vala"
	_data_->_tmp8_ = _data_->decimal;
#line 95 "../search-provider/search-provider.vala"
	if (_data_->_tmp8_ == NULL) {
#line 96 "../search-provider/search-provider.vala"
		_data_->_tmp9_ = g_strdup ("");
#line 96 "../search-provider/search-provider.vala"
		_g_free0 (_data_->decimal);
#line 96 "../search-provider/search-provider.vala"
		_data_->decimal = _data_->_tmp9_;
#line 1866 "search-provider.c"
	}
#line 99 "../search-provider/search-provider.vala"
	_data_->_tmp10_ = _data_->tsep_string;
#line 99 "../search-provider/search-provider.vala"
	_data_->_tmp11_ = string_replace (_data_->equation, _data_->_tmp10_, "");
#line 99 "../search-provider/search-provider.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 99 "../search-provider/search-provider.vala"
	_data_->_tmp13_ = _data_->decimal;
#line 99 "../search-provider/search-provider.vala"
	_data_->_tmp14_ = string_replace (_data_->_tmp12_, _data_->_tmp13_, ".");
#line 99 "../search-provider/search-provider.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 99 "../search-provider/search-provider.vala"
	_g_free0 (_data_->_tmp12_);
#line 99 "../search-provider/search-provider.vala"
	_data_->normalized_equation = _data_->_tmp15_;
#line 102 "../search-provider/search-provider.vala"
	_data_->_tmp16_ = _data_->normalized_equation;
#line 102 "../search-provider/search-provider.vala"
	if (double_try_parse (_data_->_tmp16_, NULL, NULL)) {
#line 103 "../search-provider/search-provider.vala"
		_data_->result = FALSE;
#line 103 "../search-provider/search-provider.vala"
		_g_free0 (_data_->normalized_equation);
#line 103 "../search-provider/search-provider.vala"
		_g_free0 (_data_->decimal);
#line 103 "../search-provider/search-provider.vala"
		_g_free0 (_data_->tsep_string);
#line 103 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_result_);
#line 103 "../search-provider/search-provider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 103 "../search-provider/search-provider.vala"
		if (_data_->_state_ != 0) {
#line 103 "../search-provider/search-provider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 103 "../search-provider/search-provider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1906 "search-provider.c"
			}
		}
#line 103 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 103 "../search-provider/search-provider.vala"
		return FALSE;
#line 1913 "search-provider.c"
	}
#line 106 "../search-provider/search-provider.vala"
	_data_->_tmp17_ = _data_->self->priv->cached_equations;
#line 106 "../search-provider/search-provider.vala"
	_data_->_tmp18_ = g_hash_table_lookup (_data_->_tmp17_, _data_->equation);
#line 106 "../search-provider/search-provider.vala"
	if (((const gchar*) _data_->_tmp18_) != NULL) {
#line 107 "../search-provider/search-provider.vala"
		_data_->result = TRUE;
#line 107 "../search-provider/search-provider.vala"
		_g_free0 (_data_->normalized_equation);
#line 107 "../search-provider/search-provider.vala"
		_g_free0 (_data_->decimal);
#line 107 "../search-provider/search-provider.vala"
		_g_free0 (_data_->tsep_string);
#line 107 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_result_);
#line 107 "../search-provider/search-provider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 107 "../search-provider/search-provider.vala"
		if (_data_->_state_ != 0) {
#line 107 "../search-provider/search-provider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 107 "../search-provider/search-provider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1939 "search-provider.c"
			}
		}
#line 107 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 107 "../search-provider/search-provider.vala"
		return FALSE;
#line 1946 "search-provider.c"
	}
	{
#line 111 "../search-provider/search-provider.vala"
		_data_->_state_ = 1;
#line 111 "../search-provider/search-provider.vala"
		search_provider_solve_subprocess (_data_->self, _data_->equation, search_provider_solve_equation_ready, _data_);
#line 111 "../search-provider/search-provider.vala"
		return FALSE;
#line 1955 "search-provider.c"
		_state_1:
#line 111 "../search-provider/search-provider.vala"
		_data_->_tmp19_ = search_provider_solve_subprocess_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 111 "../search-provider/search-provider.vala"
		_data_->subprocess = _data_->_tmp19_;
#line 111 "../search-provider/search-provider.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 111 "../search-provider/search-provider.vala"
			if (_data_->_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1965 "search-provider.c"
				goto __catch0_g_spawn_error;
			}
			goto __catch0_g_error;
		}
#line 112 "../search-provider/search-provider.vala"
		_data_->_tmp20_ = _data_->subprocess;
#line 112 "../search-provider/search-provider.vala"
		_data_->_tmp21_ = _data_->self->priv->cancellable;
#line 112 "../search-provider/search-provider.vala"
		_data_->_tmp22_ = NULL;
#line 112 "../search-provider/search-provider.vala"
		_data_->_state_ = 2;
#line 112 "../search-provider/search-provider.vala"
		g_subprocess_communicate_utf8_async (_data_->_tmp20_, NULL, _data_->_tmp21_, search_provider_solve_equation_ready, _data_);
#line 112 "../search-provider/search-provider.vala"
		return FALSE;
#line 1982 "search-provider.c"
		_state_2:
#line 112 "../search-provider/search-provider.vala"
		g_subprocess_communicate_utf8_finish (_data_->_tmp20_, _data_->_res_, &_data_->_tmp22_, NULL, &_data_->_inner_error0_);
#line 112 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_result_);
#line 112 "../search-provider/search-provider.vala"
		_data_->_result_ = _data_->_tmp22_;
#line 112 "../search-provider/search-provider.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 112 "../search-provider/search-provider.vala"
			_g_object_unref0 (_data_->subprocess);
#line 112 "../search-provider/search-provider.vala"
			if (_data_->_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1996 "search-provider.c"
				goto __catch0_g_spawn_error;
			}
			goto __catch0_g_error;
		}
#line 113 "../search-provider/search-provider.vala"
		_data_->_tmp23_ = _data_->subprocess;
#line 113 "../search-provider/search-provider.vala"
		_data_->_tmp24_ = _data_->self->priv->cancellable;
#line 113 "../search-provider/search-provider.vala"
		g_subprocess_wait_check (_data_->_tmp23_, _data_->_tmp24_, &_data_->_inner_error0_);
#line 113 "../search-provider/search-provider.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 113 "../search-provider/search-provider.vala"
			_g_object_unref0 (_data_->subprocess);
#line 113 "../search-provider/search-provider.vala"
			if (_data_->_inner_error0_->domain == G_SPAWN_ERROR) {
#line 2013 "search-provider.c"
				goto __catch0_g_spawn_error;
			}
			goto __catch0_g_error;
		}
#line 109 "../search-provider/search-provider.vala"
		_g_object_unref0 (_data_->subprocess);
#line 2020 "search-provider.c"
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
#line 109 "../search-provider/search-provider.vala"
		_data_->e = _data_->_inner_error0_;
#line 109 "../search-provider/search-provider.vala"
		_data_->_inner_error0_ = NULL;
#line 117 "../search-provider/search-provider.vala"
		_data_->_tmp25_ = _data_->e;
#line 117 "../search-provider/search-provider.vala"
		_data_->_tmp26_ = _data_->_tmp25_->message;
#line 117 "../search-provider/search-provider.vala"
		g_critical ("search-provider.vala:117: Failed to spawn Calculator: %s", _data_->_tmp26_);
#line 118 "../search-provider/search-provider.vala"
		_data_->_tmp27_ = _data_->e;
#line 118 "../search-provider/search-provider.vala"
		_data_->_tmp28_ = _data_->_tmp27_->message;
#line 118 "../search-provider/search-provider.vala"
		_data_->_tmp29_ = g_error_new_literal (G_DBUS_ERROR, G_DBUS_ERROR_SPAWN_FAILED, _data_->_tmp28_);
#line 118 "../search-provider/search-provider.vala"
		_data_->_inner_error0_ = _data_->_tmp29_;
#line 118 "../search-provider/search-provider.vala"
		_g_error_free0 (_data_->e);
#line 2045 "search-provider.c"
		goto __finally0;
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 109 "../search-provider/search-provider.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 122 "../search-provider/search-provider.vala"
		_data_->result = FALSE;
#line 122 "../search-provider/search-provider.vala"
		_g_free0 (_data_->normalized_equation);
#line 122 "../search-provider/search-provider.vala"
		_g_free0 (_data_->decimal);
#line 122 "../search-provider/search-provider.vala"
		_g_free0 (_data_->tsep_string);
#line 122 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_result_);
#line 122 "../search-provider/search-provider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 122 "../search-provider/search-provider.vala"
		if (_data_->_state_ != 0) {
#line 122 "../search-provider/search-provider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 122 "../search-provider/search-provider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2071 "search-provider.c"
			}
		}
#line 122 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 122 "../search-provider/search-provider.vala"
		return FALSE;
#line 2078 "search-provider.c"
	}
	__finally0:
#line 109 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 109 "../search-provider/search-provider.vala"
		if (_data_->_inner_error0_->domain == G_DBUS_ERROR) {
#line 109 "../search-provider/search-provider.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 109 "../search-provider/search-provider.vala"
			_g_free0 (_data_->normalized_equation);
#line 109 "../search-provider/search-provider.vala"
			_g_free0 (_data_->decimal);
#line 109 "../search-provider/search-provider.vala"
			_g_free0 (_data_->tsep_string);
#line 109 "../search-provider/search-provider.vala"
			_g_free0 (_data_->_result_);
#line 109 "../search-provider/search-provider.vala"
			g_object_unref (_data_->_async_result);
#line 109 "../search-provider/search-provider.vala"
			return FALSE;
#line 2099 "search-provider.c"
		} else {
#line 109 "../search-provider/search-provider.vala"
			_g_free0 (_data_->normalized_equation);
#line 109 "../search-provider/search-provider.vala"
			_g_free0 (_data_->decimal);
#line 109 "../search-provider/search-provider.vala"
			_g_free0 (_data_->tsep_string);
#line 109 "../search-provider/search-provider.vala"
			_g_free0 (_data_->_result_);
#line 109 "../search-provider/search-provider.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 109 "../search-provider/search-provider.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 109 "../search-provider/search-provider.vala"
			g_object_unref (_data_->_async_result);
#line 109 "../search-provider/search-provider.vala"
			return FALSE;
#line 2117 "search-provider.c"
		}
	}
#line 125 "../search-provider/search-provider.vala"
	_data_->_tmp30_ = _data_->self->priv->queued_equations;
#line 125 "../search-provider/search-provider.vala"
	_data_->_tmp31_ = g_strdup (_data_->equation);
#line 125 "../search-provider/search-provider.vala"
	g_queue_push_tail (_data_->_tmp30_, _data_->_tmp31_);
#line 126 "../search-provider/search-provider.vala"
	_data_->_tmp32_ = _data_->self->priv->cached_equations;
#line 126 "../search-provider/search-provider.vala"
	_data_->_tmp33_ = g_strdup (_data_->equation);
#line 126 "../search-provider/search-provider.vala"
	_data_->_tmp34_ = _data_->_result_;
#line 126 "../search-provider/search-provider.vala"
	_data_->_tmp35_ = string_strip (_data_->_tmp34_);
#line 126 "../search-provider/search-provider.vala"
	g_hash_table_insert (_data_->_tmp32_, _data_->_tmp33_, _data_->_tmp35_);
#line 128 "../search-provider/search-provider.vala"
	_data_->_tmp36_ = _data_->self->priv->queued_equations;
#line 128 "../search-provider/search-provider.vala"
	if (_data_->_tmp36_->length > ((guint) SEARCH_PROVIDER_MAX_CACHED_EQUATIONS)) {
#line 129 "../search-provider/search-provider.vala"
		_data_->_tmp37_ = _data_->self->priv->cached_equations;
#line 129 "../search-provider/search-provider.vala"
		_data_->_tmp38_ = _data_->self->priv->queued_equations;
#line 129 "../search-provider/search-provider.vala"
		_data_->_tmp39_ = g_queue_pop_head (_data_->_tmp38_);
#line 129 "../search-provider/search-provider.vala"
		_data_->_tmp40_ = (gchar*) _data_->_tmp39_;
#line 129 "../search-provider/search-provider.vala"
		g_hash_table_remove (_data_->_tmp37_, _data_->_tmp40_);
#line 129 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_tmp40_);
#line 2152 "search-provider.c"
	}
#line 131 "../search-provider/search-provider.vala"
	_data_->result = TRUE;
#line 131 "../search-provider/search-provider.vala"
	_g_free0 (_data_->normalized_equation);
#line 131 "../search-provider/search-provider.vala"
	_g_free0 (_data_->decimal);
#line 131 "../search-provider/search-provider.vala"
	_g_free0 (_data_->tsep_string);
#line 131 "../search-provider/search-provider.vala"
	_g_free0 (_data_->_result_);
#line 131 "../search-provider/search-provider.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 131 "../search-provider/search-provider.vala"
	if (_data_->_state_ != 0) {
#line 131 "../search-provider/search-provider.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 131 "../search-provider/search-provider.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2172 "search-provider.c"
		}
	}
#line 131 "../search-provider/search-provider.vala"
	g_object_unref (_data_->_async_result);
#line 131 "../search-provider/search-provider.vala"
	return FALSE;
#line 2179 "search-provider.c"
}

static void
search_provider_get_result_identifier_data_free (gpointer _data)
{
	SearchProviderGetResultIdentifierData* _data_;
	_data_ = _data;
#line 14 "../search-provider/search-provider.vala"
	_data_->result = (_vala_array_free (_data_->result, _data_->result_length1, (GDestroyNotify) g_free), NULL);
#line 14 "../search-provider/search-provider.vala"
	_g_object_unref0 (_data_->self);
#line 14 "../search-provider/search-provider.vala"
	g_slice_free (SearchProviderGetResultIdentifierData, _data_);
#line 2193 "search-provider.c"
}

static void
search_provider_get_result_identifier (SearchProvider* self,
                                       gchar** terms,
                                       gint terms_length1,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	SearchProviderGetResultIdentifierData* _data_;
	SearchProvider* _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_slice_new0 (SearchProviderGetResultIdentifierData);
#line 14 "../search-provider/search-provider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 14 "../search-provider/search-provider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, search_provider_get_result_identifier_data_free);
#line 14 "../search-provider/search-provider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "../search-provider/search-provider.vala"
	_data_->self = _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	_data_->terms = terms;
#line 14 "../search-provider/search-provider.vala"
	_data_->terms_length1 = terms_length1;
#line 14 "../search-provider/search-provider.vala"
	search_provider_get_result_identifier_co (_data_);
#line 2223 "search-provider.c"
}

static gchar**
search_provider_get_result_identifier_finish (SearchProvider* self,
                                              GAsyncResult* _res_,
                                              gint* result_length1,
                                              GError** error)
{
	gchar** result;
	SearchProviderGetResultIdentifierData* _data_;
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "../search-provider/search-provider.vala"
	if (NULL == _data_) {
#line 14 "../search-provider/search-provider.vala"
		return NULL;
#line 2240 "search-provider.c"
	}
#line 14 "../search-provider/search-provider.vala"
	result = _data_->result;
#line 14 "../search-provider/search-provider.vala"
	*result_length1 = _data_->result_length1;
#line 14 "../search-provider/search-provider.vala"
	_data_->result = NULL;
#line 14 "../search-provider/search-provider.vala"
	return result;
#line 2250 "search-provider.c"
}

static void
search_provider_get_result_identifier_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	SearchProviderGetResultIdentifierData* _data_;
#line 138 "../search-provider/search-provider.vala"
	_data_ = _user_data_;
#line 138 "../search-provider/search-provider.vala"
	_data_->_source_object_ = source_object;
#line 138 "../search-provider/search-provider.vala"
	_data_->_res_ = _res_;
#line 138 "../search-provider/search-provider.vala"
	search_provider_get_result_identifier_co (_data_);
#line 2267 "search-provider.c"
}

static gboolean
search_provider_get_result_identifier_co (SearchProviderGetResultIdentifierData* _data_)
{
#line 134 "../search-provider/search-provider.vala"
	switch (_data_->_state_) {
#line 134 "../search-provider/search-provider.vala"
		case 0:
#line 2277 "search-provider.c"
		goto _state_0;
#line 134 "../search-provider/search-provider.vala"
		case 1:
#line 2281 "search-provider.c"
		goto _state_1;
		default:
#line 134 "../search-provider/search-provider.vala"
		g_assert_not_reached ();
#line 2286 "search-provider.c"
	}
	_state_0:
#line 137 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = search_provider_terms_to_equation (_data_->terms, (gint) _data_->terms_length1);
#line 137 "../search-provider/search-provider.vala"
	_data_->equation = _data_->_tmp0_;
#line 138 "../search-provider/search-provider.vala"
	_data_->_state_ = 1;
#line 138 "../search-provider/search-provider.vala"
	search_provider_solve_equation (_data_->self, _data_->equation, search_provider_get_result_identifier_ready, _data_);
#line 138 "../search-provider/search-provider.vala"
	return FALSE;
#line 2299 "search-provider.c"
	_state_1:
#line 138 "../search-provider/search-provider.vala"
	_data_->_tmp1_ = search_provider_solve_equation_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 138 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 138 "../search-provider/search-provider.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 138 "../search-provider/search-provider.vala"
		_g_free0 (_data_->equation);
#line 138 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 138 "../search-provider/search-provider.vala"
		return FALSE;
#line 2313 "search-provider.c"
	}
#line 138 "../search-provider/search-provider.vala"
	if (_data_->_tmp1_) {
#line 139 "../search-provider/search-provider.vala"
		_data_->_tmp2_ = g_strdup (_data_->equation);
#line 139 "../search-provider/search-provider.vala"
		_data_->_tmp3_ = g_strconcat (SEARCH_PROVIDER_COPY_TO_CLIPBOARD_ID, _data_->equation, NULL);
#line 139 "../search-provider/search-provider.vala"
		_data_->_tmp4_ = g_new0 (gchar*, 2 + 1);
#line 139 "../search-provider/search-provider.vala"
		_data_->_tmp4_[0] = _data_->_tmp2_;
#line 139 "../search-provider/search-provider.vala"
		_data_->_tmp4_[1] = _data_->_tmp3_;
#line 139 "../search-provider/search-provider.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 139 "../search-provider/search-provider.vala"
		_data_->_tmp5__length1 = 2;
#line 139 "../search-provider/search-provider.vala"
		_data_->result_length1 = _data_->_tmp5__length1;
#line 139 "../search-provider/search-provider.vala"
		_data_->result = _data_->_tmp5_;
#line 139 "../search-provider/search-provider.vala"
		_g_free0 (_data_->equation);
#line 139 "../search-provider/search-provider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 139 "../search-provider/search-provider.vala"
		if (_data_->_state_ != 0) {
#line 139 "../search-provider/search-provider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 139 "../search-provider/search-provider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2345 "search-provider.c"
			}
		}
#line 139 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 139 "../search-provider/search-provider.vala"
		return FALSE;
#line 2352 "search-provider.c"
	} else {
#line 141 "../search-provider/search-provider.vala"
		_data_->_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 141 "../search-provider/search-provider.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 141 "../search-provider/search-provider.vala"
		_data_->_tmp7__length1 = 0;
#line 141 "../search-provider/search-provider.vala"
		_data_->result_length1 = _data_->_tmp7__length1;
#line 141 "../search-provider/search-provider.vala"
		_data_->result = _data_->_tmp7_;
#line 141 "../search-provider/search-provider.vala"
		_g_free0 (_data_->equation);
#line 141 "../search-provider/search-provider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 141 "../search-provider/search-provider.vala"
		if (_data_->_state_ != 0) {
#line 141 "../search-provider/search-provider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 141 "../search-provider/search-provider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2374 "search-provider.c"
			}
		}
#line 141 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 141 "../search-provider/search-provider.vala"
		return FALSE;
#line 2381 "search-provider.c"
	}
}

static void
search_provider_get_initial_result_set_data_free (gpointer _data)
{
	SearchProviderGetInitialResultSetData* _data_;
	_data_ = _data;
#line 14 "../search-provider/search-provider.vala"
	_data_->result = (_vala_array_free (_data_->result, _data_->result_length1, (GDestroyNotify) g_free), NULL);
#line 14 "../search-provider/search-provider.vala"
	_g_object_unref0 (_data_->self);
#line 14 "../search-provider/search-provider.vala"
	g_slice_free (SearchProviderGetInitialResultSetData, _data_);
#line 2396 "search-provider.c"
}

void
search_provider_get_initial_result_set (SearchProvider* self,
                                        gchar** terms,
                                        gint terms_length1,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	SearchProviderGetInitialResultSetData* _data_;
	SearchProvider* _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_slice_new0 (SearchProviderGetInitialResultSetData);
#line 14 "../search-provider/search-provider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 14 "../search-provider/search-provider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, search_provider_get_initial_result_set_data_free);
#line 14 "../search-provider/search-provider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "../search-provider/search-provider.vala"
	_data_->self = _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	_data_->terms = terms;
#line 14 "../search-provider/search-provider.vala"
	_data_->terms_length1 = terms_length1;
#line 14 "../search-provider/search-provider.vala"
	search_provider_get_initial_result_set_co (_data_);
#line 2426 "search-provider.c"
}

gchar**
search_provider_get_initial_result_set_finish (SearchProvider* self,
                                               GAsyncResult* _res_,
                                               gint* result_length1,
                                               GError** error)
{
	gchar** result;
	SearchProviderGetInitialResultSetData* _data_;
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "../search-provider/search-provider.vala"
	if (NULL == _data_) {
#line 14 "../search-provider/search-provider.vala"
		return NULL;
#line 2443 "search-provider.c"
	}
#line 14 "../search-provider/search-provider.vala"
	result = _data_->result;
#line 14 "../search-provider/search-provider.vala"
	*result_length1 = _data_->result_length1;
#line 14 "../search-provider/search-provider.vala"
	_data_->result = NULL;
#line 14 "../search-provider/search-provider.vala"
	return result;
#line 2453 "search-provider.c"
}

static void
search_provider_get_initial_result_set_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	SearchProviderGetInitialResultSetData* _data_;
#line 146 "../search-provider/search-provider.vala"
	_data_ = _user_data_;
#line 146 "../search-provider/search-provider.vala"
	_data_->_source_object_ = source_object;
#line 146 "../search-provider/search-provider.vala"
	_data_->_res_ = _res_;
#line 146 "../search-provider/search-provider.vala"
	search_provider_get_initial_result_set_co (_data_);
#line 2470 "search-provider.c"
}

static gboolean
search_provider_get_initial_result_set_co (SearchProviderGetInitialResultSetData* _data_)
{
#line 144 "../search-provider/search-provider.vala"
	switch (_data_->_state_) {
#line 144 "../search-provider/search-provider.vala"
		case 0:
#line 2480 "search-provider.c"
		goto _state_0;
#line 144 "../search-provider/search-provider.vala"
		case 1:
#line 2484 "search-provider.c"
		goto _state_1;
		default:
#line 144 "../search-provider/search-provider.vala"
		g_assert_not_reached ();
#line 2489 "search-provider.c"
	}
	_state_0:
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp1_ = 0;
#line 146 "../search-provider/search-provider.vala"
	_data_->_state_ = 1;
#line 146 "../search-provider/search-provider.vala"
	search_provider_get_result_identifier (_data_->self, _data_->terms, (gint) _data_->terms_length1, search_provider_get_initial_result_set_ready, _data_);
#line 146 "../search-provider/search-provider.vala"
	return FALSE;
#line 2500 "search-provider.c"
	_state_1:
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp2_ = search_provider_get_result_identifier_finish (_data_->self, _data_->_res_, &_data_->_tmp1_, &_data_->_inner_error0_);
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = _data_->_tmp2_;
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp0__length1 = _data_->_tmp1_;
#line 146 "../search-provider/search-provider.vala"
	_data_->__tmp0__size_ = _data_->_tmp0__length1;
#line 146 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 146 "../search-provider/search-provider.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 146 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 146 "../search-provider/search-provider.vala"
		return FALSE;
#line 2518 "search-provider.c"
	}
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp3_ = _data_->_tmp0_;
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp3__length1 = _data_->_tmp0__length1;
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = NULL;
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp0__length1 = 0;
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp4__length1 = _data_->_tmp3__length1;
#line 146 "../search-provider/search-provider.vala"
	_data_->result_length1 = _data_->_tmp4__length1;
#line 146 "../search-provider/search-provider.vala"
	_data_->result = _data_->_tmp4_;
#line 146 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = (_vala_array_free (_data_->_tmp0_, _data_->_tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 146 "../search-provider/search-provider.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 146 "../search-provider/search-provider.vala"
	if (_data_->_state_ != 0) {
#line 146 "../search-provider/search-provider.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 146 "../search-provider/search-provider.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2546 "search-provider.c"
		}
	}
#line 146 "../search-provider/search-provider.vala"
	g_object_unref (_data_->_async_result);
#line 146 "../search-provider/search-provider.vala"
	return FALSE;
#line 2553 "search-provider.c"
}

static void
search_provider_get_subsearch_result_set_data_free (gpointer _data)
{
	SearchProviderGetSubsearchResultSetData* _data_;
	_data_ = _data;
#line 14 "../search-provider/search-provider.vala"
	_data_->result = (_vala_array_free (_data_->result, _data_->result_length1, (GDestroyNotify) g_free), NULL);
#line 14 "../search-provider/search-provider.vala"
	_g_object_unref0 (_data_->self);
#line 14 "../search-provider/search-provider.vala"
	g_slice_free (SearchProviderGetSubsearchResultSetData, _data_);
#line 2567 "search-provider.c"
}

void
search_provider_get_subsearch_result_set (SearchProvider* self,
                                          gchar** previous_results,
                                          gint previous_results_length1,
                                          gchar** terms,
                                          gint terms_length1,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	SearchProviderGetSubsearchResultSetData* _data_;
	SearchProvider* _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_slice_new0 (SearchProviderGetSubsearchResultSetData);
#line 14 "../search-provider/search-provider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 14 "../search-provider/search-provider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, search_provider_get_subsearch_result_set_data_free);
#line 14 "../search-provider/search-provider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "../search-provider/search-provider.vala"
	_data_->self = _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	_data_->previous_results = previous_results;
#line 14 "../search-provider/search-provider.vala"
	_data_->previous_results_length1 = previous_results_length1;
#line 14 "../search-provider/search-provider.vala"
	_data_->terms = terms;
#line 14 "../search-provider/search-provider.vala"
	_data_->terms_length1 = terms_length1;
#line 14 "../search-provider/search-provider.vala"
	search_provider_get_subsearch_result_set_co (_data_);
#line 2603 "search-provider.c"
}

gchar**
search_provider_get_subsearch_result_set_finish (SearchProvider* self,
                                                 GAsyncResult* _res_,
                                                 gint* result_length1,
                                                 GError** error)
{
	gchar** result;
	SearchProviderGetSubsearchResultSetData* _data_;
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "../search-provider/search-provider.vala"
	if (NULL == _data_) {
#line 14 "../search-provider/search-provider.vala"
		return NULL;
#line 2620 "search-provider.c"
	}
#line 14 "../search-provider/search-provider.vala"
	result = _data_->result;
#line 14 "../search-provider/search-provider.vala"
	*result_length1 = _data_->result_length1;
#line 14 "../search-provider/search-provider.vala"
	_data_->result = NULL;
#line 14 "../search-provider/search-provider.vala"
	return result;
#line 2630 "search-provider.c"
}

static void
search_provider_get_subsearch_result_set_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	SearchProviderGetSubsearchResultSetData* _data_;
#line 151 "../search-provider/search-provider.vala"
	_data_ = _user_data_;
#line 151 "../search-provider/search-provider.vala"
	_data_->_source_object_ = source_object;
#line 151 "../search-provider/search-provider.vala"
	_data_->_res_ = _res_;
#line 151 "../search-provider/search-provider.vala"
	search_provider_get_subsearch_result_set_co (_data_);
#line 2647 "search-provider.c"
}

static gboolean
search_provider_get_subsearch_result_set_co (SearchProviderGetSubsearchResultSetData* _data_)
{
#line 149 "../search-provider/search-provider.vala"
	switch (_data_->_state_) {
#line 149 "../search-provider/search-provider.vala"
		case 0:
#line 2657 "search-provider.c"
		goto _state_0;
#line 149 "../search-provider/search-provider.vala"
		case 1:
#line 2661 "search-provider.c"
		goto _state_1;
		default:
#line 149 "../search-provider/search-provider.vala"
		g_assert_not_reached ();
#line 2666 "search-provider.c"
	}
	_state_0:
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp1_ = 0;
#line 151 "../search-provider/search-provider.vala"
	_data_->_state_ = 1;
#line 151 "../search-provider/search-provider.vala"
	search_provider_get_result_identifier (_data_->self, _data_->terms, (gint) _data_->terms_length1, search_provider_get_subsearch_result_set_ready, _data_);
#line 151 "../search-provider/search-provider.vala"
	return FALSE;
#line 2677 "search-provider.c"
	_state_1:
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp2_ = search_provider_get_result_identifier_finish (_data_->self, _data_->_res_, &_data_->_tmp1_, &_data_->_inner_error0_);
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = _data_->_tmp2_;
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp0__length1 = _data_->_tmp1_;
#line 151 "../search-provider/search-provider.vala"
	_data_->__tmp0__size_ = _data_->_tmp0__length1;
#line 151 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 151 "../search-provider/search-provider.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 151 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 151 "../search-provider/search-provider.vala"
		return FALSE;
#line 2695 "search-provider.c"
	}
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp3_ = _data_->_tmp0_;
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp3__length1 = _data_->_tmp0__length1;
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = NULL;
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp0__length1 = 0;
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp4__length1 = _data_->_tmp3__length1;
#line 151 "../search-provider/search-provider.vala"
	_data_->result_length1 = _data_->_tmp4__length1;
#line 151 "../search-provider/search-provider.vala"
	_data_->result = _data_->_tmp4_;
#line 151 "../search-provider/search-provider.vala"
	_data_->_tmp0_ = (_vala_array_free (_data_->_tmp0_, _data_->_tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 151 "../search-provider/search-provider.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 151 "../search-provider/search-provider.vala"
	if (_data_->_state_ != 0) {
#line 151 "../search-provider/search-provider.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 151 "../search-provider/search-provider.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2723 "search-provider.c"
		}
	}
#line 151 "../search-provider/search-provider.vala"
	g_object_unref (_data_->_async_result);
#line 151 "../search-provider/search-provider.vala"
	return FALSE;
#line 2730 "search-provider.c"
}

static void
search_provider_get_result_metas_data_free (gpointer _data)
{
	SearchProviderGetResultMetasData* _data_;
	_data_ = _data;
#line 14 "../search-provider/search-provider.vala"
	_g_free0 (_data_->sender);
#line 14 "../search-provider/search-provider.vala"
	_data_->result = (_vala_array_free (_data_->result, _data_->result_length1, (GDestroyNotify) g_hash_table_unref), NULL);
#line 14 "../search-provider/search-provider.vala"
	_g_object_unref0 (_data_->self);
#line 14 "../search-provider/search-provider.vala"
	g_slice_free (SearchProviderGetResultMetasData, _data_);
#line 2746 "search-provider.c"
}

void
search_provider_get_result_metas (SearchProvider* self,
                                  gchar** results,
                                  gint results_length1,
                                  const char* sender,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	SearchProviderGetResultMetasData* _data_;
	SearchProvider* _tmp0_;
	char* _tmp1_;
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (sender != NULL);
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_slice_new0 (SearchProviderGetResultMetasData);
#line 14 "../search-provider/search-provider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 14 "../search-provider/search-provider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, search_provider_get_result_metas_data_free);
#line 14 "../search-provider/search-provider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "../search-provider/search-provider.vala"
	_data_->self = _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	_data_->results = results;
#line 14 "../search-provider/search-provider.vala"
	_data_->results_length1 = results_length1;
#line 14 "../search-provider/search-provider.vala"
	_tmp1_ = g_strdup (sender);
#line 14 "../search-provider/search-provider.vala"
	_g_free0 (_data_->sender);
#line 14 "../search-provider/search-provider.vala"
	_data_->sender = _tmp1_;
#line 14 "../search-provider/search-provider.vala"
	search_provider_get_result_metas_co (_data_);
#line 2786 "search-provider.c"
}

GHashTable**
search_provider_get_result_metas_finish (SearchProvider* self,
                                         GAsyncResult* _res_,
                                         gint* result_length1,
                                         GError** error)
{
	GHashTable** result;
	SearchProviderGetResultMetasData* _data_;
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "../search-provider/search-provider.vala"
	if (NULL == _data_) {
#line 14 "../search-provider/search-provider.vala"
		return NULL;
#line 2803 "search-provider.c"
	}
#line 14 "../search-provider/search-provider.vala"
	result = _data_->result;
#line 14 "../search-provider/search-provider.vala"
	*result_length1 = _data_->result_length1;
#line 14 "../search-provider/search-provider.vala"
	_data_->result = NULL;
#line 14 "../search-provider/search-provider.vala"
	return result;
#line 2813 "search-provider.c"
}

static void
search_provider_get_result_metas_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	SearchProviderGetResultMetasData* _data_;
#line 171 "../search-provider/search-provider.vala"
	_data_ = _user_data_;
#line 171 "../search-provider/search-provider.vala"
	_data_->_source_object_ = source_object;
#line 171 "../search-provider/search-provider.vala"
	_data_->_res_ = _res_;
#line 171 "../search-provider/search-provider.vala"
	search_provider_get_result_metas_co (_data_);
#line 2830 "search-provider.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 179 "../search-provider/search-provider.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 2838 "search-provider.c"
}

static GVariant*
_variant_new1 (const gchar* value)
{
#line 180 "../search-provider/search-provider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2846 "search-provider.c"
}

static GVariant*
_variant_new2 (const gchar* value)
{
#line 181 "../search-provider/search-provider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2854 "search-provider.c"
}

static GVariant*
_variant_new3 (gchar* value)
{
#line 182 "../search-provider/search-provider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2862 "search-provider.c"
}

static GVariant*
_variant_new4 (gchar* value)
{
#line 188 "../search-provider/search-provider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2870 "search-provider.c"
}

static GVariant*
_variant_new5 (const gchar* value)
{
#line 189 "../search-provider/search-provider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2878 "search-provider.c"
}

static GVariant*
_variant_new6 (const gchar* value)
{
#line 190 "../search-provider/search-provider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2886 "search-provider.c"
}

static GVariant*
_variant_new7 (const gchar* value)
{
#line 191 "../search-provider/search-provider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2894 "search-provider.c"
}

static gboolean
search_provider_get_result_metas_co (SearchProviderGetResultMetasData* _data_)
{
#line 154 "../search-provider/search-provider.vala"
	switch (_data_->_state_) {
#line 154 "../search-provider/search-provider.vala"
		case 0:
#line 2904 "search-provider.c"
		goto _state_0;
#line 154 "../search-provider/search-provider.vala"
		case 1:
#line 2908 "search-provider.c"
		goto _state_1;
		default:
#line 154 "../search-provider/search-provider.vala"
		g_assert_not_reached ();
#line 2913 "search-provider.c"
	}
	_state_0:
#line 154 "../search-provider/search-provider.vala"
	_vala_return_val_if_fail ((_data_->results_length1 == 1) || (_data_->results_length1 == 2), "results.length == 1 || results.length == 2", FALSE);
#line 161 "../search-provider/search-provider.vala"
	if (_data_->results_length1 == 1) {
#line 161 "../search-provider/search-provider.vala"
		_data_->_tmp1_ = _data_->results[0];
#line 161 "../search-provider/search-provider.vala"
		_data_->_tmp0_ = g_str_has_prefix (_data_->_tmp1_, SEARCH_PROVIDER_COPY_TO_CLIPBOARD_ID);
#line 2924 "search-provider.c"
	} else {
#line 161 "../search-provider/search-provider.vala"
		_data_->_tmp0_ = FALSE;
#line 2928 "search-provider.c"
	}
#line 161 "../search-provider/search-provider.vala"
	if (_data_->_tmp0_) {
#line 162 "../search-provider/search-provider.vala"
		_data_->_tmp2_ = g_new0 (GHashTable*, 0 + 1);
#line 162 "../search-provider/search-provider.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 162 "../search-provider/search-provider.vala"
		_data_->_tmp3__length1 = 0;
#line 162 "../search-provider/search-provider.vala"
		_data_->result_length1 = _data_->_tmp3__length1;
#line 162 "../search-provider/search-provider.vala"
		_data_->result = _data_->_tmp3_;
#line 162 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_result_);
#line 162 "../search-provider/search-provider.vala"
		_g_free0 (_data_->equation);
#line 162 "../search-provider/search-provider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 162 "../search-provider/search-provider.vala"
		if (_data_->_state_ != 0) {
#line 162 "../search-provider/search-provider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 162 "../search-provider/search-provider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2954 "search-provider.c"
			}
		}
#line 162 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 162 "../search-provider/search-provider.vala"
		return FALSE;
#line 2961 "search-provider.c"
	}
#line 164 "../search-provider/search-provider.vala"
	if (_data_->results_length1 == 1) {
#line 164 "../search-provider/search-provider.vala"
		_data_->_tmp4_ = TRUE;
#line 2967 "search-provider.c"
	} else {
#line 164 "../search-provider/search-provider.vala"
		_data_->_tmp5_ = _data_->results[1];
#line 164 "../search-provider/search-provider.vala"
		_data_->_tmp4_ = g_str_has_prefix (_data_->_tmp5_, SEARCH_PROVIDER_COPY_TO_CLIPBOARD_ID);
#line 2973 "search-provider.c"
	}
#line 164 "../search-provider/search-provider.vala"
	if (_data_->_tmp4_) {
#line 165 "../search-provider/search-provider.vala"
		_data_->equation_index = (guint32) 0;
#line 2979 "search-provider.c"
	} else {
#line 167 "../search-provider/search-provider.vala"
		_data_->equation_index = (guint32) 1;
#line 2983 "search-provider.c"
	}
#line 169 "../search-provider/search-provider.vala"
	_data_->_tmp6_ = _data_->results[_data_->equation_index];
#line 169 "../search-provider/search-provider.vala"
	_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
#line 169 "../search-provider/search-provider.vala"
	_g_free0 (_data_->equation);
#line 169 "../search-provider/search-provider.vala"
	_data_->equation = _data_->_tmp7_;
#line 171 "../search-provider/search-provider.vala"
	_data_->_tmp9_ = _data_->equation;
#line 171 "../search-provider/search-provider.vala"
	_data_->_state_ = 1;
#line 171 "../search-provider/search-provider.vala"
	search_provider_solve_equation (_data_->self, _data_->_tmp9_, search_provider_get_result_metas_ready, _data_);
#line 171 "../search-provider/search-provider.vala"
	return FALSE;
#line 3001 "search-provider.c"
	_state_1:
#line 171 "../search-provider/search-provider.vala"
	_data_->_tmp8_ = search_provider_solve_equation_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 171 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 171 "../search-provider/search-provider.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 171 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_result_);
#line 171 "../search-provider/search-provider.vala"
		_g_free0 (_data_->equation);
#line 171 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 171 "../search-provider/search-provider.vala"
		return FALSE;
#line 3017 "search-provider.c"
	}
#line 171 "../search-provider/search-provider.vala"
	if (!_data_->_tmp8_) {
#line 172 "../search-provider/search-provider.vala"
		_data_->_tmp10_ = g_new0 (GHashTable*, 0 + 1);
#line 172 "../search-provider/search-provider.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 172 "../search-provider/search-provider.vala"
		_data_->_tmp11__length1 = 0;
#line 172 "../search-provider/search-provider.vala"
		_data_->result_length1 = _data_->_tmp11__length1;
#line 172 "../search-provider/search-provider.vala"
		_data_->result = _data_->_tmp11_;
#line 172 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_result_);
#line 172 "../search-provider/search-provider.vala"
		_g_free0 (_data_->equation);
#line 172 "../search-provider/search-provider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 172 "../search-provider/search-provider.vala"
		if (_data_->_state_ != 0) {
#line 172 "../search-provider/search-provider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 172 "../search-provider/search-provider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3043 "search-provider.c"
			}
		}
#line 172 "../search-provider/search-provider.vala"
		g_object_unref (_data_->_async_result);
#line 172 "../search-provider/search-provider.vala"
		return FALSE;
#line 3050 "search-provider.c"
	}
#line 174 "../search-provider/search-provider.vala"
	_data_->_tmp12_ = _data_->self->priv->cached_equations;
#line 174 "../search-provider/search-provider.vala"
	_data_->_tmp13_ = _data_->equation;
#line 174 "../search-provider/search-provider.vala"
	_data_->_tmp14_ = g_hash_table_lookup (_data_->_tmp12_, _data_->_tmp13_);
#line 174 "../search-provider/search-provider.vala"
	_data_->_tmp15_ = g_strdup ((const gchar*) _data_->_tmp14_);
#line 174 "../search-provider/search-provider.vala"
	_g_free0 (_data_->_result_);
#line 174 "../search-provider/search-provider.vala"
	_data_->_result_ = _data_->_tmp15_;
#line 175 "../search-provider/search-provider.vala"
	_data_->_tmp16_ = _data_->_result_;
#line 175 "../search-provider/search-provider.vala"
	_vala_assert (_data_->_tmp16_ != NULL, "result != null");
#line 177 "../search-provider/search-provider.vala"
	_data_->_tmp17_ = g_new0 (GHashTable*, _data_->results_length1 + 1);
#line 177 "../search-provider/search-provider.vala"
	_data_->metadata = _data_->_tmp17_;
#line 177 "../search-provider/search-provider.vala"
	_data_->metadata_length1 = _data_->results_length1;
#line 177 "../search-provider/search-provider.vala"
	_data_->_metadata_size_ = _data_->metadata_length1;
#line 179 "../search-provider/search-provider.vala"
	_data_->_tmp18_ = _data_->metadata;
#line 179 "../search-provider/search-provider.vala"
	_data_->_tmp18__length1 = _data_->metadata_length1;
#line 179 "../search-provider/search-provider.vala"
	_data_->_tmp19_ = g_str_hash;
#line 179 "../search-provider/search-provider.vala"
	_data_->_tmp20_ = g_str_equal;
#line 179 "../search-provider/search-provider.vala"
	_data_->_tmp21_ = g_hash_table_new_full (_data_->_tmp19_, _data_->_tmp20_, _g_free0_, _g_variant_unref0_);
#line 179 "../search-provider/search-provider.vala"
	_g_hash_table_unref0 (_data_->_tmp18_[_data_->equation_index]);
#line 179 "../search-provider/search-provider.vala"
	_data_->_tmp18_[_data_->equation_index] = _data_->_tmp21_;
#line 180 "../search-provider/search-provider.vala"
	_data_->_tmp22_ = _data_->metadata;
#line 180 "../search-provider/search-provider.vala"
	_data_->_tmp22__length1 = _data_->metadata_length1;
#line 180 "../search-provider/search-provider.vala"
	_data_->_tmp23_ = _data_->_tmp22_[_data_->equation_index];
#line 180 "../search-provider/search-provider.vala"
	_data_->_tmp24_ = g_strdup ("id");
#line 180 "../search-provider/search-provider.vala"
	_data_->_tmp25_ = _data_->equation;
#line 180 "../search-provider/search-provider.vala"
	_data_->_tmp26_ = _variant_new1 (_data_->_tmp25_);
#line 180 "../search-provider/search-provider.vala"
	g_hash_table_insert (_data_->_tmp23_, _data_->_tmp24_, _data_->_tmp26_);
#line 181 "../search-provider/search-provider.vala"
	_data_->_tmp27_ = _data_->metadata;
#line 181 "../search-provider/search-provider.vala"
	_data_->_tmp27__length1 = _data_->metadata_length1;
#line 181 "../search-provider/search-provider.vala"
	_data_->_tmp28_ = _data_->_tmp27_[_data_->equation_index];
#line 181 "../search-provider/search-provider.vala"
	_data_->_tmp29_ = g_strdup ("name");
#line 181 "../search-provider/search-provider.vala"
	_data_->_tmp30_ = _data_->equation;
#line 181 "../search-provider/search-provider.vala"
	_data_->_tmp31_ = _variant_new2 (_data_->_tmp30_);
#line 181 "../search-provider/search-provider.vala"
	g_hash_table_insert (_data_->_tmp28_, _data_->_tmp29_, _data_->_tmp31_);
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp32_ = _data_->metadata;
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp32__length1 = _data_->metadata_length1;
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp33_ = _data_->_tmp32_[_data_->equation_index];
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp34_ = g_strdup ("description");
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp35_ = _data_->_result_;
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp36_ = string_to_string (_data_->_tmp35_);
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp37_ = g_strconcat (" = ", _data_->_tmp36_, NULL);
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 182 "../search-provider/search-provider.vala"
	_data_->_tmp39_ = _variant_new3 (_data_->_tmp38_);
#line 182 "../search-provider/search-provider.vala"
	g_hash_table_insert (_data_->_tmp33_, _data_->_tmp34_, _data_->_tmp39_);
#line 182 "../search-provider/search-provider.vala"
	_g_free0 (_data_->_tmp38_);
#line 184 "../search-provider/search-provider.vala"
	if (_data_->results_length1 == 2) {
#line 186 "../search-provider/search-provider.vala"
		_data_->copy_index = (_data_->equation_index + 1) % 2;
#line 187 "../search-provider/search-provider.vala"
		_data_->_tmp40_ = _data_->metadata;
#line 187 "../search-provider/search-provider.vala"
		_data_->_tmp40__length1 = _data_->metadata_length1;
#line 187 "../search-provider/search-provider.vala"
		_data_->_tmp41_ = g_str_hash;
#line 187 "../search-provider/search-provider.vala"
		_data_->_tmp42_ = g_str_equal;
#line 187 "../search-provider/search-provider.vala"
		_data_->_tmp43_ = g_hash_table_new_full (_data_->_tmp41_, _data_->_tmp42_, _g_free0_, _g_variant_unref0_);
#line 187 "../search-provider/search-provider.vala"
		_g_hash_table_unref0 (_data_->_tmp40_[_data_->copy_index]);
#line 187 "../search-provider/search-provider.vala"
		_data_->_tmp40_[_data_->copy_index] = _data_->_tmp43_;
#line 188 "../search-provider/search-provider.vala"
		_data_->_tmp44_ = _data_->metadata;
#line 188 "../search-provider/search-provider.vala"
		_data_->_tmp44__length1 = _data_->metadata_length1;
#line 188 "../search-provider/search-provider.vala"
		_data_->_tmp45_ = _data_->_tmp44_[_data_->copy_index];
#line 188 "../search-provider/search-provider.vala"
		_data_->_tmp46_ = g_strdup ("id");
#line 188 "../search-provider/search-provider.vala"
		_data_->_tmp47_ = _data_->equation;
#line 188 "../search-provider/search-provider.vala"
		_data_->_tmp48_ = g_strconcat (SEARCH_PROVIDER_COPY_TO_CLIPBOARD_ID, _data_->_tmp47_, NULL);
#line 188 "../search-provider/search-provider.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 188 "../search-provider/search-provider.vala"
		_data_->_tmp50_ = _variant_new4 (_data_->_tmp49_);
#line 188 "../search-provider/search-provider.vala"
		g_hash_table_insert (_data_->_tmp45_, _data_->_tmp46_, _data_->_tmp50_);
#line 188 "../search-provider/search-provider.vala"
		_g_free0 (_data_->_tmp49_);
#line 189 "../search-provider/search-provider.vala"
		_data_->_tmp51_ = _data_->metadata;
#line 189 "../search-provider/search-provider.vala"
		_data_->_tmp51__length1 = _data_->metadata_length1;
#line 189 "../search-provider/search-provider.vala"
		_data_->_tmp52_ = _data_->_tmp51_[_data_->copy_index];
#line 189 "../search-provider/search-provider.vala"
		_data_->_tmp53_ = g_strdup ("name");
#line 189 "../search-provider/search-provider.vala"
		_data_->_tmp54_ = _variant_new5 (_ ("Copy"));
#line 189 "../search-provider/search-provider.vala"
		g_hash_table_insert (_data_->_tmp52_, _data_->_tmp53_, _data_->_tmp54_);
#line 190 "../search-provider/search-provider.vala"
		_data_->_tmp55_ = _data_->metadata;
#line 190 "../search-provider/search-provider.vala"
		_data_->_tmp55__length1 = _data_->metadata_length1;
#line 190 "../search-provider/search-provider.vala"
		_data_->_tmp56_ = _data_->_tmp55_[_data_->copy_index];
#line 190 "../search-provider/search-provider.vala"
		_data_->_tmp57_ = g_strdup ("description");
#line 190 "../search-provider/search-provider.vala"
		_data_->_tmp58_ = _variant_new6 (_ ("Copy result to clipboard"));
#line 190 "../search-provider/search-provider.vala"
		g_hash_table_insert (_data_->_tmp56_, _data_->_tmp57_, _data_->_tmp58_);
#line 191 "../search-provider/search-provider.vala"
		_data_->_tmp59_ = _data_->metadata;
#line 191 "../search-provider/search-provider.vala"
		_data_->_tmp59__length1 = _data_->metadata_length1;
#line 191 "../search-provider/search-provider.vala"
		_data_->_tmp60_ = _data_->_tmp59_[_data_->copy_index];
#line 191 "../search-provider/search-provider.vala"
		_data_->_tmp61_ = g_strdup ("clipboardText");
#line 191 "../search-provider/search-provider.vala"
		_data_->_tmp62_ = _data_->_result_;
#line 191 "../search-provider/search-provider.vala"
		_data_->_tmp63_ = string_to_string (_data_->_tmp62_);
#line 191 "../search-provider/search-provider.vala"
		_data_->_tmp64_ = _variant_new7 (_data_->_tmp63_);
#line 191 "../search-provider/search-provider.vala"
		g_hash_table_insert (_data_->_tmp60_, _data_->_tmp61_, _data_->_tmp64_);
#line 3218 "search-provider.c"
	}
#line 194 "../search-provider/search-provider.vala"
	_data_->_tmp65_ = _data_->metadata;
#line 194 "../search-provider/search-provider.vala"
	_data_->_tmp65__length1 = _data_->metadata_length1;
#line 194 "../search-provider/search-provider.vala"
	_data_->result_length1 = _data_->_tmp65__length1;
#line 194 "../search-provider/search-provider.vala"
	_data_->result = _data_->_tmp65_;
#line 194 "../search-provider/search-provider.vala"
	_g_free0 (_data_->_result_);
#line 194 "../search-provider/search-provider.vala"
	_g_free0 (_data_->equation);
#line 194 "../search-provider/search-provider.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 194 "../search-provider/search-provider.vala"
	if (_data_->_state_ != 0) {
#line 194 "../search-provider/search-provider.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 194 "../search-provider/search-provider.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3240 "search-provider.c"
		}
	}
#line 194 "../search-provider/search-provider.vala"
	g_object_unref (_data_->_async_result);
#line 194 "../search-provider/search-provider.vala"
	return FALSE;
#line 3247 "search-provider.c"
}

static void
search_provider_spawn_and_display_equation (gchar** terms,
                                            gint terms_length1,
                                            GError** error)
{
	GError* _inner_error0_ = NULL;
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 201 "../search-provider/search-provider.vala"
		_tmp0_ = search_provider_terms_to_equation (terms, (gint) terms_length1);
#line 201 "../search-provider/search-provider.vala"
		_tmp1_ = _tmp0_;
#line 201 "../search-provider/search-provider.vala"
		_tmp2_ = g_shell_quote (_tmp1_);
#line 201 "../search-provider/search-provider.vala"
		_tmp3_ = _tmp2_;
#line 201 "../search-provider/search-provider.vala"
		_tmp4_ = g_strconcat ("gnome-calculator --equation ", _tmp3_, NULL);
#line 201 "../search-provider/search-provider.vala"
		_tmp5_ = _tmp4_;
#line 201 "../search-provider/search-provider.vala"
		g_spawn_command_line_async (_tmp5_, &_inner_error0_);
#line 201 "../search-provider/search-provider.vala"
		_g_free0 (_tmp5_);
#line 201 "../search-provider/search-provider.vala"
		_g_free0 (_tmp3_);
#line 201 "../search-provider/search-provider.vala"
		_g_free0 (_tmp1_);
#line 201 "../search-provider/search-provider.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../search-provider/search-provider.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 3287 "search-provider.c"
				goto __catch0_g_spawn_error;
			}
#line 201 "../search-provider/search-provider.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "../search-provider/search-provider.vala"
			g_clear_error (&_inner_error0_);
#line 201 "../search-provider/search-provider.vala"
			return;
#line 3296 "search-provider.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		GError* _tmp10_;
#line 199 "../search-provider/search-provider.vala"
		e = _inner_error0_;
#line 199 "../search-provider/search-provider.vala"
		_inner_error0_ = NULL;
#line 206 "../search-provider/search-provider.vala"
		_tmp6_ = e;
#line 206 "../search-provider/search-provider.vala"
		_tmp7_ = _tmp6_->message;
#line 206 "../search-provider/search-provider.vala"
		g_critical ("search-provider.vala:206: Failed to spawn Calculator: %s", _tmp7_);
#line 207 "../search-provider/search-provider.vala"
		_tmp8_ = e;
#line 207 "../search-provider/search-provider.vala"
		_tmp9_ = _tmp8_->message;
#line 207 "../search-provider/search-provider.vala"
		_tmp10_ = g_error_new_literal (G_DBUS_ERROR, G_DBUS_ERROR_SPAWN_FAILED, _tmp9_);
#line 207 "../search-provider/search-provider.vala"
		_inner_error0_ = _tmp10_;
#line 207 "../search-provider/search-provider.vala"
		_g_error_free0 (e);
#line 3328 "search-provider.c"
		goto __finally0;
	}
	__finally0:
#line 199 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../search-provider/search-provider.vala"
		g_propagate_error (error, _inner_error0_);
#line 199 "../search-provider/search-provider.vala"
		return;
#line 3338 "search-provider.c"
	}
}

static void
search_provider_activate_result_data_free (gpointer _data)
{
	SearchProviderActivateResultData* _data_;
	_data_ = _data;
#line 14 "../search-provider/search-provider.vala"
	_g_free0 (_data_->result_id);
#line 14 "../search-provider/search-provider.vala"
	_g_object_unref0 (_data_->self);
#line 14 "../search-provider/search-provider.vala"
	g_slice_free (SearchProviderActivateResultData, _data_);
#line 3353 "search-provider.c"
}

void
search_provider_activate_result (SearchProvider* self,
                                 const gchar* result_id,
                                 gchar** terms,
                                 gint terms_length1,
                                 guint32 timestamp,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	SearchProviderActivateResultData* _data_;
	SearchProvider* _tmp0_;
	gchar* _tmp1_;
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 14 "../search-provider/search-provider.vala"
	g_return_if_fail (result_id != NULL);
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_slice_new0 (SearchProviderActivateResultData);
#line 14 "../search-provider/search-provider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 14 "../search-provider/search-provider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, search_provider_activate_result_data_free);
#line 14 "../search-provider/search-provider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "../search-provider/search-provider.vala"
	_data_->self = _tmp0_;
#line 14 "../search-provider/search-provider.vala"
	_tmp1_ = g_strdup (result_id);
#line 14 "../search-provider/search-provider.vala"
	_g_free0 (_data_->result_id);
#line 14 "../search-provider/search-provider.vala"
	_data_->result_id = _tmp1_;
#line 14 "../search-provider/search-provider.vala"
	_data_->terms = terms;
#line 14 "../search-provider/search-provider.vala"
	_data_->terms_length1 = terms_length1;
#line 14 "../search-provider/search-provider.vala"
	_data_->timestamp = timestamp;
#line 14 "../search-provider/search-provider.vala"
	search_provider_activate_result_co (_data_);
#line 3396 "search-provider.c"
}

void
search_provider_activate_result_finish (SearchProvider* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	SearchProviderActivateResultData* _data_;
#line 14 "../search-provider/search-provider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "../search-provider/search-provider.vala"
	if (NULL == _data_) {
#line 14 "../search-provider/search-provider.vala"
		return;
#line 3411 "search-provider.c"
	}
}

static void
search_provider_activate_result_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	SearchProviderActivateResultData* _data_;
#line 217 "../search-provider/search-provider.vala"
	_data_ = _user_data_;
#line 217 "../search-provider/search-provider.vala"
	_data_->_source_object_ = source_object;
#line 217 "../search-provider/search-provider.vala"
	_data_->_res_ = _res_;
#line 217 "../search-provider/search-provider.vala"
	search_provider_activate_result_co (_data_);
#line 3429 "search-provider.c"
}

static gboolean
search_provider_activate_result_co (SearchProviderActivateResultData* _data_)
{
#line 211 "../search-provider/search-provider.vala"
	switch (_data_->_state_) {
#line 211 "../search-provider/search-provider.vala"
		case 0:
#line 3439 "search-provider.c"
		goto _state_0;
#line 211 "../search-provider/search-provider.vala"
		case 1:
#line 3443 "search-provider.c"
		goto _state_1;
		default:
#line 211 "../search-provider/search-provider.vala"
		g_assert_not_reached ();
#line 3448 "search-provider.c"
	}
	_state_0:
#line 213 "../search-provider/search-provider.vala"
	if (g_str_has_prefix (_data_->result_id, SEARCH_PROVIDER_COPY_TO_CLIPBOARD_ID)) {
#line 215 "../search-provider/search-provider.vala"
		_data_->_tmp0_ = search_provider_terms_to_equation (_data_->terms, (gint) _data_->terms_length1);
#line 215 "../search-provider/search-provider.vala"
		_data_->equation = _data_->_tmp0_;
#line 217 "../search-provider/search-provider.vala"
		_data_->_tmp2_ = _data_->equation;
#line 217 "../search-provider/search-provider.vala"
		_data_->_state_ = 1;
#line 217 "../search-provider/search-provider.vala"
		search_provider_solve_equation (_data_->self, _data_->_tmp2_, search_provider_activate_result_ready, _data_);
#line 217 "../search-provider/search-provider.vala"
		return FALSE;
#line 3465 "search-provider.c"
		_state_1:
#line 217 "../search-provider/search-provider.vala"
		_data_->_tmp1_ = search_provider_solve_equation_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 217 "../search-provider/search-provider.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 217 "../search-provider/search-provider.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 217 "../search-provider/search-provider.vala"
			_g_free0 (_data_->equation);
#line 217 "../search-provider/search-provider.vala"
			g_object_unref (_data_->_async_result);
#line 217 "../search-provider/search-provider.vala"
			return FALSE;
#line 3479 "search-provider.c"
		}
#line 217 "../search-provider/search-provider.vala"
		if (_data_->_tmp1_) {
#line 219 "../search-provider/search-provider.vala"
			_data_->_tmp3_ = _data_->self->priv->cached_equations;
#line 219 "../search-provider/search-provider.vala"
			_data_->_tmp4_ = _data_->equation;
#line 219 "../search-provider/search-provider.vala"
			_data_->_tmp5_ = g_hash_table_lookup (_data_->_tmp3_, _data_->_tmp4_);
#line 219 "../search-provider/search-provider.vala"
			_data_->_tmp6_ = g_strdup ((const gchar*) _data_->_tmp5_);
#line 219 "../search-provider/search-provider.vala"
			_data_->equation_result = _data_->_tmp6_;
#line 220 "../search-provider/search-provider.vala"
			_data_->_tmp7_ = gdk_display_get_default ();
#line 220 "../search-provider/search-provider.vala"
			_data_->_tmp8_ = gdk_display_get_clipboard (_data_->_tmp7_);
#line 220 "../search-provider/search-provider.vala"
			_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 220 "../search-provider/search-provider.vala"
			_data_->clipboard = _data_->_tmp9_;
#line 221 "../search-provider/search-provider.vala"
			_data_->_tmp10_ = _data_->clipboard;
#line 221 "../search-provider/search-provider.vala"
			_data_->_tmp11_ = _data_->equation_result;
#line 221 "../search-provider/search-provider.vala"
			gdk_clipboard_set_text (_data_->_tmp10_, _data_->_tmp11_);
#line 217 "../search-provider/search-provider.vala"
			_g_object_unref0 (_data_->clipboard);
#line 217 "../search-provider/search-provider.vala"
			_g_free0 (_data_->equation_result);
#line 3511 "search-provider.c"
		}
#line 213 "../search-provider/search-provider.vala"
		_g_free0 (_data_->equation);
#line 3515 "search-provider.c"
	} else {
#line 226 "../search-provider/search-provider.vala"
		search_provider_spawn_and_display_equation (_data_->terms, (gint) _data_->terms_length1, &_data_->_inner_error0_);
#line 226 "../search-provider/search-provider.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 226 "../search-provider/search-provider.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 226 "../search-provider/search-provider.vala"
			g_object_unref (_data_->_async_result);
#line 226 "../search-provider/search-provider.vala"
			return FALSE;
#line 3527 "search-provider.c"
		}
	}
#line 211 "../search-provider/search-provider.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 211 "../search-provider/search-provider.vala"
	if (_data_->_state_ != 0) {
#line 211 "../search-provider/search-provider.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 211 "../search-provider/search-provider.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3538 "search-provider.c"
		}
	}
#line 211 "../search-provider/search-provider.vala"
	g_object_unref (_data_->_async_result);
#line 211 "../search-provider/search-provider.vala"
	return FALSE;
#line 3545 "search-provider.c"
}

void
search_provider_launch_search (SearchProvider* self,
                               gchar** terms,
                               gint terms_length1,
                               guint32 timestamp,
                               GError** error)
{
	GError* _inner_error0_ = NULL;
#line 230 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 232 "../search-provider/search-provider.vala"
	search_provider_spawn_and_display_equation (terms, (gint) terms_length1, &_inner_error0_);
#line 232 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 232 "../search-provider/search-provider.vala"
		g_propagate_error (error, _inner_error0_);
#line 232 "../search-provider/search-provider.vala"
		return;
#line 3566 "search-provider.c"
	}
}

static void
search_provider_class_init (SearchProviderClass * klass,
                            gpointer klass_data)
{
#line 14 "../search-provider/search-provider.vala"
	search_provider_parent_class = g_type_class_peek_parent (klass);
#line 14 "../search-provider/search-provider.vala"
	g_type_class_adjust_private_offset (klass, &SearchProvider_private_offset);
#line 14 "../search-provider/search-provider.vala"
	G_OBJECT_CLASS (klass)->finalize = search_provider_finalize;
#line 3580 "search-provider.c"
}

static void
search_provider_instance_init (SearchProvider * self,
                               gpointer klass)
{
#line 14 "../search-provider/search-provider.vala"
	self->priv = search_provider_get_instance_private (self);
#line 3589 "search-provider.c"
}

static void
search_provider_finalize (GObject * obj)
{
	SearchProvider * self;
#line 14 "../search-provider/search-provider.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_PROVIDER, SearchProvider);
#line 35 "../search-provider/search-provider.vala"
	search_provider_cancel (self);
#line 17 "../search-provider/search-provider.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 20 "../search-provider/search-provider.vala"
	(self->priv->queued_equations == NULL) ? NULL : (self->priv->queued_equations = (_g_queue_free__g_free0_ (self->priv->queued_equations), NULL));
#line 21 "../search-provider/search-provider.vala"
	_g_hash_table_unref0 (self->priv->cached_equations);
#line 14 "../search-provider/search-provider.vala"
	G_OBJECT_CLASS (search_provider_parent_class)->finalize (obj);
#line 3608 "search-provider.c"
}

static GType
search_provider_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchProviderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_provider_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchProvider), 0, (GInstanceInitFunc) search_provider_instance_init, NULL };
	GType search_provider_type_id;
	search_provider_type_id = g_type_register_static (G_TYPE_OBJECT, "SearchProvider", &g_define_type_info, 0);
	g_type_set_qdata (search_provider_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) search_provider_register_object);
	SearchProvider_private_offset = g_type_add_instance_private (search_provider_type_id, sizeof (SearchProviderPrivate));
	return search_provider_type_id;
}

GType
search_provider_get_type (void)
{
	static volatile gsize search_provider_type_id__once = 0;
	if (g_once_init_enter (&search_provider_type_id__once)) {
		GType search_provider_type_id;
		search_provider_type_id = search_provider_get_type_once ();
		g_once_init_leave (&search_provider_type_id__once, search_provider_type_id);
	}
	return search_provider_type_id__once;
}

static void
_dbus_search_provider_get_initial_result_set (SearchProvider* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	SearchProviderGetInitialResultSetReadyData* _ready_data;
	GVariant* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length;
	gint _tmp1__size;
	gint _tmp1__length1;
	GVariantIter _tmp2_;
	GVariant* _tmp3_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (SearchProviderGetInitialResultSetReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp1_ = g_new (gchar*, 5);
	_tmp1__length = 0;
	_tmp1__size = 4;
	_tmp1__length1 = 0;
	g_variant_iter_init (&_tmp2_, _tmp0_);
	for (; (_tmp3_ = g_variant_iter_next_value (&_tmp2_)) != NULL; _tmp1__length1++) {
		if (_tmp1__size == _tmp1__length) {
			_tmp1__size = 2 * _tmp1__size;
			_tmp1_ = g_renew (gchar*, _tmp1_, _tmp1__size + 1);
		}
		_tmp1_[_tmp1__length++] = g_variant_dup_string (_tmp3_, NULL);
		g_variant_unref (_tmp3_);
	}
	_ready_data->terms_length1 = _tmp1__length1;
	_tmp1_[_tmp1__length] = NULL;
	_ready_data->terms = _tmp1_;
	g_variant_unref (_tmp0_);
	search_provider_get_initial_result_set (self, _ready_data->terms, _ready_data->terms_length1, (GAsyncReadyCallback) _dbus_search_provider_get_initial_result_set_ready, _ready_data);
	_error:
	;
}

static void
_dbus_search_provider_get_initial_result_set_ready (GObject * source_object,
                                                    GAsyncResult * _res_,
                                                    gpointer _user_data_)
{
	SearchProviderGetInitialResultSetReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	gint result_length1 = 0;
	gchar** _tmp4_;
	GVariantBuilder _tmp5_;
	gint _tmp6_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	result = search_provider_get_initial_result_set_finish ((SearchProvider*) source_object, _res_, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp4_ = result;
	g_variant_builder_init (&_tmp5_, G_VARIANT_TYPE ("as"));
	for (_tmp6_ = 0; _tmp6_ < result_length1; _tmp6_++) {
		g_variant_builder_add_value (&_tmp5_, g_variant_new_string (*_tmp4_));
		_tmp4_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp5_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_ready_data->terms = (_vala_array_free (_ready_data->terms, _ready_data->terms_length1, (GDestroyNotify) g_free), NULL);
	g_slice_free (SearchProviderGetInitialResultSetReadyData, _ready_data);
}

static void
_dbus_search_provider_get_subsearch_result_set (SearchProvider* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	SearchProviderGetSubsearchResultSetReadyData* _ready_data;
	GVariant* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length;
	gint _tmp8__size;
	gint _tmp8__length1;
	GVariantIter _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length;
	gint _tmp12__size;
	gint _tmp12__length1;
	GVariantIter _tmp13_;
	GVariant* _tmp14_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (SearchProviderGetSubsearchResultSetReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp8_ = g_new (gchar*, 5);
	_tmp8__length = 0;
	_tmp8__size = 4;
	_tmp8__length1 = 0;
	g_variant_iter_init (&_tmp9_, _tmp7_);
	for (; (_tmp10_ = g_variant_iter_next_value (&_tmp9_)) != NULL; _tmp8__length1++) {
		if (_tmp8__size == _tmp8__length) {
			_tmp8__size = 2 * _tmp8__size;
			_tmp8_ = g_renew (gchar*, _tmp8_, _tmp8__size + 1);
		}
		_tmp8_[_tmp8__length++] = g_variant_dup_string (_tmp10_, NULL);
		g_variant_unref (_tmp10_);
	}
	_ready_data->previous_results_length1 = _tmp8__length1;
	_tmp8_[_tmp8__length] = NULL;
	_ready_data->previous_results = _tmp8_;
	g_variant_unref (_tmp7_);
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp12_ = g_new (gchar*, 5);
	_tmp12__length = 0;
	_tmp12__size = 4;
	_tmp12__length1 = 0;
	g_variant_iter_init (&_tmp13_, _tmp11_);
	for (; (_tmp14_ = g_variant_iter_next_value (&_tmp13_)) != NULL; _tmp12__length1++) {
		if (_tmp12__size == _tmp12__length) {
			_tmp12__size = 2 * _tmp12__size;
			_tmp12_ = g_renew (gchar*, _tmp12_, _tmp12__size + 1);
		}
		_tmp12_[_tmp12__length++] = g_variant_dup_string (_tmp14_, NULL);
		g_variant_unref (_tmp14_);
	}
	_ready_data->terms_length1 = _tmp12__length1;
	_tmp12_[_tmp12__length] = NULL;
	_ready_data->terms = _tmp12_;
	g_variant_unref (_tmp11_);
	search_provider_get_subsearch_result_set (self, _ready_data->previous_results, _ready_data->previous_results_length1, _ready_data->terms, _ready_data->terms_length1, (GAsyncReadyCallback) _dbus_search_provider_get_subsearch_result_set_ready, _ready_data);
	_error:
	;
}

static void
_dbus_search_provider_get_subsearch_result_set_ready (GObject * source_object,
                                                      GAsyncResult * _res_,
                                                      gpointer _user_data_)
{
	SearchProviderGetSubsearchResultSetReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	gint result_length1 = 0;
	gchar** _tmp15_;
	GVariantBuilder _tmp16_;
	gint _tmp17_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	result = search_provider_get_subsearch_result_set_finish ((SearchProvider*) source_object, _res_, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp15_ = result;
	g_variant_builder_init (&_tmp16_, G_VARIANT_TYPE ("as"));
	for (_tmp17_ = 0; _tmp17_ < result_length1; _tmp17_++) {
		g_variant_builder_add_value (&_tmp16_, g_variant_new_string (*_tmp15_));
		_tmp15_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp16_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_ready_data->previous_results = (_vala_array_free (_ready_data->previous_results, _ready_data->previous_results_length1, (GDestroyNotify) g_free), NULL);
	_ready_data->terms = (_vala_array_free (_ready_data->terms, _ready_data->terms_length1, (GDestroyNotify) g_free), NULL);
	g_slice_free (SearchProviderGetSubsearchResultSetReadyData, _ready_data);
}

static void
_dbus_search_provider_get_result_metas (SearchProvider* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	SearchProviderGetResultMetasReadyData* _ready_data;
	GVariant* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length;
	gint _tmp19__size;
	gint _tmp19__length1;
	GVariantIter _tmp20_;
	GVariant* _tmp21_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (SearchProviderGetResultMetasReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp19_ = g_new (gchar*, 5);
	_tmp19__length = 0;
	_tmp19__size = 4;
	_tmp19__length1 = 0;
	g_variant_iter_init (&_tmp20_, _tmp18_);
	for (; (_tmp21_ = g_variant_iter_next_value (&_tmp20_)) != NULL; _tmp19__length1++) {
		if (_tmp19__size == _tmp19__length) {
			_tmp19__size = 2 * _tmp19__size;
			_tmp19_ = g_renew (gchar*, _tmp19_, _tmp19__size + 1);
		}
		_tmp19_[_tmp19__length++] = g_variant_dup_string (_tmp21_, NULL);
		g_variant_unref (_tmp21_);
	}
	_ready_data->results_length1 = _tmp19__length1;
	_tmp19_[_tmp19__length] = NULL;
	_ready_data->results = _tmp19_;
	g_variant_unref (_tmp18_);
	search_provider_get_result_metas (self, _ready_data->results, _ready_data->results_length1, g_dbus_method_invocation_get_sender (invocation), (GAsyncReadyCallback) _dbus_search_provider_get_result_metas_ready, _ready_data);
	_error:
	;
}

static void
_dbus_search_provider_get_result_metas_ready (GObject * source_object,
                                              GAsyncResult * _res_,
                                              gpointer _user_data_)
{
	SearchProviderGetResultMetasReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable** result;
	gint result_length1 = 0;
	GHashTable** _tmp22_;
	GVariantBuilder _tmp23_;
	gint _tmp24_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	result = search_provider_get_result_metas_finish ((SearchProvider*) source_object, _res_, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp22_ = result;
	g_variant_builder_init (&_tmp23_, G_VARIANT_TYPE ("aa{sv}"));
	for (_tmp24_ = 0; _tmp24_ < result_length1; _tmp24_++) {
		GVariantBuilder _tmp25_;
		GHashTableIter _tmp26_;
		gpointer _tmp27_;
		gpointer _tmp28_;
		g_hash_table_iter_init (&_tmp26_, *_tmp22_);
		g_variant_builder_init (&_tmp25_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp26_, &_tmp27_, &_tmp28_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp27_;
			_value = (GVariant*) _tmp28_;
			g_variant_builder_add (&_tmp25_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp23_, g_variant_builder_end (&_tmp25_));
		_tmp22_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp23_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_hash_table_unref), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_ready_data->results = (_vala_array_free (_ready_data->results, _ready_data->results_length1, (GDestroyNotify) g_free), NULL);
	g_slice_free (SearchProviderGetResultMetasReadyData, _ready_data);
}

static void
_dbus_search_provider_activate_result (SearchProvider* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	SearchProviderActivateResultReadyData* _ready_data;
	GVariant* _tmp29_;
	GVariant* _tmp30_;
	gchar** _tmp31_;
	gint _tmp31__length;
	gint _tmp31__size;
	gint _tmp31__length1;
	GVariantIter _tmp32_;
	GVariant* _tmp33_;
	GVariant* _tmp34_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (SearchProviderActivateResultReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp29_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->result_id = g_variant_dup_string (_tmp29_, NULL);
	g_variant_unref (_tmp29_);
	_tmp30_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp31_ = g_new (gchar*, 5);
	_tmp31__length = 0;
	_tmp31__size = 4;
	_tmp31__length1 = 0;
	g_variant_iter_init (&_tmp32_, _tmp30_);
	for (; (_tmp33_ = g_variant_iter_next_value (&_tmp32_)) != NULL; _tmp31__length1++) {
		if (_tmp31__size == _tmp31__length) {
			_tmp31__size = 2 * _tmp31__size;
			_tmp31_ = g_renew (gchar*, _tmp31_, _tmp31__size + 1);
		}
		_tmp31_[_tmp31__length++] = g_variant_dup_string (_tmp33_, NULL);
		g_variant_unref (_tmp33_);
	}
	_ready_data->terms_length1 = _tmp31__length1;
	_tmp31_[_tmp31__length] = NULL;
	_ready_data->terms = _tmp31_;
	g_variant_unref (_tmp30_);
	_tmp34_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->timestamp = g_variant_get_uint32 (_tmp34_);
	g_variant_unref (_tmp34_);
	search_provider_activate_result (self, _ready_data->result_id, _ready_data->terms, _ready_data->terms_length1, _ready_data->timestamp, (GAsyncReadyCallback) _dbus_search_provider_activate_result_ready, _ready_data);
	_error:
	;
}

static void
_dbus_search_provider_activate_result_ready (GObject * source_object,
                                             GAsyncResult * _res_,
                                             gpointer _user_data_)
{
	SearchProviderActivateResultReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	search_provider_activate_result_finish ((SearchProvider*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (_ready_data->result_id);
	_ready_data->terms = (_vala_array_free (_ready_data->terms, _ready_data->terms_length1, (GDestroyNotify) g_free), NULL);
	g_slice_free (SearchProviderActivateResultReadyData, _ready_data);
}

static void
_dbus_search_provider_launch_search (SearchProvider* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** terms = NULL;
	gint terms_length1 = 0;
	GVariant* _tmp35_;
	gchar** _tmp36_;
	gint _tmp36__length;
	gint _tmp36__size;
	gint _tmp36__length1;
	GVariantIter _tmp37_;
	GVariant* _tmp38_;
	guint32 timestamp = 0U;
	GVariant* _tmp39_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp35_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp36_ = g_new (gchar*, 5);
	_tmp36__length = 0;
	_tmp36__size = 4;
	_tmp36__length1 = 0;
	g_variant_iter_init (&_tmp37_, _tmp35_);
	for (; (_tmp38_ = g_variant_iter_next_value (&_tmp37_)) != NULL; _tmp36__length1++) {
		if (_tmp36__size == _tmp36__length) {
			_tmp36__size = 2 * _tmp36__size;
			_tmp36_ = g_renew (gchar*, _tmp36_, _tmp36__size + 1);
		}
		_tmp36_[_tmp36__length++] = g_variant_dup_string (_tmp38_, NULL);
		g_variant_unref (_tmp38_);
	}
	terms_length1 = _tmp36__length1;
	_tmp36_[_tmp36__length] = NULL;
	terms = _tmp36_;
	g_variant_unref (_tmp35_);
	_tmp39_ = g_variant_iter_next_value (&_arguments_iter);
	timestamp = g_variant_get_uint32 (_tmp39_);
	g_variant_unref (_tmp39_);
	search_provider_launch_search (self, terms, terms_length1, timestamp, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	terms = (_vala_array_free (terms, terms_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
search_provider_dbus_interface_method_call (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* method_name,
                                            GVariant* parameters,
                                            GDBusMethodInvocation* invocation,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetInitialResultSet") == 0) {
		_dbus_search_provider_get_initial_result_set (object, parameters, invocation);
	} else if (strcmp (method_name, "GetSubsearchResultSet") == 0) {
		_dbus_search_provider_get_subsearch_result_set (object, parameters, invocation);
	} else if (strcmp (method_name, "GetResultMetas") == 0) {
		_dbus_search_provider_get_result_metas (object, parameters, invocation);
	} else if (strcmp (method_name, "ActivateResult") == 0) {
		_dbus_search_provider_activate_result (object, parameters, invocation);
	} else if (strcmp (method_name, "LaunchSearch") == 0) {
		_dbus_search_provider_launch_search (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
search_provider_dbus_interface_get_property (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* property_name,
                                             GError** error,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
search_provider_dbus_interface_set_property (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* property_name,
                                             GVariant* value,
                                             GError** error,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
search_provider_register_object (gpointer object,
                                 GDBusConnection* connection,
                                 const gchar* path,
                                 GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_search_provider_dbus_interface_info), &_search_provider_dbus_interface_vtable, data, _search_provider_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_search_provider_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

SearchProviderApp*
search_provider_app_construct (GType object_type)
{
	SearchProviderApp * self = NULL;
#line 241 "../search-provider/search-provider.vala"
	self = (SearchProviderApp*) g_object_new (object_type, "application-id", "org.gnome.Calculator.SearchProvider", "flags", G_APPLICATION_IS_SERVICE, "inactivity-timeout", 20000, NULL);
#line 239 "../search-provider/search-provider.vala"
	return self;
#line 4161 "search-provider.c"
}

SearchProviderApp*
search_provider_app_new (void)
{
#line 239 "../search-provider/search-provider.vala"
	return search_provider_app_construct (TYPE_SEARCH_PROVIDER_APP);
#line 4169 "search-provider.c"
}

void
search_provider_app_renew_inactivity_timeout (SearchProviderApp* self)
{
#line 246 "../search-provider/search-provider.vala"
	g_return_if_fail (self != NULL);
#line 248 "../search-provider/search-provider.vala"
	g_application_hold ((GApplication*) self);
#line 249 "../search-provider/search-provider.vala"
	g_application_release ((GApplication*) self);
#line 4181 "search-provider.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 252 "../search-provider/search-provider.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 252 "../search-provider/search-provider.vala"
	return _data2_;
#line 4191 "search-provider.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 252 "../search-provider/search-provider.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 4201 "search-provider.c"
		SearchProviderApp* self;
#line 252 "../search-provider/search-provider.vala"
		self = _data2_->self;
#line 252 "../search-provider/search-provider.vala"
		_g_object_unref0 (_data2_->search_provider);
#line 252 "../search-provider/search-provider.vala"
		_g_object_unref0 (self);
#line 252 "../search-provider/search-provider.vala"
		g_slice_free (Block2Data, _data2_);
#line 4211 "search-provider.c"
	}
}

static void
__lambda4_ (Block2Data* _data2_)
{
	SearchProviderApp* self;
#line 266 "../search-provider/search-provider.vala"
	self = _data2_->self;
#line 267 "../search-provider/search-provider.vala"
	search_provider_cancel (_data2_->search_provider);
#line 4223 "search-provider.c"
}

static void
___lambda4__g_application_shutdown (GApplication* _sender,
                                    gpointer self)
{
#line 266 "../search-provider/search-provider.vala"
	__lambda4_ (self);
#line 4232 "search-provider.c"
}

static gboolean
search_provider_app_real_dbus_register (GApplication* base,
                                        GDBusConnection* connection,
                                        const gchar* object_path,
                                        GError** error)
{
	SearchProviderApp * self;
	Block2Data* _data2_;
	SearchProvider* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 252 "../search-provider/search-provider.vala"
	self = (SearchProviderApp*) base;
#line 252 "../search-provider/search-provider.vala"
	g_return_val_if_fail (connection != NULL, FALSE);
#line 252 "../search-provider/search-provider.vala"
	g_return_val_if_fail (object_path != NULL, FALSE);
#line 252 "../search-provider/search-provider.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 252 "../search-provider/search-provider.vala"
	_data2_->_ref_count_ = 1;
#line 252 "../search-provider/search-provider.vala"
	_data2_->self = g_object_ref (self);
#line 254 "../search-provider/search-provider.vala"
	_tmp0_ = search_provider_new (self);
#line 254 "../search-provider/search-provider.vala"
	_data2_->search_provider = _tmp0_;
#line 4262 "search-provider.c"
	{
#line 258 "../search-provider/search-provider.vala"
		search_provider_register_object (_data2_->search_provider, connection, object_path, &_inner_error0_);
#line 258 "../search-provider/search-provider.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4268 "search-provider.c"
			gboolean _tmp1_ = FALSE;
#line 258 "../search-provider/search-provider.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 4272 "search-provider.c"
				goto __catch0_g_io_error;
			}
#line 258 "../search-provider/search-provider.vala"
			block2_data_unref (_data2_);
#line 258 "../search-provider/search-provider.vala"
			_data2_ = NULL;
#line 258 "../search-provider/search-provider.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "../search-provider/search-provider.vala"
			g_clear_error (&_inner_error0_);
#line 258 "../search-provider/search-provider.vala"
			return _tmp1_;
#line 4285 "search-provider.c"
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 256 "../search-provider/search-provider.vala"
		_error_ = _inner_error0_;
#line 256 "../search-provider/search-provider.vala"
		_inner_error0_ = NULL;
#line 262 "../search-provider/search-provider.vala"
		_tmp2_ = stderr;
#line 262 "../search-provider/search-provider.vala"
		_tmp3_ = _error_;
#line 262 "../search-provider/search-provider.vala"
		_tmp4_ = _tmp3_->message;
#line 262 "../search-provider/search-provider.vala"
		fprintf (_tmp2_, "Could not register service: %s\n", _tmp4_);
#line 263 "../search-provider/search-provider.vala"
		g_application_quit ((GApplication*) self);
#line 256 "../search-provider/search-provider.vala"
		_g_error_free0 (_error_);
#line 4311 "search-provider.c"
	}
	__finally0:
#line 256 "../search-provider/search-provider.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4316 "search-provider.c"
		gboolean _tmp5_ = FALSE;
#line 256 "../search-provider/search-provider.vala"
		block2_data_unref (_data2_);
#line 256 "../search-provider/search-provider.vala"
		_data2_ = NULL;
#line 256 "../search-provider/search-provider.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 256 "../search-provider/search-provider.vala"
		g_clear_error (&_inner_error0_);
#line 256 "../search-provider/search-provider.vala"
		return _tmp5_;
#line 4328 "search-provider.c"
	}
#line 266 "../search-provider/search-provider.vala"
	g_signal_connect_data ((GApplication*) self, "shutdown", (GCallback) ___lambda4__g_application_shutdown, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 270 "../search-provider/search-provider.vala"
	result = TRUE;
#line 270 "../search-provider/search-provider.vala"
	block2_data_unref (_data2_);
#line 270 "../search-provider/search-provider.vala"
	_data2_ = NULL;
#line 270 "../search-provider/search-provider.vala"
	return result;
#line 4340 "search-provider.c"
}

static void
search_provider_app_class_init (SearchProviderAppClass * klass,
                                gpointer klass_data)
{
#line 237 "../search-provider/search-provider.vala"
	search_provider_app_parent_class = g_type_class_peek_parent (klass);
#line 237 "../search-provider/search-provider.vala"
	((GApplicationClass *) klass)->dbus_register = (gboolean (*) (GApplication*, GDBusConnection*, const gchar*, GError**)) search_provider_app_real_dbus_register;
#line 4351 "search-provider.c"
}

static void
search_provider_app_instance_init (SearchProviderApp * self,
                                   gpointer klass)
{
}

static GType
search_provider_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchProviderAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_provider_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchProviderApp), 0, (GInstanceInitFunc) search_provider_app_instance_init, NULL };
	GType search_provider_app_type_id;
	search_provider_app_type_id = g_type_register_static (g_application_get_type (), "SearchProviderApp", &g_define_type_info, 0);
	return search_provider_app_type_id;
}

GType
search_provider_app_get_type (void)
{
	static volatile gsize search_provider_app_type_id__once = 0;
	if (g_once_init_enter (&search_provider_app_type_id__once)) {
		GType search_provider_app_type_id;
		search_provider_app_type_id = search_provider_app_get_type_once ();
		g_once_init_leave (&search_provider_app_type_id__once, search_provider_app_type_id);
	}
	return search_provider_app_type_id__once;
}

static gint
_vala_main (gchar** args,
            gint args_length1)
{
	SearchProviderApp* _tmp0_;
	SearchProviderApp* _tmp1_;
	gint _tmp2_;
	gint result;
#line 276 "../search-provider/search-provider.vala"
	gtk_init ();
#line 277 "../search-provider/search-provider.vala"
	setlocale (LC_ALL, "");
#line 279 "../search-provider/search-provider.vala"
	_tmp0_ = search_provider_app_new ();
#line 279 "../search-provider/search-provider.vala"
	_tmp1_ = _tmp0_;
#line 279 "../search-provider/search-provider.vala"
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) 0, NULL);
#line 279 "../search-provider/search-provider.vala"
	_g_object_unref0 (_tmp1_);
#line 279 "../search-provider/search-provider.vala"
	result = _tmp2_;
#line 279 "../search-provider/search-provider.vala"
	return result;
#line 4405 "search-provider.c"
}

int
main (int argc,
      char ** argv)
{
#line 274 "../search-provider/search-provider.vala"
	return _vala_main (argv, argc);
#line 4414 "search-provider.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

